"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getParentProcessApi = exports.provideApiForChildProcess = exports.electronDevChildProcessEnv = exports.electronDevParentProcessEnv = exports.DEV_SERVER_API_ID_TOKEN = void 0;
const express_1 = __importDefault(require("express"));
const engine_core_1 = require("@wixc3/engine-core");
const engine_core_node_1 = require("@wixc3/engine-core-node");
exports.DEV_SERVER_API_ID_TOKEN = {
    id: 'dev-server-api',
};
exports.electronDevParentProcessEnv = { id: 'electron-dev-parent-process' };
exports.electronDevChildProcessEnv = { id: 'electron-dev-child-process' };
function provideApiForChildProcess(electronApp, router) {
    const host = new engine_core_node_1.IPCHost(electronApp);
    const com = new engine_core_1.Communication(new engine_core_1.BaseHost(), exports.electronDevParentProcessEnv.id);
    com.registerEnv(exports.electronDevChildProcessEnv.id, host);
    com.registerMessageHandler(host);
    com.registerAPI(exports.DEV_SERVER_API_ID_TOKEN, {
        registerExternalRoute: (basePath, route) => {
            router.use(route, express_1.default.static(basePath));
        },
    });
}
exports.provideApiForChildProcess = provideApiForChildProcess;
function getParentProcessApi() {
    const host = new engine_core_node_1.IPCHost(process);
    const com = new engine_core_1.Communication(new engine_core_1.BaseHost(), exports.electronDevChildProcessEnv.id);
    com.registerEnv(exports.electronDevParentProcessEnv.id, host);
    com.registerMessageHandler(host);
    const api = com.apiProxy(exports.electronDevParentProcessEnv, exports.DEV_SERVER_API_ID_TOKEN);
    return api;
}
exports.getParentProcessApi = getParentProcessApi;
//# sourceMappingURL=ipc-communication.js.map