"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createBaseNodeFs = exports.createNodeFs = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const process_1 = require("process");
const util_1 = require("util");
const utils_1 = require("@file-services/utils");
const watch_service_js_1 = require("./watch-service.js");
const caseSensitive = !fs_1.default.existsSync(__filename.toUpperCase());
const fsPromisesExists = (0, util_1.promisify)(fs_1.default.exists);
function createNodeFs(options) {
    return (0, utils_1.createFileSystem)(createBaseNodeFs(options));
}
exports.createNodeFs = createNodeFs;
function createBaseNodeFs(options) {
    return {
        ...path_1.default,
        chdir: process_1.chdir,
        cwd: process_1.cwd,
        watchService: new watch_service_js_1.NodeWatchService(options && options.watchOptions),
        caseSensitive,
        ...fs_1.default,
        promises: {
            ...fs_1.default.promises,
            exists: fsPromisesExists,
        },
    };
}
exports.createBaseNodeFs = createBaseNodeFs;
//# sourceMappingURL=node-fs.js.map