"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.namespaceToStNamespace = void 0;
const index_internal_1 = require("@stylable/core/dist/index-internal");
const namespaceToStNamespace = ({ ast }) => {
    let changed = false;
    let foundStNamespace = false;
    const nodesToMod = [];
    ast.walkAtRules((atRule) => {
        if (atRule.name === 'namespace') {
            const namespace = index_internal_1.STNamespace.parseNamespace(atRule);
            if (namespace) {
                nodesToMod.push(atRule);
            }
        }
        else if (atRule.name === 'st-namespace') {
            foundStNamespace = true;
        }
    });
    if (!foundStNamespace) {
        for (const atRule of nodesToMod) {
            atRule.name = 'st-namespace';
            changed = true;
        }
    }
    return {
        changed,
    };
};
exports.namespaceToStNamespace = namespaceToStNamespace;
//# sourceMappingURL=namespace-to-st-namespace.js.map