"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRuleScopeSelector = void 0;
const deprecation_1 = require("../helpers/deprecation");
const postcss_1 = require("postcss");
/**
 * mark extended fields as deprecated.
 * `valueOnThis` is used because postcss.clone copies own properties.
 */
(0, deprecation_1.setFieldForDeprecation)(postcss_1.Rule.prototype, `stScopeSelector`, {
    objectType: `SRule`,
    valueOnThis: true,
    pleaseUse: `getRuleScopeSelector(rule)`,
});
// ToDo: remove when st-scope moves to transformer
function getRuleScopeSelector(rule) {
    return (0, deprecation_1.ignoreDeprecationWarn)(() => rule.stScopeSelector);
}
exports.getRuleScopeSelector = getRuleScopeSelector;
//# sourceMappingURL=postcss-ast-extension.js.map