export class CacheStyleNodeRenderer {
    constructor(options) {
        this.options = options;
        this.create = (stylesheet, key) => {
            const node = this.options.createElement('style');
            node.textContent = stylesheet.$css || '';
            node.setAttribute(this.options.attrKey, key);
            node.setAttribute('st-depth', stylesheet.$depth + '');
            return node;
        };
        this.hasKey = (node) => node.hasAttribute(this.options.attrKey);
        this.update = (stylesheet, node) => {
            if (node.textContent !== stylesheet.$css) {
                node.textContent = stylesheet.$css || '';
            }
            return node;
        };
        this.renderKey = (stylesheet) => stylesheet.$id;
    }
}
//# sourceMappingURL=cached-node-renderer.js.map