"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.chain = void 0;
const iterables_1 = require("./iterables");
const objects_1 = require("./objects");
function chain(value) {
    const iterable = (value === undefined
        ? []
        : value === null
            ? [null]
            : typeof value === 'object' && Symbol.iterator in value
                ? value
                : [value]);
    return iterable === value ? chainIter(iterable) : chainElement(value);
}
exports.chain = chain;
function chainIter(iterable) {
    const toIter = { skip: iterables_1.skip, map: iterables_1.map, flatMap: iterables_1.flatMap, filter: iterables_1.filter, concat: iterables_1.concat, flat: iterables_1.flat, unique: iterables_1.unique, sort: iterables_1.sort };
    const toElm = { join: iterables_1.join, last: iterables_1.last, first: iterables_1.first, isEmpty: iterables_1.isEmpty, size: iterables_1.size, at: iterables_1.at, next: iterables_1.next, prev: iterables_1.prev, find: iterables_1.find, some: iterables_1.some, includes: iterables_1.includes, every: iterables_1.every, reduce: iterables_1.reduce };
    const boundToIter = (0, objects_1.mapValues)(toIter, (v) => (...args) => chainIter(v(iterable, ...args)));
    const boundToElm = (0, objects_1.mapValues)(toElm, (v) => (...args) => chainElement(v(iterable, ...args)));
    return {
        value: iterable,
        iterable,
        ...boundToIter,
        ...boundToElm,
        forEach: (mapping) => {
            (0, iterables_1.forEach)(iterable, mapping);
            return chainIter(iterable);
        },
    };
}
function chainElement(value) {
    const iterable = (value === undefined ? [] : [value]);
    return {
        ...chainIter(iterable),
        value,
    };
}
//# sourceMappingURL=chain.js.map