"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.seededRandomInt = exports.createRandomIntWithSeed = exports.mulberry32 = exports.normToRage = exports.clamp = void 0;
function clamp(value, min, max) {
    if (value < min) {
        return min;
    }
    if (value > max) {
        return max;
    }
    return value;
}
exports.clamp = clamp;
function normToRage(normal, min, max) {
    return normal * (max - min) + min;
}
exports.normToRage = normToRage;
function mulberry32(a = 0) {
    return function () {
        let t = (a += 0x6d2b79f5);
        t = Math.imul(t ^ (t >>> 15), t | 1);
        t ^= t + Math.imul(t ^ (t >>> 7), t | 61);
        return ((t ^ (t >>> 14)) >>> 0) / 4294967296;
    };
}
exports.mulberry32 = mulberry32;
function createRandomIntWithSeed(seed) {
    const nextRandomFloat = mulberry32(seed);
    const randInt = (min, max) => Math.floor(normToRage(nextRandomFloat(), min, max));
    return randInt;
}
exports.createRandomIntWithSeed = createRandomIntWithSeed;
exports.seededRandomInt = createRandomIntWithSeed(1);
//# sourceMappingURL=numbers.js.map