"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getOs = exports.isElectronRendererProcess = exports.isWindows = exports.isMac = void 0;
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment, @typescript-eslint/no-unsafe-member-access
const _process = globalThis['process'];
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment, @typescript-eslint/no-unsafe-member-access
const _navigator = globalThis['navigator'];
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment, @typescript-eslint/no-unsafe-member-access
const platform = _process === null || _process === void 0 ? void 0 : _process.platform;
exports.isMac = platform ? platform === 'darwin' : _navigator === null || _navigator === void 0 ? void 0 : _navigator.platform.includes('Mac');
exports.isWindows = platform ? platform === 'win32' : _navigator === null || _navigator === void 0 ? void 0 : _navigator.platform.includes('Win32');
exports.isElectronRendererProcess = typeof _process === 'object' && (_process === null || _process === void 0 ? void 0 : _process.type) === 'renderer';
const getOs = () => {
    if (platform) {
        return platform;
    }
    /** Normilizes return value to nodejs output */
    if (_navigator === null || _navigator === void 0 ? void 0 : _navigator.platform.includes('Mac')) {
        return 'darwin';
    }
    if (_navigator === null || _navigator === void 0 ? void 0 : _navigator.platform.includes('Win')) {
        return 'win32';
    }
    if (_navigator === null || _navigator === void 0 ? void 0 : _navigator.platform.includes('Linux')) {
        return 'linux';
    }
    return _navigator === null || _navigator === void 0 ? void 0 : _navigator.platform;
};
exports.getOs = getOs;
//# sourceMappingURL=platform.js.map