import { isMap } from './types';
export function has(obj, key) {
    return (!!obj &&
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        (typeof obj.has === 'function' ? obj.has(key) : key in obj));
}
export function get(obj, key) {
    if (obj) {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access, @typescript-eslint/no-unsafe-return
        return typeof obj.get === 'function'
            ? obj.get(key)
            : // @ts-expect-error definitely not a map or nullish
                obj[key];
    }
    return;
}
export function getValue(map, key, errorMessage) {
    // @ts-expect-error hmm
    if (has(map, key)) {
        // @ts-expect-error hmmm
        return get(map, key);
    }
    throw new Error(errorMessage || `Missing map`);
}
export function keys(obj) {
    return isMap(obj) ? obj.keys() : Object.keys(obj);
}
export function values(obj) {
    return isMap(obj) ? obj.values() : Object.values(obj);
}
//# sourceMappingURL=maps.js.map