"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.flattenTree = exports.returnsTrue = void 0;
const returnsTrue = () => true;
exports.returnsTrue = returnsTrue;
function flattenTree(root, children, predicate = exports.returnsTrue) {
    const results = new Set();
    const visited = new Set();
    const toProcess = [root];
    while (toProcess.length) {
        const node = toProcess.shift();
        if (visited.has(node)) {
            continue;
        }
        visited.add(node);
        if (predicate(node)) {
            results.add(node);
        }
        toProcess.push(...children(node));
    }
    return results;
}
exports.flattenTree = flattenTree;
//# sourceMappingURL=flatten-tree.js.map