(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("socket.io-client"));
	else if(typeof define === 'function' && define.amd)
		define(["socket.io-client"], factory);
	else if(typeof exports === 'object')
		exports["EngineCore"] = factory(require("socket.io-client"));
	else
		root["EngineCore"] = factory(root["io"]);
})(globalThis, (__WEBPACK_EXTERNAL_MODULE_socket_io_client__) => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./packages/core/src/com/communication.ts":
/*!************************************************!*\
  !*** ./packages/core/src/com/communication.ts ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Communication": () => (/* binding */ Communication),
/* harmony export */   "declareComEmitter": () => (/* binding */ declareComEmitter)
/* harmony export */ });
/* harmony import */ var _errors__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./errors */ "./packages/core/src/com/errors.ts");
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./helpers */ "./packages/core/src/com/helpers.ts");
/* harmony import */ var _types__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./types */ "./packages/core/src/com/types.ts");
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../symbols */ "./packages/core/src/symbols.ts");
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../helpers */ "./packages/core/src/helpers/index.ts");
/* harmony import */ var _wixc3_patterns__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @wixc3/patterns */ "./node_modules/@wixc3/patterns/dist/esm/set-multi-map.js");
/* harmony import */ var _hosts_base_host__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./hosts/base-host */ "./packages/core/src/com/hosts/base-host.ts");
/* harmony import */ var _hosts_ws_client_host__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./hosts/ws-client-host */ "./packages/core/src/com/hosts/ws-client-host.ts");
/* harmony import */ var _message_types__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./message-types */ "./packages/core/src/com/message-types.ts");
/* harmony import */ var promise_assist__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! promise-assist */ "./node_modules/promise-assist/esm/deferred.js");










/**
 * Manages all API registrations and message forwarding
 * in each execution context.
 */
class Communication {
    constructor(host, id, topology = {}, resolvedContexts = {}, isServer = false, options) {
        this.topology = topology;
        this.resolvedContexts = resolvedContexts;
        this.isServer = isServer;
        this.idsCounter = new _helpers__WEBPACK_IMPORTED_MODULE_1__.MultiCounter();
        this.disposing = false;
        this.callbackTimeout = 60000 * 5; // 5 minutes
        this.slowThreshold = 5000; // 5 seconds
        this.callbacks = {};
        this.pendingEnvs = new _wixc3_patterns__WEBPACK_IMPORTED_MODULE_8__.SetMultiMap();
        this.pendingMessages = new _wixc3_patterns__WEBPACK_IMPORTED_MODULE_8__.SetMultiMap();
        this.handlers = new Map();
        this.eventDispatchers = {};
        this.apis = {};
        this.apisOverrides = {};
        this.readyEnvs = new Set();
        this.environments = {};
        this.messageHandlers = new WeakMap();
        this.disposeListeners = new Set();
        this.callbackToEnvMapping = new Map();
        // the any is here because issue with typescript and union types Worker | Window have different message handlers
        this.handleEvent = ({ data }) => {
            this.handleMessage(data).catch(_errors__WEBPACK_IMPORTED_MODULE_0__.reportError);
        };
        this.options = { warnOnSlow: false, publicPath: '', connectedEnvironments: {}, ...options };
        this.rootEnvId = id;
        this.rootEnvName = id.split('/')[0];
        this.registerMessageHandler(host);
        this.registerEnv(id, host);
        this.environments['*'] = { id, host };
        this.post(this.getPostEndpoint(host), {
            type: 'ready',
            from: id,
            to: '*',
            origin: id,
            forwardingChain: [],
        });
        for (const [id, envEntry] of Object.entries(this.options.connectedEnvironments)) {
            if (envEntry.registerMessageHandler) {
                this.registerMessageHandler(envEntry.host);
            }
            this.environments[id] = envEntry;
        }
    }
    /**
     * Registers environments that spawned in the same execution context as the root environment.
     */
    registerEnv(id, host) {
        if (!this.environments[id]) {
            this.environments[id] = { id, host };
        }
        else {
            throw new Error((0,_errors__WEBPACK_IMPORTED_MODULE_0__.DUPLICATE_REGISTER)(id, 'Environment'));
        }
    }
    /**
     * Registers local api implementation of the remote service.
     */
    registerAPI({ id }, api) {
        if (!this.apis[id]) {
            this.apis[id] = api;
            this.applyApiDirectives(id, api);
            return api;
        }
        else {
            throw new Error((0,_errors__WEBPACK_IMPORTED_MODULE_0__.DUPLICATE_REGISTER)(id, 'RemoteService'));
        }
    }
    getEnvironmentContext(endPoint) {
        return this.resolvedContexts[endPoint.env];
    }
    getEnvironmentInstanceId(envName, endpointType) {
        return endpointType === 'single' ? envName : this.generateEnvInstanceID(envName);
    }
    getPublicPath() {
        return this.options.publicPath;
    }
    setTopology(envName, envUrl) {
        this.topology[envName] = envUrl;
    }
    subscribeToEnvironmentDispose(handler) {
        this.disposeListeners.add(handler);
    }
    unsubscribeToEnvironmentDispose(handler) {
        this.disposeListeners.delete(handler);
    }
    /**
     * Creates a Proxy for a remote service api.
     */
    apiProxy(instanceToken, { id: api }, serviceComConfig = {}) {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-return
        return new Proxy(Object.create(null), {
            get: (obj, method) => {
                if (typeof method === 'string') {
                    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment, @typescript-eslint/no-unsafe-member-access
                    let runtimeMethod = obj[method];
                    if (!runtimeMethod) {
                        runtimeMethod = async (...args) => this.callMethod((await instanceToken).id, api, method, args, this.rootEnvId, serviceComConfig, []);
                        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment, @typescript-eslint/no-unsafe-member-access
                        obj[method] = runtimeMethod;
                    }
                    // eslint-disable-next-line @typescript-eslint/no-unsafe-return
                    return runtimeMethod;
                }
            },
        });
    }
    /**
     * Add local handle event listener to Target.
     */
    registerMessageHandler(target) {
        var _a;
        const envTarget = (_a = target.parent) !== null && _a !== void 0 ? _a : target;
        const onTargetMessage = ({ data }) => {
            if ((0,_message_types__WEBPACK_IMPORTED_MODULE_7__.isMessage)(data)) {
                if (!this.environments[data.from]) {
                    this.registerEnv(data.from, envTarget);
                }
                if (!this.environments[data.origin]) {
                    this.registerEnv(data.origin, envTarget);
                }
                this.handleEvent({ data });
            }
        };
        target.addEventListener('message', onTargetMessage, true);
        this.messageHandlers.set(target, onTargetMessage);
    }
    /**
     * Remove local handle event listener to Target.
     */
    removeMessageHandler(target) {
        const messageHandler = this.messageHandlers.get(target);
        if (messageHandler) {
            target.removeEventListener('message', messageHandler, true);
        }
    }
    /**
     * Generate client id for newly spawned environment.
     */
    generateEnvInstanceID(name) {
        return this.idsCounter.next(`${name}/`);
    }
    /**
     * Calls a remote method in any opened environment.
     */
    callMethod(envId, api, method, args, origin, serviceComConfig, forwardingChain) {
        return new Promise((res, rej) => {
            var _a, _b;
            const callbackId = !((_a = serviceComConfig[method]) === null || _a === void 0 ? void 0 : _a.emitOnly) ? this.idsCounter.next('c') : undefined;
            if (this.isListenCall(args) || ((_b = serviceComConfig[method]) === null || _b === void 0 ? void 0 : _b.removeAllListeners)) {
                this.addOrRemoveListener(envId, api, method, callbackId, origin, serviceComConfig, args[0], forwardingChain, res, rej);
            }
            else {
                const message = {
                    to: envId,
                    from: this.rootEnvId,
                    type: 'call',
                    data: { api, method, args },
                    callbackId,
                    origin,
                    forwardingChain,
                };
                this.callWithCallback(envId, message, callbackId, res, rej);
            }
        });
    }
    /**
     * handles Communication incoming message.
     */
    async handleMessage(message) {
        if (message.type === 'dispose' && message.to === '*') {
            this.clearEnvironment(message.origin, this.rootEnvId);
            return;
        }
        const env = this.environments[message.to];
        if (!env) {
            this.unhandledMessage(message);
            return;
        }
        if (env.id !== this.rootEnvId) {
            await this.forwardMessage(message, env);
            return;
        }
        switch (message.type) {
            case 'call':
                await this.handleCall(message);
                break;
            case 'callback':
                this.handleCallback(message);
                break;
            case 'event':
                this.handleEventMessage(message);
                break;
            case 'listen':
                await this.handleListen(message);
                break;
            case 'unlisten':
                await this.handleUnListen(message);
                break;
            case 'ready':
                this.handleReady(message);
                break;
            case 'dispose':
                if (message.from !== this.rootEnvId) {
                    this.clearEnvironment(message.origin, message.from);
                }
                break;
            default:
                break;
        }
    }
    /**
     * Dispose the Communication and stop listening to messages.
     */
    dispose() {
        this.disposing = true;
        for (const { host, id } of Object.values(this.environments)) {
            if (host instanceof _hosts_ws_client_host__WEBPACK_IMPORTED_MODULE_6__.WsClientHost) {
                host.subscribers.clear();
                host.dispose();
            }
            this.removeMessageHandler(host);
            this.locallyClear(id);
        }
        this.locallyClear(this.rootEnvId);
        this.disposeListeners.clear();
        for (const [id, { timerId }] of Object.entries(this.callbacks)) {
            clearTimeout(timerId);
            delete this.callbacks[id];
        }
    }
    getEnvironmentId() {
        return this.rootEnvId;
    }
    getEnvironmentName() {
        return this.rootEnvName;
    }
    getEnvironmentHost(envName) {
        var _a;
        return (_a = this.environments[envName]) === null || _a === void 0 ? void 0 : _a.host;
    }
    /**
     * Gets a list of all registered environment instance ids.
     * @returns the list of instance ids.
     */
    getRegisteredEnvironmentInstances() {
        return Object.keys(this.environments).filter((id) => id !== '*');
    }
    parseHandlerId(handlerId, prelude) {
        const [api, method] = handlerId.slice(prelude.length).split('@');
        return {
            api,
            method,
        };
    }
    reconnectHandler(instanceId, handlerId) {
        return new Promise((res, rej) => {
            const message = {
                to: instanceId,
                from: this.rootEnvId,
                type: 'listen',
                data: this.parseHandlerId(handlerId, this.createHandlerIdPrefix({ from: this.rootEnvId, to: instanceId })),
                callbackId: this.idsCounter.next('c'),
                origin: this.rootEnvId,
                handlerId,
                forwardingChain: [],
            };
            this.createCallbackRecord(message, message.callbackId, res, rej);
            this.sendTo(instanceId, message);
        });
    }
    async reconnectHandlers(instanceId) {
        const handlerPrefix = this.createHandlerIdPrefix({ from: this.rootEnvId, to: instanceId });
        for (const handlerId of this.handlers.keys()) {
            if (handlerId.startsWith(handlerPrefix)) {
                await this.reconnectHandler(instanceId, handlerId);
            }
        }
    }
    createHandlerIdPrefix({ from, to }) {
        return `${from}__${to}_`;
    }
    applyApiDirectives(id, api) {
        const serviceConfig = api[_symbols__WEBPACK_IMPORTED_MODULE_3__.SERVICE_CONFIG];
        if (serviceConfig) {
            this.apisOverrides[id] = {};
            for (const methodName of Object.keys(serviceConfig)) {
                const config = serviceConfig[methodName](api);
                if (config.proxyFunction) {
                    this.apisOverrides[id][methodName] = config.proxyFunction;
                }
            }
        }
    }
    envReady(instanceId) {
        const { promise, resolve } = (0,promise_assist__WEBPACK_IMPORTED_MODULE_9__.deferred)();
        if (this.readyEnvs.has(instanceId)) {
            this.handleReady({ from: instanceId });
            resolve();
        }
        else {
            this.pendingEnvs.add(instanceId, () => resolve());
        }
        return promise;
    }
    clearEnvironment(instanceId, from = instanceId, emitRemote = true) {
        const connectedEnvs = Object.keys(this.options.connectedEnvironments);
        if (emitRemote && (this.readyEnvs.has(instanceId) || connectedEnvs.includes(instanceId))) {
            for (const env of [...this.readyEnvs, ...connectedEnvs]) {
                if (![instanceId, from, this.rootEnvId].includes(env)) {
                    this.sendTo(env, {
                        type: 'dispose',
                        from: this.rootEnvId,
                        to: env,
                        origin: instanceId,
                        forwardingChain: [],
                    });
                }
            }
        }
        this.locallyClear(instanceId);
    }
    locallyClear(instanceId) {
        var _a;
        this.readyEnvs.delete(instanceId);
        this.pendingMessages.deleteKey(instanceId);
        this.pendingEnvs.deleteKey(instanceId);
        delete this.environments[instanceId];
        for (const [callbackId, env] of (_a = this.callbackToEnvMapping.entries()) !== null && _a !== void 0 ? _a : []) {
            if (env === instanceId && this.callbacks[callbackId]) {
                const { timerId, reject } = this.callbacks[callbackId];
                clearTimeout(timerId);
                reject(new Error((0,_errors__WEBPACK_IMPORTED_MODULE_0__.ENV_DISCONNECTED)(instanceId)));
                delete this.callbacks[callbackId];
                this.callbackToEnvMapping.delete(callbackId);
            }
        }
        for (const dispose of this.disposeListeners) {
            dispose(instanceId);
        }
    }
    async forwardMessage(message, env) {
        const responseMessage = {
            from: message.to,
            to: message.from,
            callbackId: message.callbackId,
            origin: message.to,
            type: 'callback',
            forwardingChain: [this.rootEnvId],
        };
        if (message.forwardingChain.indexOf(this.rootEnvId) > -1) {
            this.sendTo(message.from, {
                ...responseMessage,
                error: new Error(`cannot reach environment '${message.to}' from '${message.from}' since it's stuck in circular messaging loop`),
            });
            return;
        }
        message.forwardingChain = [...message.forwardingChain, this.rootEnvId];
        if (message.type === 'call') {
            try {
                const data = await this.callMethod(env.id, message.data.api, message.data.method, message.data.args, message.origin, {}, message.forwardingChain);
                if (message.callbackId) {
                    this.sendTo(message.from, { ...responseMessage, data });
                }
            }
            catch (error) {
                if (message.callbackId) {
                    this.sendTo(message.from, { ...responseMessage, error: (0,_helpers__WEBPACK_IMPORTED_MODULE_4__.serializeError)(error) });
                }
            }
        }
        else if (message.type === 'callback' || message.type === 'dispose') {
            if (message.type === 'callback' && message.callbackId) {
                if (this.callbacks[message.callbackId]) {
                    const { resolve, timerId } = this.callbacks[message.callbackId];
                    resolve(message.data);
                    clearTimeout(timerId);
                }
                else {
                    this.sendTo(message.to, message);
                }
            }
            else {
                this.sendTo(message.to, message);
            }
        }
        else if (message.type === 'unlisten') {
            await this.forwardUnlisten(message);
        }
        else if (message.type === 'listen') {
            await this.forwardListenMessage(message);
        }
    }
    async forwardListenMessage(message) {
        const callbackId = this.idsCounter.next('c');
        const data = await new Promise((res, rej) => {
            const handlerId = message.handlerId;
            const handler = (...args) => {
                this.sendTo(message.from, {
                    to: message.from,
                    from: message.to,
                    type: 'event',
                    data: args,
                    handlerId,
                    origin: message.from,
                    forwardingChain: [],
                });
            };
            this.eventDispatchers[handlerId] = handler;
            this.addOrRemoveListener(message.to, message.data.api, message.data.method, callbackId, message.origin, { [message.data.method]: { listener: true } }, handler, message.forwardingChain, res, rej);
        });
        const replyCallback = {
            to: message.from,
            type: 'callback',
            callbackId: message.callbackId,
            from: message.to,
            origin: message.origin,
            data,
            forwardingChain: [],
        };
        this.sendTo(message.from, replyCallback);
    }
    apiCall(origin, api, method, args) {
        var _a;
        if ((_a = this.apisOverrides[api]) === null || _a === void 0 ? void 0 : _a[method]) {
            return this.apisOverrides[api][method](...[origin, ...args]);
        }
        return this.apis[api][method](...args);
    }
    unhandledMessage(_message) {
        // console.warn(
        //   `unhandledMessage at ${this.rootEnv} message:\n${JSON.stringify(message, null, 2)}`
        // )
    }
    addOrRemoveListener(envId, api, method, callbackId, origin, serviceComConfig, fn, forwardingChain, res, rej) {
        var _a, _b, _c, _d;
        const removeListenerRef = ((_a = serviceComConfig[method]) === null || _a === void 0 ? void 0 : _a.removeAllListeners) || ((_b = serviceComConfig[method]) === null || _b === void 0 ? void 0 : _b.removeListener);
        if (removeListenerRef) {
            const listenerHandlerId = this.getHandlerId(envId, api, removeListenerRef);
            const listenerHandlersBucket = this.handlers.get(listenerHandlerId);
            if (!listenerHandlersBucket) {
                res();
                return;
            }
            if ((_c = serviceComConfig[method]) === null || _c === void 0 ? void 0 : _c.removeListener) {
                listenerHandlersBucket.delete(fn);
            }
            else {
                listenerHandlersBucket.clear();
            }
            if (listenerHandlersBucket.size === 0) {
                // send remove handler call
                const message = {
                    to: envId,
                    from: this.rootEnvId,
                    type: 'unlisten',
                    data: {
                        api,
                        method,
                    },
                    handlerId: listenerHandlerId,
                    origin,
                    forwardingChain,
                };
                // sometimes the callback will never happen since target environment is already dead
                this.sendTo(envId, message);
                res();
            }
            else {
                res();
            }
        }
        else {
            if ((_d = serviceComConfig[method]) === null || _d === void 0 ? void 0 : _d.listener) {
                const handlersBucket = this.handlers.get(this.getHandlerId(envId, api, method));
                if (handlersBucket && handlersBucket.size !== 0) {
                    if (handlersBucket.has(fn)) {
                        throw new Error('Cannot add same listener instance twice ' + this.getHandlerId(envId, api, method));
                    }
                    handlersBucket.add(fn);
                    res();
                }
                else {
                    const message = {
                        to: envId,
                        from: this.rootEnvId,
                        type: 'listen',
                        data: {
                            api,
                            method,
                        },
                        handlerId: this.createHandlerRecord(envId, api, method, fn),
                        callbackId,
                        origin,
                        forwardingChain,
                    };
                    this.callWithCallback(envId, message, callbackId, res, rej);
                }
            }
            else {
                throw new Error(`cannot add listener to unconfigured method ${api} ${method}`);
            }
        }
    }
    callWithCallback(envId, message, callbackId, res, rej) {
        if (callbackId) {
            this.createCallbackRecord(message, callbackId, res, rej);
        }
        this.sendTo(envId, message);
        if (!callbackId) {
            res();
        }
    }
    sendTo(envId, message) {
        if (this.pendingEnvs.get(envId)) {
            this.pendingMessages.add(envId, () => this.post(this.resolveMessageTarget(envId), message));
        }
        else {
            this.post(this.resolveMessageTarget(envId), message);
        }
    }
    post(target, message) {
        if ((0,_helpers__WEBPACK_IMPORTED_MODULE_1__.isWorkerContext)(target)) {
            target.postMessage(message);
        }
        else {
            target.postMessage(message, '*');
        }
    }
    resolveMessageTarget(envId) {
        const env = this.environments[envId] || this.environments[this.rootEnvId];
        if (!env) {
            return _types__WEBPACK_IMPORTED_MODULE_2__.HOST_REMOVED;
        }
        const { host } = env;
        if (env.id !== this.rootEnvId) {
            return host;
        }
        else {
            if (host instanceof _hosts_base_host__WEBPACK_IMPORTED_MODULE_5__.BaseHost) {
                return host.parent || host;
            }
            return this.getPostEndpoint(host);
        }
    }
    getPostEndpoint(target) {
        return (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.isWindow)(target) ? target.opener || target.parent : target;
    }
    handleEventMessage(message) {
        const handlers = this.handlers.get(message.handlerId);
        if (!handlers) {
            return;
        }
        for (const handler of handlers) {
            handler(...message.data);
        }
    }
    handleReady({ from }) {
        this.readyEnvs.add(from);
        const pendingEnvCb = this.pendingEnvs.get(from);
        if (pendingEnvCb) {
            this.pendingEnvs.deleteKey(from);
            const pendingMessages = this.pendingMessages.get(from);
            if (pendingMessages) {
                for (const postMessage of pendingMessages) {
                    postMessage();
                }
                this.pendingMessages.deleteKey(from);
            }
            for (const cb of pendingEnvCb) {
                cb();
            }
        }
    }
    async handleUnListen(message) {
        const namespacedHandlerId = message.handlerId + message.origin;
        const dispatcher = this.eventDispatchers[namespacedHandlerId];
        if (dispatcher) {
            delete this.eventDispatchers[namespacedHandlerId];
            const data = await this.apiCall(message.origin, message.data.api, message.data.method, [dispatcher]);
            if (message.callbackId) {
                this.sendTo(message.from, {
                    to: message.from,
                    from: this.rootEnvId,
                    type: 'callback',
                    data,
                    callbackId: message.callbackId,
                    origin: this.rootEnvId,
                    forwardingChain: [],
                });
            }
        }
    }
    async forwardUnlisten(message) {
        const callbackId = this.idsCounter.next('c');
        const { method, api } = this.parseHandlerId(message.handlerId, this.createHandlerIdPrefix(message));
        const data = await new Promise((res, rej) => this.addOrRemoveListener(message.to, api, message.data.method, callbackId, message.origin, {
            [message.data.method]: {
                removeListener: method,
            },
        }, this.eventDispatchers[message.handlerId], message.forwardingChain, res, rej));
        delete this.eventDispatchers[message.handlerId];
        if (message.callbackId) {
            this.sendTo(message.from, {
                to: message.from,
                from: message.to,
                type: 'callback',
                data,
                callbackId: message.callbackId,
                origin: message.to,
                forwardingChain: [],
            });
        }
    }
    async handleListen(message) {
        try {
            const namespacedHandlerId = message.handlerId + message.origin;
            const dispatcher = this.eventDispatchers[namespacedHandlerId] || this.createDispatcher(message.from, message);
            const data = await this.apiCall(message.origin, message.data.api, message.data.method, [dispatcher]);
            if (message.callbackId) {
                this.sendTo(message.from, {
                    to: message.from,
                    from: this.rootEnvId,
                    type: 'callback',
                    data,
                    callbackId: message.callbackId,
                    origin: this.rootEnvId,
                    forwardingChain: [],
                });
            }
        }
        catch (error) {
            this.sendTo(message.from, {
                to: message.from,
                from: this.rootEnvId,
                type: 'callback',
                error: (0,_helpers__WEBPACK_IMPORTED_MODULE_4__.serializeError)(error),
                callbackId: message.callbackId,
                origin: this.rootEnvId,
                forwardingChain: [],
            });
        }
    }
    async handleCall(message) {
        try {
            const data = await this.apiCall(message.origin, message.data.api, message.data.method, message.data.args);
            if (message.callbackId) {
                this.sendTo(message.from, {
                    to: message.origin,
                    from: this.rootEnvId,
                    type: 'callback',
                    data,
                    callbackId: message.callbackId,
                    origin: this.rootEnvId,
                    forwardingChain: [],
                });
            }
        }
        catch (error) {
            this.sendTo(message.from, {
                to: message.from,
                from: this.rootEnvId,
                type: 'callback',
                error: (0,_helpers__WEBPACK_IMPORTED_MODULE_4__.serializeError)(error),
                callbackId: message.callbackId,
                origin: this.rootEnvId,
                forwardingChain: [],
            });
        }
    }
    handleCallback(message) {
        const rec = message.callbackId ? this.callbacks[message.callbackId] : null;
        if (rec && message.error) {
            // If the error is not caught later, and logged to the console,
            // it would be nice to indicate which environment the error came from.
            // We shouldn't change the error message or the error name because
            // those could be used by error-handling code. Fortunately, we can
            // add metadata to the stack trace, and Chrome logs the entire stack
            // property to the console. Unfortunately, Firefox doesn't.
            const error = Object.assign(new Error(), message.error);
            error.stack = (0,_errors__WEBPACK_IMPORTED_MODULE_0__.REMOTE_CALL_FAILED)(message.from, error.stack);
            rec.reject(error);
        }
        else if (rec) {
            rec.resolve(message.data);
        }
        else {
            // TODO: only in dev mode
            if (message.callbackId) {
                throw new Error((0,_errors__WEBPACK_IMPORTED_MODULE_0__.UNKNOWN_CALLBACK_ID)(removeMessageArgs(message)));
            }
        }
    }
    createDispatcher(envId, message) {
        const namespacedHandlerId = message.handlerId + message.origin;
        return (this.eventDispatchers[namespacedHandlerId] = (...args) => {
            this.sendTo(envId, {
                to: envId,
                from: this.rootEnvId,
                type: 'event',
                data: args,
                handlerId: message.handlerId,
                origin: this.rootEnvId,
                forwardingChain: [],
            });
        });
    }
    isListenCall(args) {
        return typeof args[0] === 'function' && args.length === 1;
    }
    getHandlerId(envId, api, method) {
        return `${this.createHandlerIdPrefix({ from: this.rootEnvId, to: envId })}${api}@${method}`;
    }
    createHandlerRecord(envId, api, method, fn) {
        const handlerId = this.getHandlerId(envId, api, method);
        const handlersBucket = this.handlers.get(handlerId);
        if (!handlersBucket) {
            this.subscribeToEnvironmentDispose((disposedEnvId) => {
                if (envId === disposedEnvId) {
                    this.handlers.delete(handlerId);
                }
            });
        }
        handlersBucket ? handlersBucket.add(fn) : this.handlers.set(handlerId, new Set([fn]));
        return handlerId;
    }
    createCallbackRecord(message, callbackId, res, rej) {
        if (!this.disposing) {
            this.callbackToEnvMapping.set(callbackId, message.to);
            const resolve = (value) => {
                this.callbackToEnvMapping.delete(callbackId);
                delete this.callbacks[callbackId];
                clearTimeout(timerId);
                res(value);
            };
            const reject = (error) => {
                this.callbackToEnvMapping.delete(callbackId);
                delete this.callbacks[callbackId];
                clearTimeout(timerId);
                rej(error);
            };
            if (this.options.warnOnSlow) {
                setTimeout(() => {
                    if (this.callbacks[callbackId]) {
                        console.error((0,_errors__WEBPACK_IMPORTED_MODULE_0__.CALLBACK_TIMEOUT)(callbackId, this.rootEnvId, removeMessageArgs(message)));
                    }
                }, this.slowThreshold);
            }
            const timerId = setTimeout(() => {
                reject(new Error((0,_errors__WEBPACK_IMPORTED_MODULE_0__.CALLBACK_TIMEOUT)(callbackId, this.rootEnvId, removeMessageArgs(message))));
            }, this.callbackTimeout);
            this.callbacks[callbackId] = {
                timerId,
                resolve,
                reject,
            };
        }
    }
}
const removeMessageArgs = (message) => {
    message = { ...message };
    if (message.type === 'call' || message.type === 'callback') {
        const { data } = message;
        if (data && data.args) {
            data.args = undefined;
        }
    }
    return message;
};
function declareComEmitter(onMethod, offMethod, removeAll) {
    if (typeof onMethod !== 'string') {
        throw 'onMethod ref must be a string';
    }
    return {
        [onMethod]: { listener: true },
        [offMethod]: { removeListener: onMethod },
        ...(removeAll ? { [removeAll]: { removeAllListeners: onMethod } } : undefined),
    };
}


/***/ }),

/***/ "./packages/core/src/com/errors.ts":
/*!*****************************************!*\
  !*** ./packages/core/src/com/errors.ts ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CALLBACK_TIMEOUT": () => (/* binding */ CALLBACK_TIMEOUT),
/* harmony export */   "DUPLICATE_REGISTER": () => (/* binding */ DUPLICATE_REGISTER),
/* harmony export */   "ENV_DISCONNECTED": () => (/* binding */ ENV_DISCONNECTED),
/* harmony export */   "GLOBAL_REF": () => (/* binding */ GLOBAL_REF),
/* harmony export */   "MISSING_COM_CONTEXT": () => (/* binding */ MISSING_COM_CONTEXT),
/* harmony export */   "MISSING_CONTEXT_FOR_API_PROXY": () => (/* binding */ MISSING_CONTEXT_FOR_API_PROXY),
/* harmony export */   "MISSING_ENV": () => (/* binding */ MISSING_ENV),
/* harmony export */   "MISSING_FORWARD_FOR_MESSAGE": () => (/* binding */ MISSING_FORWARD_FOR_MESSAGE),
/* harmony export */   "REMOTE_CALL_FAILED": () => (/* binding */ REMOTE_CALL_FAILED),
/* harmony export */   "SPAWNED_MORE_THEN_ONCE": () => (/* binding */ SPAWNED_MORE_THEN_ONCE),
/* harmony export */   "UNKNOWN_CALLBACK_ID": () => (/* binding */ UNKNOWN_CALLBACK_ID),
/* harmony export */   "reportError": () => (/* binding */ reportError)
/* harmony export */ });
const DUPLICATE_REGISTER = (id, type) => `Could not register same id ${id} as ${type}`;
const GLOBAL_REF = (id) => `Com with id "${id}" is already running.`;
const REMOTE_CALL_FAILED = (environment, stack) => `Remote call failed in ${environment}${stack ? `\n${stack}` : ''}`;
const ENV_DISCONNECTED = (environment) => `Remote call failed in ${environment} - environment disconnected`;
const UNKNOWN_CALLBACK_ID = (message) => `Unknown callback id "${message.callbackId}" in message:\n${JSON.stringify(message)}`;
const CALLBACK_TIMEOUT = (callbackId, hostId, message) => `Callback timeout "${callbackId}" at ${hostId} on message:\n${JSON.stringify(message)}`;
const MISSING_ENV = (target, environments) => `Destination environment ${target} is not registered. available environments: [${environments.join(', ')}]`;
const MISSING_FORWARD_FOR_MESSAGE = (message) => `Not implemented forward for ${message.type}`;
const MISSING_COM_CONTEXT = (id, when) => `Missing communication context for "${id}" when ${when}`;
const SPAWNED_MORE_THEN_ONCE = (id) => `Environment with id ${id} can only spawned once`;
const MISSING_CONTEXT_FOR_API_PROXY = (type, remoteServiceId) => `Missing ${type} when trying to get remote service api proxy for ${remoteServiceId}`;
function reportError(e) {
    console.error(e);
}


/***/ }),

/***/ "./packages/core/src/com/helpers.ts":
/*!******************************************!*\
  !*** ./packages/core/src/com/helpers.ts ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "MultiCounter": () => (/* binding */ MultiCounter),
/* harmony export */   "isIframe": () => (/* binding */ isIframe),
/* harmony export */   "isWindow": () => (/* binding */ isWindow),
/* harmony export */   "isWorkerContext": () => (/* binding */ isWorkerContext)
/* harmony export */ });
function isWorkerContext(target) {
    return ((typeof Worker !== 'undefined' && target instanceof Worker) ||
        (typeof WorkerGlobalScope !== 'undefined' && target instanceof WorkerGlobalScope));
}
function isWindow(win) {
    return typeof Window !== 'undefined' && win instanceof Window;
}
function isIframe(iframe) {
    return typeof HTMLIFrameElement !== 'undefined' && iframe instanceof HTMLIFrameElement;
}
class MultiCounter {
    constructor() {
        this.ids = {};
    }
    next(ns) {
        this.ids[ns] = this.ids[ns] || 0;
        return `${ns}${this.ids[ns]++}`;
    }
}


/***/ }),

/***/ "./packages/core/src/com/hosts/base-host.ts":
/*!**************************************************!*\
  !*** ./packages/core/src/com/hosts/base-host.ts ***!
  \**************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "BaseHost": () => (/* binding */ BaseHost)
/* harmony export */ });
class BaseHost {
    constructor() {
        this.name = 'base-host';
        this.parent = undefined;
        this.handlers = new Map();
    }
    addEventListener(name, handler, _capture) {
        const handlers = this.handlers.get(name);
        if (!handlers) {
            this.handlers.set(name, new Set([handler]));
        }
        else {
            handlers.add(handler);
        }
    }
    removeEventListener(name, handler, _capture) {
        const handlers = this.handlers.get(name);
        if (handlers) {
            handlers.delete(handler);
        }
    }
    postMessage(message) {
        this.emitMessageHandlers(message);
    }
    open() {
        const host = new BaseHost();
        host.parent = this;
        return host;
    }
    emitMessageHandlers(message) {
        for (const handler of this.handlers.get('message') || []) {
            handler({ data: message });
        }
    }
}


/***/ }),

/***/ "./packages/core/src/com/hosts/event-emitter.ts":
/*!******************************************************!*\
  !*** ./packages/core/src/com/hosts/event-emitter.ts ***!
  \******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "EventEmitterHost": () => (/* binding */ EventEmitterHost)
/* harmony export */ });
/* harmony import */ var _base_host__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base-host */ "./packages/core/src/com/hosts/base-host.ts");

class EventEmitterHost extends _base_host__WEBPACK_IMPORTED_MODULE_0__.BaseHost {
    constructor(host) {
        super();
        this.host = host;
        this.host.on('message', (data) => this.emitMessageHandlers(data));
    }
    postMessage(message) {
        this.emitMessageHandlers(message);
    }
}


/***/ }),

/***/ "./packages/core/src/com/hosts/index.ts":
/*!**********************************************!*\
  !*** ./packages/core/src/com/hosts/index.ts ***!
  \**********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "BaseHost": () => (/* reexport safe */ _base_host__WEBPACK_IMPORTED_MODULE_0__.BaseHost),
/* harmony export */   "EventEmitterHost": () => (/* reexport safe */ _event_emitter__WEBPACK_IMPORTED_MODULE_2__.EventEmitterHost),
/* harmony export */   "WsClientHost": () => (/* reexport safe */ _ws_client_host__WEBPACK_IMPORTED_MODULE_1__.WsClientHost)
/* harmony export */ });
/* harmony import */ var _base_host__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base-host */ "./packages/core/src/com/hosts/base-host.ts");
/* harmony import */ var _ws_client_host__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./ws-client-host */ "./packages/core/src/com/hosts/ws-client-host.ts");
/* harmony import */ var _event_emitter__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./event-emitter */ "./packages/core/src/com/hosts/event-emitter.ts");





/***/ }),

/***/ "./packages/core/src/com/hosts/ws-client-host.ts":
/*!*******************************************************!*\
  !*** ./packages/core/src/com/hosts/ws-client-host.ts ***!
  \*******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "WsClientHost": () => (/* binding */ WsClientHost)
/* harmony export */ });
/* harmony import */ var socket_io_client__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! socket.io-client */ "socket.io-client");
/* harmony import */ var socket_io_client__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(socket_io_client__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _base_host__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./base-host */ "./packages/core/src/com/hosts/base-host.ts");
/* harmony import */ var _wixc3_patterns__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @wixc3/patterns */ "./node_modules/@wixc3/patterns/dist/esm/event-emitter.js");
/* harmony import */ var promise_assist__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! promise-assist */ "./node_modules/promise-assist/esm/deferred.js");




class WsClientHost extends _base_host__WEBPACK_IMPORTED_MODULE_1__.BaseHost {
    constructor(url, options) {
        super();
        this.subscribers = new _wixc3_patterns__WEBPACK_IMPORTED_MODULE_2__.EventEmitter();
        const { path, ...query } = Object.fromEntries(new URL(url).searchParams);
        const { promise, resolve } = (0,promise_assist__WEBPACK_IMPORTED_MODULE_3__.deferred)();
        this.connected = promise;
        this.socketClient = (0,socket_io_client__WEBPACK_IMPORTED_MODULE_0__.io)(url, {
            transports: ['websocket'],
            forceNew: true,
            withCredentials: true,
            path,
            query,
            ...options,
        });
        this.socketClient.on('connect', () => {
            this.socketClient.on('message', (data) => {
                this.emitMessageHandlers(data);
            });
            resolve();
        });
        this.socketClient.on('disconnect', () => {
            this.subscribers.emit('disconnect', undefined);
            this.socketClient.close();
        });
        this.socketClient.on('reconnect', () => {
            this.subscribers.emit('reconnect', undefined);
        });
        this.socketClient.connect();
    }
    postMessage(data) {
        this.socketClient.emit('message', data);
    }
    dispose() {
        this.subscribers.clear();
        this.socketClient.close();
    }
}


/***/ }),

/***/ "./packages/core/src/com/index.ts":
/*!****************************************!*\
  !*** ./packages/core/src/com/index.ts ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "BaseHost": () => (/* reexport safe */ _hosts_base_host__WEBPACK_IMPORTED_MODULE_0__.BaseHost),
/* harmony export */   "CALLBACK_TIMEOUT": () => (/* reexport safe */ _errors__WEBPACK_IMPORTED_MODULE_2__.CALLBACK_TIMEOUT),
/* harmony export */   "Communication": () => (/* reexport safe */ _communication__WEBPACK_IMPORTED_MODULE_1__.Communication),
/* harmony export */   "DUPLICATE_REGISTER": () => (/* reexport safe */ _errors__WEBPACK_IMPORTED_MODULE_2__.DUPLICATE_REGISTER),
/* harmony export */   "ENV_DISCONNECTED": () => (/* reexport safe */ _errors__WEBPACK_IMPORTED_MODULE_2__.ENV_DISCONNECTED),
/* harmony export */   "EventEmitterHost": () => (/* reexport safe */ _hosts__WEBPACK_IMPORTED_MODULE_11__.EventEmitterHost),
/* harmony export */   "GLOBAL_REF": () => (/* reexport safe */ _errors__WEBPACK_IMPORTED_MODULE_2__.GLOBAL_REF),
/* harmony export */   "HOST_REMOVED": () => (/* reexport safe */ _types__WEBPACK_IMPORTED_MODULE_8__.HOST_REMOVED),
/* harmony export */   "INSTANCE_ID_PARAM_NAME": () => (/* reexport safe */ _initializers__WEBPACK_IMPORTED_MODULE_10__.INSTANCE_ID_PARAM_NAME),
/* harmony export */   "LoggerService": () => (/* reexport safe */ _logger_service__WEBPACK_IMPORTED_MODULE_4__.LoggerService),
/* harmony export */   "MISSING_COM_CONTEXT": () => (/* reexport safe */ _errors__WEBPACK_IMPORTED_MODULE_2__.MISSING_COM_CONTEXT),
/* harmony export */   "MISSING_CONTEXT_FOR_API_PROXY": () => (/* reexport safe */ _errors__WEBPACK_IMPORTED_MODULE_2__.MISSING_CONTEXT_FOR_API_PROXY),
/* harmony export */   "MISSING_ENV": () => (/* reexport safe */ _errors__WEBPACK_IMPORTED_MODULE_2__.MISSING_ENV),
/* harmony export */   "MISSING_FORWARD_FOR_MESSAGE": () => (/* reexport safe */ _errors__WEBPACK_IMPORTED_MODULE_2__.MISSING_FORWARD_FOR_MESSAGE),
/* harmony export */   "MultiCounter": () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_3__.MultiCounter),
/* harmony export */   "REMOTE_CALL_FAILED": () => (/* reexport safe */ _errors__WEBPACK_IMPORTED_MODULE_2__.REMOTE_CALL_FAILED),
/* harmony export */   "SPAWNED_MORE_THEN_ONCE": () => (/* reexport safe */ _errors__WEBPACK_IMPORTED_MODULE_2__.SPAWNED_MORE_THEN_ONCE),
/* harmony export */   "UNKNOWN_CALLBACK_ID": () => (/* reexport safe */ _errors__WEBPACK_IMPORTED_MODULE_2__.UNKNOWN_CALLBACK_ID),
/* harmony export */   "WindowInitializerService": () => (/* reexport safe */ _window_initializer_service__WEBPACK_IMPORTED_MODULE_5__.WindowInitializerService),
/* harmony export */   "WsClientHost": () => (/* reexport safe */ _hosts_ws_client_host__WEBPACK_IMPORTED_MODULE_9__.WsClientHost),
/* harmony export */   "declareComEmitter": () => (/* reexport safe */ _communication__WEBPACK_IMPORTED_MODULE_1__.declareComEmitter),
/* harmony export */   "deferredIframeInitializer": () => (/* reexport safe */ _initializers__WEBPACK_IMPORTED_MODULE_10__.deferredIframeInitializer),
/* harmony export */   "iframeInitializer": () => (/* reexport safe */ _initializers__WEBPACK_IMPORTED_MODULE_10__.iframeInitializer),
/* harmony export */   "initializeContextualEnv": () => (/* reexport safe */ _initializers__WEBPACK_IMPORTED_MODULE_10__.initializeContextualEnv),
/* harmony export */   "ipcInitializer": () => (/* reexport safe */ _initializers__WEBPACK_IMPORTED_MODULE_10__.ipcInitializer),
/* harmony export */   "isIframe": () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_3__.isIframe),
/* harmony export */   "isMessage": () => (/* reexport safe */ _message_types__WEBPACK_IMPORTED_MODULE_6__.isMessage),
/* harmony export */   "isWindow": () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_3__.isWindow),
/* harmony export */   "isWorkerContext": () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_3__.isWorkerContext),
/* harmony export */   "multiTenantMethod": () => (/* reexport safe */ _service_config__WEBPACK_IMPORTED_MODULE_7__.multiTenantMethod),
/* harmony export */   "reportError": () => (/* reexport safe */ _errors__WEBPACK_IMPORTED_MODULE_2__.reportError),
/* harmony export */   "socketClientInitializer": () => (/* reexport safe */ _initializers__WEBPACK_IMPORTED_MODULE_10__.socketClientInitializer),
/* harmony export */   "webWorkerInitializer": () => (/* reexport safe */ _initializers__WEBPACK_IMPORTED_MODULE_10__.webWorkerInitializer),
/* harmony export */   "windowInitializer": () => (/* reexport safe */ _initializers__WEBPACK_IMPORTED_MODULE_10__.windowInitializer)
/* harmony export */ });
/* harmony import */ var _hosts_base_host__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./hosts/base-host */ "./packages/core/src/com/hosts/base-host.ts");
/* harmony import */ var _communication__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./communication */ "./packages/core/src/com/communication.ts");
/* harmony import */ var _errors__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./errors */ "./packages/core/src/com/errors.ts");
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./helpers */ "./packages/core/src/com/helpers.ts");
/* harmony import */ var _logger_service__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./logger-service */ "./packages/core/src/com/logger-service.ts");
/* harmony import */ var _window_initializer_service__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./window-initializer-service */ "./packages/core/src/com/window-initializer-service.ts");
/* harmony import */ var _message_types__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./message-types */ "./packages/core/src/com/message-types.ts");
/* harmony import */ var _service_config__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./service-config */ "./packages/core/src/com/service-config.ts");
/* harmony import */ var _types__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./types */ "./packages/core/src/com/types.ts");
/* harmony import */ var _hosts_ws_client_host__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./hosts/ws-client-host */ "./packages/core/src/com/hosts/ws-client-host.ts");
/* harmony import */ var _initializers__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./initializers */ "./packages/core/src/com/initializers/index.ts");
/* harmony import */ var _hosts__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./hosts */ "./packages/core/src/com/hosts/index.ts");














/***/ }),

/***/ "./packages/core/src/com/initializers/contextual.ts":
/*!**********************************************************!*\
  !*** ./packages/core/src/com/initializers/contextual.ts ***!
  \**********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "initializeContextualEnv": () => (/* binding */ initializeContextualEnv)
/* harmony export */ });
/**
 * TODO: better inference of the return type of the initialzier function
 */
function initializeContextualEnv({ communication, env: { env, environments }, envInitializers, }) {
    const runtimeEnvironmentName = communication.resolvedContexts[env];
    const activeEnvironment = environments.find((contextualEnv) => contextualEnv.env === runtimeEnvironmentName);
    if (!activeEnvironment) {
        throw new Error(`${runtimeEnvironmentName} cannot be found in definition of ${env} environment`);
    }
    if (activeEnvironment.env in envInitializers) {
        const envInitializer = envInitializers[activeEnvironment.env];
        if (!envInitializer) {
            throw new Error(`environment initializer is not set for ${activeEnvironment.env}`);
        }
        return envInitializer({ communication, env: { ...activeEnvironment, env } });
    }
    else {
        throw new Error('error');
    }
}


/***/ }),

/***/ "./packages/core/src/com/initializers/iframe.ts":
/*!******************************************************!*\
  !*** ./packages/core/src/com/initializers/iframe.ts ***!
  \******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "INSTANCE_ID_PARAM_NAME": () => (/* binding */ INSTANCE_ID_PARAM_NAME),
/* harmony export */   "deferredIframeInitializer": () => (/* binding */ deferredIframeInitializer),
/* harmony export */   "iframeInitializer": () => (/* binding */ iframeInitializer)
/* harmony export */ });
/* harmony import */ var _window_initializer_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../window-initializer-service */ "./packages/core/src/com/window-initializer-service.ts");

const INSTANCE_ID_PARAM_NAME = 'iframe-instance-id';
async function iframeInitializer({ communication, env, ...initializerOptions }) {
    const { initialize } = deferredIframeInitializer({ communication, env });
    const id = await initialize(initializerOptions);
    return {
        id,
    };
}
function deferredIframeInitializer({ communication: com, env: { env, endpointType } }) {
    const instanceId = com.getEnvironmentInstanceId(env, endpointType);
    const envReadyPromise = com.envReady(instanceId);
    return {
        id: instanceId,
        initialize: ({ iframeElement, hashParams, src, origin }) => {
            const publicPath = com.getPublicPath();
            const startIframeParams = {
                com,
                envReadyPromise,
                instanceId,
                iframe: iframeElement,
                src: src !== null && src !== void 0 ? src : defaultHtmlSourceFactory(env, publicPath, hashParams, origin),
            };
            return startIframe(startIframeParams);
        },
    };
}
const cancellationTriggers = new WeakMap();
async function startIframe({ com, iframe, instanceId, src, envReadyPromise }) {
    var _a;
    if (!iframe.contentWindow) {
        throw new Error('Cannot initialize environment in a detached iframe');
    }
    (_a = cancellationTriggers.get(iframe)) === null || _a === void 0 ? void 0 : _a();
    const waitForCancel = new Promise((_, reject) => {
        cancellationTriggers.set(iframe, () => {
            reject('Cancelled environment initialization in an iframe');
        });
    });
    const cleanup = () => {
        com.clearEnvironment(instanceId);
    };
    try {
        const contentWindow = iframe.contentWindow;
        const url = new URL(src, window.location.href);
        com.registerEnv(instanceId, contentWindow);
        // pass instance id in query param for engine initialization
        // script that will run in the iframe can pick it up
        url.searchParams.set(INSTANCE_ID_PARAM_NAME, instanceId);
        iframe.src = url.href;
        await Promise.race([waitForCancel, waitForLoad(iframe), envReadyPromise]);
        const api = com.apiProxy({ id: instanceId }, { id: _window_initializer_service__WEBPACK_IMPORTED_MODULE_0__.WindowInitializerService.apiId }, {
            oncePageHide: {
                listener: true,
            },
        });
        const postInitHref = await api.getHref();
        if (iframe.contentWindow !== contentWindow || postInitHref !== url.href) {
            throw new Error('Iframe location has changed during environment initialization');
        }
        // pagehide is used on purpose since it is more reliable than onUnload
        // onUnload does not send postMessages on cross origin
        // https://bugs.chromium.org/p/chromium/issues/detail?id=964950
        await api.oncePageHide(() => {
            cleanup();
        });
        cancellationTriggers.delete(iframe);
        return instanceId;
    }
    catch (e) {
        cleanup();
        throw e;
    }
}
const waitForLoad = (elem) => new Promise((resolve) => elem.addEventListener('load', resolve, { once: true }));
const defaultHtmlSourceFactory = (envName, publicPath = '', hashParams, origin = '') => {
    return `${origin}${publicPath}${envName}.html${location.search}${hashParams !== null && hashParams !== void 0 ? hashParams : ''}`;
};


/***/ }),

/***/ "./packages/core/src/com/initializers/index.ts":
/*!*****************************************************!*\
  !*** ./packages/core/src/com/initializers/index.ts ***!
  \*****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "INSTANCE_ID_PARAM_NAME": () => (/* reexport safe */ _iframe__WEBPACK_IMPORTED_MODULE_4__.INSTANCE_ID_PARAM_NAME),
/* harmony export */   "deferredIframeInitializer": () => (/* reexport safe */ _iframe__WEBPACK_IMPORTED_MODULE_4__.deferredIframeInitializer),
/* harmony export */   "iframeInitializer": () => (/* reexport safe */ _iframe__WEBPACK_IMPORTED_MODULE_4__.iframeInitializer),
/* harmony export */   "initializeContextualEnv": () => (/* reexport safe */ _contextual__WEBPACK_IMPORTED_MODULE_2__.initializeContextualEnv),
/* harmony export */   "ipcInitializer": () => (/* reexport safe */ _ipc__WEBPACK_IMPORTED_MODULE_5__.ipcInitializer),
/* harmony export */   "socketClientInitializer": () => (/* reexport safe */ _socket_server__WEBPACK_IMPORTED_MODULE_0__.socketClientInitializer),
/* harmony export */   "webWorkerInitializer": () => (/* reexport safe */ _webworker__WEBPACK_IMPORTED_MODULE_3__.webWorkerInitializer),
/* harmony export */   "windowInitializer": () => (/* reexport safe */ _window__WEBPACK_IMPORTED_MODULE_1__.windowInitializer)
/* harmony export */ });
/* harmony import */ var _socket_server__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./socket-server */ "./packages/core/src/com/initializers/socket-server.ts");
/* harmony import */ var _window__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./window */ "./packages/core/src/com/initializers/window.ts");
/* harmony import */ var _contextual__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./contextual */ "./packages/core/src/com/initializers/contextual.ts");
/* harmony import */ var _webworker__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./webworker */ "./packages/core/src/com/initializers/webworker.ts");
/* harmony import */ var _iframe__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./iframe */ "./packages/core/src/com/initializers/iframe.ts");
/* harmony import */ var _ipc__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./ipc */ "./packages/core/src/com/initializers/ipc.ts");
/* harmony import */ var _types__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./types */ "./packages/core/src/com/initializers/types.ts");









/***/ }),

/***/ "./packages/core/src/com/initializers/ipc.ts":
/*!***************************************************!*\
  !*** ./packages/core/src/com/initializers/ipc.ts ***!
  \***************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ipcInitializer": () => (/* binding */ ipcInitializer)
/* harmony export */ });
const ipcInitializer = async ({ communication, env: { env, endpointType } }) => {
    const instanceId = communication.getEnvironmentInstanceId(env, endpointType);
    const host = communication.getEnvironmentHost(env);
    if (!host) {
        throw new Error(`IPC hosts should be registered and forked before the initializer run`);
    }
    communication.registerMessageHandler(host);
    await communication.envReady(env);
    return {
        id: instanceId,
    };
};


/***/ }),

/***/ "./packages/core/src/com/initializers/socket-server.ts":
/*!*************************************************************!*\
  !*** ./packages/core/src/com/initializers/socket-server.ts ***!
  \*************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "socketClientInitializer": () => (/* binding */ socketClientInitializer)
/* harmony export */ });
/* harmony import */ var _hosts_ws_client_host__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../hosts/ws-client-host */ "./packages/core/src/com/hosts/ws-client-host.ts");

const socketClientInitializer = async ({ communication, env: { env }, ...socketClientOptions }) => {
    const url = communication.topology[env];
    if (!url) {
        throw new Error(`Could not find node topology for ${env} environment`);
    }
    const instanceId = env;
    const host = new _hosts_ws_client_host__WEBPACK_IMPORTED_MODULE_0__.WsClientHost(url, socketClientOptions);
    if (communication.getEnvironmentHost(instanceId)) {
        communication.clearEnvironment(instanceId, undefined, false);
    }
    communication.registerMessageHandler(host);
    communication.registerEnv(instanceId, host);
    await host.connected;
    communication.handleReady({ from: instanceId });
    return {
        id: instanceId,
        onDisconnect: (cb) => {
            host.subscribers.on('disconnect', cb);
        },
        onReconnect: (cb) => {
            host.subscribers.on('reconnect', cb);
        },
    };
};


/***/ }),

/***/ "./packages/core/src/com/initializers/types.ts":
/*!*****************************************************!*\
  !*** ./packages/core/src/com/initializers/types.ts ***!
  \*****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./packages/core/src/com/initializers/webworker.ts":
/*!*********************************************************!*\
  !*** ./packages/core/src/com/initializers/webworker.ts ***!
  \*********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "webWorkerInitializer": () => (/* binding */ webWorkerInitializer)
/* harmony export */ });
async function webWorkerInitializer({ communication, env: { env, endpointType } }) {
    const isSingleton = endpointType === 'single';
    const instanceId = isSingleton ? env : communication.generateEnvInstanceID(env);
    const webWorker = new Worker(`${communication.getPublicPath()}${env}.webworker.js${location.search}`, {
        name: instanceId,
    });
    communication.registerMessageHandler(webWorker);
    communication.registerEnv(instanceId, webWorker);
    await communication.envReady(instanceId);
    return {
        id: instanceId,
    };
}


/***/ }),

/***/ "./packages/core/src/com/initializers/window.ts":
/*!******************************************************!*\
  !*** ./packages/core/src/com/initializers/window.ts ***!
  \******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "windowInitializer": () => (/* binding */ windowInitializer)
/* harmony export */ });
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../helpers */ "./packages/core/src/com/helpers.ts");
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../helpers */ "./packages/core/src/helpers/index.ts");


async function windowInitializer({ communication, env: { env, endpointType }, host }) {
    const instanceId = communication.getEnvironmentInstanceId(env, endpointType);
    const win = (0,_helpers__WEBPACK_IMPORTED_MODULE_0__.isIframe)(host) ? host.contentWindow : host;
    if (!win) {
        throw new Error('cannot spawn detached iframe.');
    }
    await (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.injectScript)(win, instanceId, `${communication.getPublicPath()}${env}.web.js${location.search}`);
    return {
        id: instanceId,
    };
}


/***/ }),

/***/ "./packages/core/src/com/logger-service.ts":
/*!*************************************************!*\
  !*** ./packages/core/src/com/logger-service.ts ***!
  \*************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "LoggerService": () => (/* binding */ LoggerService)
/* harmony export */ });
/* harmony import */ var _wixc3_patterns__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wixc3/patterns */ "./node_modules/@wixc3/patterns/dist/esm/event-emitter.js");
/* harmony import */ var _types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../types */ "./packages/core/src/types.ts");


class LoggerService extends _wixc3_patterns__WEBPACK_IMPORTED_MODULE_1__.EventEmitter {
    constructor(transports = [], baseMetadata = {}, config = { severity: _types__WEBPACK_IMPORTED_MODULE_0__.LogLevel.DEBUG }) {
        super();
        this.transports = transports;
        this.baseMetadata = baseMetadata;
        this.config = config;
        this.messages = [];
        this.debug = (value) => this.log(value, _types__WEBPACK_IMPORTED_MODULE_0__.LogLevel.DEBUG);
        this.info = (value) => this.log(value, _types__WEBPACK_IMPORTED_MODULE_0__.LogLevel.INFO);
        this.warn = (value) => this.log(value, _types__WEBPACK_IMPORTED_MODULE_0__.LogLevel.WARN);
        this.error = (value) => this.log(value, _types__WEBPACK_IMPORTED_MODULE_0__.LogLevel.ERROR);
    }
    getMessages() {
        return this.messages;
    }
    logMessage(message) {
        if (message.level >= this.config.severity) {
            this.addToMessages(message);
            this.emit('message', message);
            if (this.config.logToConsole) {
                logToConsole(message);
            }
            for (const transport of this.transports) {
                transport.handleMessage(message);
            }
        }
    }
    clearMessages() {
        this.messages = [];
    }
    log(message, severity) {
        const { value, metadata } = getValue(message);
        this.logMessage({
            message: value,
            timestamp: Date.now(),
            level: severity,
            metadata: { base: this.baseMetadata, ...metadata },
        });
    }
    addToMessages(message) {
        if (this.messages.length + 1 > this.config.maxLogMessages) {
            this.messages.shift();
        }
        this.messages.push(message);
    }
}
function getValue(message) {
    const logValue = {
        value: '',
    };
    if (typeof message === 'function') {
        const evaluatedValue = message();
        if (typeof evaluatedValue === 'string') {
            logValue.value = evaluatedValue;
        }
        else {
            logValue.value = evaluatedValue.value;
            logValue.metadata = evaluatedValue.metadata || logValue.metadata;
        }
    }
    else if (typeof message === 'string') {
        logValue.value = message;
    }
    else {
        logValue.value = message.value;
        logValue.metadata = message.metadata;
    }
    return logValue;
}
function logToConsole({ message, metadata = {}, level }) {
    switch (level) {
        case _types__WEBPACK_IMPORTED_MODULE_0__.LogLevel.DEBUG:
            console.log(message, metadata);
            break;
        case _types__WEBPACK_IMPORTED_MODULE_0__.LogLevel.INFO:
            console.info(message, metadata);
            break;
        case _types__WEBPACK_IMPORTED_MODULE_0__.LogLevel.WARN:
            console.warn(message, metadata);
            break;
        case _types__WEBPACK_IMPORTED_MODULE_0__.LogLevel.ERROR:
            console.error(message, metadata);
            break;
    }
}


/***/ }),

/***/ "./packages/core/src/com/message-types.ts":
/*!************************************************!*\
  !*** ./packages/core/src/com/message-types.ts ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "isMessage": () => (/* binding */ isMessage)
/* harmony export */ });
function isMessage(arg) {
    return typeof arg === 'object' && arg !== null && 'to' in arg && 'from' in arg && 'type' in arg;
}


/***/ }),

/***/ "./packages/core/src/com/service-config.ts":
/*!*************************************************!*\
  !*** ./packages/core/src/com/service-config.ts ***!
  \*************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "multiTenantMethod": () => (/* binding */ multiTenantMethod)
/* harmony export */ });
function multiTenantMethod(method) {
    return (context) => {
        function getArgs([_first, ...rest]) {
            return rest;
        }
        function proxyFunction(...args) {
            if (typeof method === 'function') {
                return method.call(context, ...args);
            }
            throw new Error('No Such function');
        }
        return {
            getArgs,
            proxyFunction,
        };
    };
}


/***/ }),

/***/ "./packages/core/src/com/types.ts":
/*!****************************************!*\
  !*** ./packages/core/src/com/types.ts ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "HOST_REMOVED": () => (/* binding */ HOST_REMOVED)
/* harmony export */ });
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../symbols */ "./packages/core/src/symbols.ts");

const HOST_REMOVED = {
    name: 'HOST_REMOVED',
    addEventListener: () => void 0,
    removeEventListener: () => void 0,
    postMessage: () => void 0,
};


/***/ }),

/***/ "./packages/core/src/com/window-initializer-service.ts":
/*!*************************************************************!*\
  !*** ./packages/core/src/com/window-initializer-service.ts ***!
  \*************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "WindowInitializerService": () => (/* binding */ WindowInitializerService)
/* harmony export */ });
/**
 * Service needed to complete window initialization
 */
class WindowInitializerService {
    oncePageHide(handler) {
        window.addEventListener('pagehide', () => handler(), { once: true });
    }
    getHref() {
        return window.location.href;
    }
}
WindowInitializerService.apiId = 'WindowInitializerService';


/***/ }),

/***/ "./packages/core/src/common-types.ts":
/*!*******************************************!*\
  !*** ./packages/core/src/common-types.ts ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./packages/core/src/communication.feature.ts":
/*!****************************************************!*\
  !*** ./packages/core/src/communication.feature.ts ***!
  \****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _com_hosts_base_host__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./com/hosts/base-host */ "./packages/core/src/com/hosts/base-host.ts");
/* harmony import */ var _com_communication__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./com/communication */ "./packages/core/src/com/communication.ts");
/* harmony import */ var _com_logger_service__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./com/logger-service */ "./packages/core/src/com/logger-service.ts");
/* harmony import */ var _entities_config__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./entities/config */ "./packages/core/src/entities/config.ts");
/* harmony import */ var _entities_env__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./entities/env */ "./packages/core/src/entities/env.ts");
/* harmony import */ var _entities_feature__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./entities/feature */ "./packages/core/src/entities/feature.ts");
/* harmony import */ var _entities_value__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./entities/value */ "./packages/core/src/entities/value.ts");
/* harmony import */ var _entities_slot__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./entities/slot */ "./packages/core/src/entities/slot.ts");
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./symbols */ "./packages/core/src/symbols.ts");
/* harmony import */ var _types__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./types */ "./packages/core/src/types.ts");
/* harmony import */ var _com_window_initializer_service__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./com/window-initializer-service */ "./packages/core/src/com/window-initializer-service.ts");











/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (new _entities_feature__WEBPACK_IMPORTED_MODULE_5__.Feature({
    id: 'COM',
    api: {
        config: _entities_config__WEBPACK_IMPORTED_MODULE_3__.Config.withType().defineEntity({
            id: '',
            loggerSeverity: _types__WEBPACK_IMPORTED_MODULE_9__.LogLevel.DEBUG,
            maxLogMessages: 100,
            topology: {},
            resolvedContexts: {},
        }, (a, b) => ({
            ...a,
            ...b,
            topology: {
                ...a.topology,
                ...b.topology,
            },
            resolvedContexts: {
                ...a.resolvedContexts,
                ...b.resolvedContexts,
            },
            connectedEnvironments: {
                ...a.connectedEnvironments,
                ...b.connectedEnvironments,
            },
        })),
        loggerTransports: _entities_slot__WEBPACK_IMPORTED_MODULE_7__.Slot.withType().defineEntity(_entities_env__WEBPACK_IMPORTED_MODULE_4__.Universal),
        loggerService: _entities_value__WEBPACK_IMPORTED_MODULE_6__.Value.withType().defineEntity(_entities_env__WEBPACK_IMPORTED_MODULE_4__.Universal),
        communication: _entities_value__WEBPACK_IMPORTED_MODULE_6__.Value.withType().defineEntity(_entities_env__WEBPACK_IMPORTED_MODULE_4__.AllEnvironments),
    },
}).setup(_entities_env__WEBPACK_IMPORTED_MODULE_4__.Universal, ({ config: { host, id, topology, maxLogMessages, loggerSeverity, logToConsole, resolvedContexts, publicPath, connectedEnvironments = {}, }, loggerTransports, [_symbols__WEBPACK_IMPORTED_MODULE_8__.RUN_OPTIONS]: runOptions, [_symbols__WEBPACK_IMPORTED_MODULE_8__.ENGINE]: engine, onDispose, }) => {
    var _a;
    const isNode = typeof process !== 'undefined' &&
        !!((_a = process.versions) === null || _a === void 0 ? void 0 : _a.node) &&
        process.title !== 'browser' &&
        // in electron process also have type 'renderer'
        process.type !== 'renderer';
    // iframe gets `instanceId` with top level config
    // webworker gets `instanceId` set into `name` property when initialized as Environment.
    // it can be overridden using top level config.
    // main frame might not have that configured, so we use 'main' fallback for it.
    const comId = id || (host && host.name) || (typeof self !== 'undefined' && self.name) || engine.entryEnvironment.env;
    const comOptions = {
        warnOnSlow: runOptions.has('warnOnSlow'),
        publicPath,
        connectedEnvironments,
    };
    const communication = new _com_communication__WEBPACK_IMPORTED_MODULE_1__.Communication(isNode ? host || new _com_hosts_base_host__WEBPACK_IMPORTED_MODULE_0__.BaseHost() : self, comId, topology, resolvedContexts, isNode, comOptions);
    // manually register window initialization api service to be used during
    // start of managed iframe in packages/core/src/com/initializers/iframe.ts
    communication.registerAPI({ id: _com_window_initializer_service__WEBPACK_IMPORTED_MODULE_10__.WindowInitializerService.apiId }, new _com_window_initializer_service__WEBPACK_IMPORTED_MODULE_10__.WindowInitializerService());
    const loggerService = new _com_logger_service__WEBPACK_IMPORTED_MODULE_2__.LoggerService(loggerTransports, { environment: communication.getEnvironmentId() }, { severity: loggerSeverity, maxLogMessages, logToConsole });
    onDispose(() => communication.dispose());
    return {
        loggerService,
        communication,
    };
}));


/***/ }),

/***/ "./packages/core/src/entities/config.ts":
/*!**********************************************!*\
  !*** ./packages/core/src/entities/config.ts ***!
  \**********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Config": () => (/* binding */ Config)
/* harmony export */ });
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../symbols */ "./packages/core/src/symbols.ts");
/* harmony import */ var _env__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./env */ "./packages/core/src/entities/env.ts");
/* harmony import */ var _input__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./input */ "./packages/core/src/entities/input.ts");
var _a;



class Config extends _input__WEBPACK_IMPORTED_MODULE_2__.FeatureInput {
    static withType() {
        return {
            defineEntity(defaultValue, mergeConfig, visibleAt) {
                return new Config(defaultValue, mergeConfig, visibleAt);
            },
        };
    }
    constructor(defaultValue, mergeConfig = (a, b) => ({ ...a, ...b }), visibleAt = _env__WEBPACK_IMPORTED_MODULE_1__.AllEnvironments) {
        super(_env__WEBPACK_IMPORTED_MODULE_1__.AllEnvironments, visibleAt);
        this.defaultValue = defaultValue;
        this.mergeConfig = mergeConfig;
        this[_a] = true;
    }
    [(_a = _symbols__WEBPACK_IMPORTED_MODULE_0__.CONFIGURABLE, _symbols__WEBPACK_IMPORTED_MODULE_0__.CREATE_RUNTIME)](context, featureID, entityKey) {
        const topConfig = context.getTopLevelConfig(featureID, entityKey);
        return topConfig.reduce((current, next) => {
            return this.mergeConfig(current, next);
        }, this.defaultValue);
    }
    [_symbols__WEBPACK_IMPORTED_MODULE_0__.REGISTER_VALUE](_context, _providedValue, inputValue, _featureID, _entityKey) {
        return inputValue;
    }
}


/***/ }),

/***/ "./packages/core/src/entities/env.ts":
/*!*******************************************!*\
  !*** ./packages/core/src/entities/env.ts ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "AllEnvironments": () => (/* binding */ AllEnvironments),
/* harmony export */   "Environment": () => (/* binding */ Environment),
/* harmony export */   "EnvironmentContext": () => (/* binding */ EnvironmentContext),
/* harmony export */   "SingleEndpointContextualEnvironment": () => (/* binding */ SingleEndpointContextualEnvironment),
/* harmony export */   "Universal": () => (/* binding */ Universal),
/* harmony export */   "globallyProvidingEnvironments": () => (/* binding */ globallyProvidingEnvironments),
/* harmony export */   "normEnvVisibility": () => (/* binding */ normEnvVisibility),
/* harmony export */   "orderedEnvDependencies": () => (/* binding */ orderedEnvDependencies),
/* harmony export */   "testEnvironmentCollision": () => (/* binding */ testEnvironmentCollision)
/* harmony export */ });
/* harmony import */ var _entity_helpers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../entity-helpers */ "./packages/core/src/entity-helpers.ts");

class Environment {
    constructor(env, envType, endpointType, dependencies = []) {
        this.env = env;
        this.envType = envType;
        this.endpointType = endpointType;
        this.dependencies = dependencies;
    }
}
class EnvironmentContext {
    constructor(env, activeEnvironmentName) {
        this.env = env;
        this.activeEnvironmentName = activeEnvironmentName;
    }
}
const Universal = new Environment('<Universal>', 'window', 'multi');
const AllEnvironments = new Environment('<All>', 'window', 'multi');
const globallyProvidingEnvironments = new Set([Universal.env, AllEnvironments.env]);
function orderedEnvDependencies(env) {
    var _a, _b;
    return (_b = (_a = env.dependencies) === null || _a === void 0 ? void 0 : _a.flatMap(orderedEnvDependencies).concat(env.env)) !== null && _b !== void 0 ? _b : [];
}
class SingleEndpointContextualEnvironment extends Environment {
    constructor(env, environments) {
        super(env, 'context', 'single');
        this.environments = environments;
        if (environments.length === 0) {
            throw new Error(`Contextual Environment ${env} initiated without child environments`);
        }
    }
    useContext(contextEnv) {
        return new EnvironmentContext(this.env, contextEnv);
    }
    withContext() {
        return {
            type: (0,_entity_helpers__WEBPACK_IMPORTED_MODULE_0__.runtimeType)(this.env + ' context'),
        };
    }
    getEnvironmentById(id) {
        return this.environments.find(({ env }) => env === id);
    }
}
function normEnvVisibility(envVisibility) {
    const envSet = new Set();
    const extractDependencies = (env) => {
        for (const { env: depEnv, dependencies } of env.dependencies) {
            envSet.add(depEnv);
            dependencies.map(extractDependencies);
        }
    };
    const envs = Array.isArray(envVisibility) ? envVisibility : [envVisibility];
    for (const e of envs) {
        envSet.add(e.env);
        extractDependencies(e);
    }
    return envSet;
}
function testEnvironmentCollision(envVisibility, envSet) {
    const containsEnv = new Set();
    const test = (env) => {
        envSet.has(env) ? containsEnv.add(env) : envSet.add(env);
    };
    if (Array.isArray(envVisibility)) {
        for (const e of envVisibility) {
            test(e.env);
        }
    }
    else if (typeof envVisibility === 'string') {
        test(envVisibility);
    }
    else {
        test(envVisibility.env);
    }
    return [...containsEnv];
}


/***/ }),

/***/ "./packages/core/src/entities/feature.ts":
/*!***********************************************!*\
  !*** ./packages/core/src/entities/feature.ts ***!
  \***********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Feature": () => (/* binding */ Feature),
/* harmony export */   "RuntimeFeature": () => (/* binding */ RuntimeFeature)
/* harmony export */ });
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../symbols */ "./packages/core/src/symbols.ts");
/* harmony import */ var _env__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./env */ "./packages/core/src/entities/env.ts");
/* harmony import */ var _wixc3_patterns__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @wixc3/patterns */ "./node_modules/@wixc3/patterns/dist/esm/set-multi-map.js");
/* harmony import */ var promise_assist__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! promise-assist */ "./node_modules/promise-assist/esm/deferred.js");




const emptyDispose = { dispose: () => undefined };
/**
 * Represents a currently running feature instance.
 **/
class RuntimeFeature {
    constructor(feature, api, dependencies) {
        this.feature = feature;
        this.api = api;
        this.dependencies = dependencies;
        this.running = false;
        this.runHandlers = new _wixc3_patterns__WEBPACK_IMPORTED_MODULE_2__.SetMultiMap();
        this.disposeHandlers = new _wixc3_patterns__WEBPACK_IMPORTED_MODULE_2__.SetMultiMap();
    }
    addRunHandler(fn, envName) {
        this.runHandlers.add(envName, fn);
    }
    addOnDisposeHandler(fn, envName) {
        this.disposeHandlers.add(envName, fn);
    }
    async [_symbols__WEBPACK_IMPORTED_MODULE_0__.RUN](context) {
        if (this.running) {
            return;
        }
        this.running = true;
        const runPromises = [];
        for (const envName of context.referencedEnvs) {
            for (const dep of this.feature.dependencies) {
                runPromises.push(context.runFeature(dep));
            }
            const envRunHandlers = this.runHandlers.get(envName) || [];
            for (const handler of envRunHandlers) {
                runPromises.push(handler());
            }
        }
        await Promise.all(runPromises);
    }
    async [_symbols__WEBPACK_IMPORTED_MODULE_0__.DISPOSE](context) {
        const { entryEnvironment: { env: envName }, } = context;
        if (this.disposing) {
            return this.disposing.promise;
        }
        this.disposing = (0,promise_assist__WEBPACK_IMPORTED_MODULE_3__.deferred)();
        for (const dep of this.feature.dependencies) {
            await context.dispose(dep);
        }
        const featureDisposeHandlers = this.disposeHandlers.get(envName) || new Set();
        for (const handler of featureDisposeHandlers) {
            await handler();
        }
        return this.disposing.resolve();
    }
}
/**
 * Feature instances define an area of functionality of an app.
 * Each has a unique string ID, and may expose a public API containing services and slots.
 * It also contains a list of all dependencies, meaning other Feature instances, to use their APIs.
 *
 * When calling `runEngineApp` and providing it with a Feature[], it uses the definitions
 * to initialize a `RuntimeFeature` for each.
 *
 * @typeParam ID - Unique string identity
 * @typeParam Deps - Dependencies needed by this Feature (to consume their API)
 * @typeParam API - Entities (Slots, Services, etc.) this Feature exposes for other Features to consume.
 * @typeParam EnvironmentContext - Environment-specific APIs consumed by this feature
 */
class Feature {
    /**
     * Define a new feature by providing:
     * - Unique string identifier
     * - API
     * - Dependencies (optional)
     * - Context (optional)
     *
     * This instance will be detected by engine when exported as default, as well as being used
     * by `<feature-name>.<environment-name>.env.ts` files to define the environment specific implementations.
     *
     * @example
     * ```
     * export default new Feature({
     *   id: 'my-feature',
     *   api: { ... },
     * })
     * ```
     */
    constructor(def) {
        /**
         * References `this` without the exact types of `Deps` (making them a generic `Feature[]`).
         * We use `someFeature.asEntity` instead of `someFeature` when we want to avoid typescript
         * inlining these types during inference of `.d.ts` files.
         *
         * Mainly used where a Feature has dependencies:
         * ```ts
         * new Feature({
         *    id: 'someFeature',
         *    dependencies: [anotherFeature.asDependency],
         *    api: { ... },
         * })
         * ```
         */
        this.asDependency = this;
        this.environmentIml = new Set();
        this.setupHandlers = new _wixc3_patterns__WEBPACK_IMPORTED_MODULE_2__.SetMultiMap();
        this.contextHandlers = new Map();
        this.id = def.id;
        this.dependencies = def.dependencies || [];
        this.api = def.api || {};
        this.context = def.context || {};
        this.identifyApis();
    }
    /**
     * Call this to provide the environment specific implementation for a feature.
     *
     * @param env Environment id to implement the api for.
     * @param setupHandler Callback that receives:
     * - Own feature `Slot`s
     * - Dependencies APIs
     * - Context API that is specific to a runtime environment.
     *
     * @returns Implementation for the services defined for this feature on this environment
     */
    setup(env, setupHandler) {
        validateNoDuplicateEnvRegistration(env, this.id, this.environmentIml);
        this.setupHandlers.add(env.env, setupHandler);
        return this;
    }
    /**
     *
     *
     * @param config
     * @returns
     */
    use(config) {
        return [this.id, config];
    }
    setupContext(_env, environmentContext, contextHandler) {
        validateNoDuplicateContextRegistration(environmentContext, this.id, this.contextHandlers);
        this.contextHandlers.set(environmentContext, contextHandler);
        return this;
    }
    [_symbols__WEBPACK_IMPORTED_MODULE_0__.CREATE_RUNTIME](runningEngine) {
        const { features, runOptions, referencedEnvs, entryEnvironment: { env: envName }, } = runningEngine;
        const deps = {};
        const depsApis = {};
        const runningApi = {};
        const inputApi = {};
        const providedAPI = {};
        const environmentContext = {};
        const apiEntries = Object.entries(this.api);
        const feature = new RuntimeFeature(this, runningApi, deps);
        features.set(this, feature);
        for (const dep of this.dependencies) {
            deps[dep.id] = runningEngine.initFeature(dep);
            depsApis[dep.id] = deps[dep.id].api;
        }
        for (const [key, entity] of apiEntries) {
            const provided = entity[_symbols__WEBPACK_IMPORTED_MODULE_0__.CREATE_RUNTIME](runningEngine, this.id, key);
            if (provided !== undefined) {
                inputApi[key] = provided;
            }
        }
        const settingUpFeature = {
            ...inputApi,
            id: this.id,
            run(fn) {
                feature.addRunHandler(fn, envName);
            },
            onDispose(fn) {
                feature.addOnDisposeHandler(fn, envName);
            },
            [_symbols__WEBPACK_IMPORTED_MODULE_0__.RUN_OPTIONS]: runOptions,
            [_symbols__WEBPACK_IMPORTED_MODULE_0__.ENGINE]: runningEngine,
            runningEnvironmentName: envName,
        };
        for (const [key, contextHandler] of this.contextHandlers) {
            environmentContext[key] = { ...emptyDispose, ...contextHandler(depsApis) };
        }
        for (const envName of referencedEnvs) {
            const environmentSetupHandlers = this.setupHandlers.get(envName);
            if (!environmentSetupHandlers) {
                continue;
            }
            for (const setupHandler of environmentSetupHandlers) {
                const featureOutput = setupHandler(settingUpFeature, depsApis, environmentContext);
                if (!featureOutput) {
                    continue;
                }
                for (const [key, value] of Object.entries(featureOutput)) {
                    settingUpFeature[key] = value;
                }
                Object.assign(providedAPI, featureOutput);
            }
        }
        for (const [key, entity] of apiEntries) {
            const registered = entity[_symbols__WEBPACK_IMPORTED_MODULE_0__.REGISTER_VALUE](runningEngine, providedAPI[key], inputApi[key], this.id, key);
            if (registered !== undefined) {
                runningApi[key] = registered;
            }
        }
        return feature;
    }
    identifyApis() {
        for (const [key, api] of Object.entries(this.api)) {
            const entityFn = api[_symbols__WEBPACK_IMPORTED_MODULE_0__.IDENTIFY_API];
            if (entityFn) {
                entityFn.call(api, this.id, key);
            }
        }
    }
}
function validateNoDuplicateEnvRegistration(env, featureId, registered) {
    const hasCollision = (0,_env__WEBPACK_IMPORTED_MODULE_1__.testEnvironmentCollision)(env, registered);
    if (hasCollision.length) {
        const collisions = hasCollision.join(', ');
        throw new Error(`Feature can only have single setup for each environment. ${featureId} Feature already implements: ${collisions}`);
    }
}
function validateNoDuplicateContextRegistration(environmentContext, featureId, contextHandlers) {
    const registeredContext = contextHandlers.get(environmentContext);
    if (registeredContext) {
        throw new Error(`Feature can only have single setupContext for each context id. ${featureId} Feature already implements: ${String(environmentContext)}`);
    }
}


/***/ }),

/***/ "./packages/core/src/entities/index.ts":
/*!*********************************************!*\
  !*** ./packages/core/src/entities/index.ts ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "AllEnvironments": () => (/* reexport safe */ _env__WEBPACK_IMPORTED_MODULE_1__.AllEnvironments),
/* harmony export */   "Config": () => (/* reexport safe */ _config__WEBPACK_IMPORTED_MODULE_0__.Config),
/* harmony export */   "Environment": () => (/* reexport safe */ _env__WEBPACK_IMPORTED_MODULE_1__.Environment),
/* harmony export */   "EnvironmentContext": () => (/* reexport safe */ _env__WEBPACK_IMPORTED_MODULE_1__.EnvironmentContext),
/* harmony export */   "Feature": () => (/* reexport safe */ _feature__WEBPACK_IMPORTED_MODULE_2__.Feature),
/* harmony export */   "FeatureInput": () => (/* reexport safe */ _input__WEBPACK_IMPORTED_MODULE_3__.FeatureInput),
/* harmony export */   "FeatureOutput": () => (/* reexport safe */ _output__WEBPACK_IMPORTED_MODULE_6__.FeatureOutput),
/* harmony export */   "MapRegistry": () => (/* reexport safe */ _map_slot__WEBPACK_IMPORTED_MODULE_4__.MapRegistry),
/* harmony export */   "MapSlot": () => (/* reexport safe */ _map_slot__WEBPACK_IMPORTED_MODULE_4__.MapSlot),
/* harmony export */   "OrderedRegistry": () => (/* reexport safe */ _ordered_slot__WEBPACK_IMPORTED_MODULE_5__.OrderedRegistry),
/* harmony export */   "OrderedSlot": () => (/* reexport safe */ _ordered_slot__WEBPACK_IMPORTED_MODULE_5__.OrderedSlot),
/* harmony export */   "Registry": () => (/* reexport safe */ _slot__WEBPACK_IMPORTED_MODULE_8__.Registry),
/* harmony export */   "RuntimeFeature": () => (/* reexport safe */ _feature__WEBPACK_IMPORTED_MODULE_2__.RuntimeFeature),
/* harmony export */   "Service": () => (/* reexport safe */ _service__WEBPACK_IMPORTED_MODULE_7__.Service),
/* harmony export */   "SingleEndpointContextualEnvironment": () => (/* reexport safe */ _env__WEBPACK_IMPORTED_MODULE_1__.SingleEndpointContextualEnvironment),
/* harmony export */   "Slot": () => (/* reexport safe */ _slot__WEBPACK_IMPORTED_MODULE_8__.Slot),
/* harmony export */   "Universal": () => (/* reexport safe */ _env__WEBPACK_IMPORTED_MODULE_1__.Universal),
/* harmony export */   "globallyProvidingEnvironments": () => (/* reexport safe */ _env__WEBPACK_IMPORTED_MODULE_1__.globallyProvidingEnvironments),
/* harmony export */   "normEnvVisibility": () => (/* reexport safe */ _env__WEBPACK_IMPORTED_MODULE_1__.normEnvVisibility),
/* harmony export */   "orderedEnvDependencies": () => (/* reexport safe */ _env__WEBPACK_IMPORTED_MODULE_1__.orderedEnvDependencies),
/* harmony export */   "testEnvironmentCollision": () => (/* reexport safe */ _env__WEBPACK_IMPORTED_MODULE_1__.testEnvironmentCollision)
/* harmony export */ });
/* harmony import */ var _config__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./config */ "./packages/core/src/entities/config.ts");
/* harmony import */ var _env__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./env */ "./packages/core/src/entities/env.ts");
/* harmony import */ var _feature__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./feature */ "./packages/core/src/entities/feature.ts");
/* harmony import */ var _input__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./input */ "./packages/core/src/entities/input.ts");
/* harmony import */ var _map_slot__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./map-slot */ "./packages/core/src/entities/map-slot.ts");
/* harmony import */ var _ordered_slot__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./ordered-slot */ "./packages/core/src/entities/ordered-slot.ts");
/* harmony import */ var _output__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./output */ "./packages/core/src/entities/output.ts");
/* harmony import */ var _service__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./service */ "./packages/core/src/entities/service.ts");
/* harmony import */ var _slot__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./slot */ "./packages/core/src/entities/slot.ts");











/***/ }),

/***/ "./packages/core/src/entities/input.ts":
/*!*********************************************!*\
  !*** ./packages/core/src/entities/input.ts ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "FeatureInput": () => (/* binding */ FeatureInput)
/* harmony export */ });
/* harmony import */ var _entity_helpers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../entity-helpers */ "./packages/core/src/entity-helpers.ts");
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../symbols */ "./packages/core/src/symbols.ts");


class FeatureInput {
    constructor(providedFrom, visibleAt) {
        this.providedFrom = providedFrom;
        this.visibleAt = visibleAt;
        this.mode = 'input';
        this.type = (0,_entity_helpers__WEBPACK_IMPORTED_MODULE_0__.runtimeType)();
        this.proxyType = (0,_entity_helpers__WEBPACK_IMPORTED_MODULE_0__.runtimeType)();
        this.remoteAccess = false;
    }
    [_symbols__WEBPACK_IMPORTED_MODULE_1__.REGISTER_VALUE](_context, _providedValue, inputValue, _featureID, _entityKey) {
        return inputValue;
    }
}


/***/ }),

/***/ "./packages/core/src/entities/map-slot.ts":
/*!************************************************!*\
  !*** ./packages/core/src/entities/map-slot.ts ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "MapRegistry": () => (/* binding */ MapRegistry),
/* harmony export */   "MapSlot": () => (/* binding */ MapSlot)
/* harmony export */ });
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../symbols */ "./packages/core/src/symbols.ts");
/* harmony import */ var _input__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./input */ "./packages/core/src/entities/input.ts");


class MapRegistry {
    constructor() {
        this.items = new Map();
        this.callbacks = new Set();
    }
    register(key, item) {
        this.items.set(key, item);
        for (const callback of this.callbacks) {
            callback(key, item);
        }
    }
    [Symbol.iterator]() {
        return this.items[Symbol.iterator]();
    }
    subscribe(cb) {
        this.callbacks.add(cb);
    }
    unSubscribe(cb) {
        this.callbacks.delete(cb);
    }
    stream(cb) {
        for (const [key, value] of this) {
            cb(key, value);
        }
        this.subscribe(cb);
        return () => this.unSubscribe(cb);
    }
    asMap() {
        return this.items;
    }
    get(key) {
        return this.items.get(key);
    }
    values() {
        return this.items.values();
    }
}
class MapSlot extends _input__WEBPACK_IMPORTED_MODULE_1__.FeatureInput {
    static withType() {
        return {
            defineEntity(env) {
                return new MapSlot(env, env);
            },
        };
    }
    [_symbols__WEBPACK_IMPORTED_MODULE_0__.CREATE_RUNTIME]() {
        return new MapRegistry();
    }
}


/***/ }),

/***/ "./packages/core/src/entities/ordered-slot.ts":
/*!****************************************************!*\
  !*** ./packages/core/src/entities/ordered-slot.ts ***!
  \****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "OrderedRegistry": () => (/* binding */ OrderedRegistry),
/* harmony export */   "OrderedSlot": () => (/* binding */ OrderedSlot)
/* harmony export */ });
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../symbols */ "./packages/core/src/symbols.ts");
/* harmony import */ var _input__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./input */ "./packages/core/src/entities/input.ts");


function getItemOrder(sortingOrder, item) {
    const index = sortingOrder.indexOf(item);
    return index < 0 ? Infinity : index;
}
function compareAny(a, b) {
    return a < b ? -1 : a > b ? 1 : 0;
}
function composeCompare(f, g) {
    return (a, b) => {
        const r = f(a, b);
        return r || g(a, b);
    };
}
const { hasOwnProperty } = Object.prototype;
function mkCompare(params) {
    let func = (_a, _b) => 0;
    // eslint-disable-next-line @typescript-eslint/no-for-in-array
    for (const p in params) {
        if (hasOwnProperty.call(params, p)) {
            const [key, mode] = params[p];
            if (mode === true) {
                // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
                func = composeCompare(func, (a, b) => compareAny(b[key], a[key]));
            }
            else if (mode === false) {
                // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
                func = composeCompare(func, (a, b) => compareAny(a[key], b[key]));
            }
            else {
                func = composeCompare(func, 
                // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
                (a, b) => getItemOrder(mode, a[key]) - getItemOrder(mode, b[key]));
            }
        }
    }
    return func;
}
class OrderedRegistry {
    constructor() {
        this.items = [];
        this.callbacks = new Set();
        this.compareFunction = (_a, _b) => 0;
    }
    register(item) {
        this.items.push(item);
        this.sortItems();
        for (const callback of this.callbacks) {
            callback(item);
        }
    }
    [Symbol.iterator]() {
        return this.items[Symbol.iterator]();
    }
    subscribe(cb) {
        this.callbacks.add(cb);
    }
    unSubscribe(cb) {
        this.callbacks.delete(cb);
    }
    stream(cb) {
        for (const item of this) {
            cb(item);
        }
        this.subscribe(cb);
        return () => this.unSubscribe(cb);
    }
    setItems(items) {
        this.items = items;
        this.sortItems();
        return this;
    }
    setSortingOrder(order) {
        this.compareFunction = mkCompare(order);
        this.sortItems();
        return this;
    }
    sortItems() {
        this.items.sort(this.compareFunction);
    }
}
class OrderedSlot extends _input__WEBPACK_IMPORTED_MODULE_1__.FeatureInput {
    static withType() {
        return {
            defineEntity(env) {
                return new OrderedSlot(env, env);
            },
        };
    }
    [_symbols__WEBPACK_IMPORTED_MODULE_0__.CREATE_RUNTIME]() {
        return new OrderedRegistry();
    }
}


/***/ }),

/***/ "./packages/core/src/entities/output.ts":
/*!**********************************************!*\
  !*** ./packages/core/src/entities/output.ts ***!
  \**********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "FeatureOutput": () => (/* binding */ FeatureOutput)
/* harmony export */ });
/* harmony import */ var _entity_helpers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../entity-helpers */ "./packages/core/src/entity-helpers.ts");
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../symbols */ "./packages/core/src/symbols.ts");


class FeatureOutput {
    constructor(providedFrom, visibleAt, remoteAccess) {
        this.providedFrom = providedFrom;
        this.visibleAt = visibleAt;
        this.remoteAccess = remoteAccess;
        this.mode = 'output';
        this.type = (0,_entity_helpers__WEBPACK_IMPORTED_MODULE_0__.runtimeType)();
        this.proxyType = (0,_entity_helpers__WEBPACK_IMPORTED_MODULE_0__.runtimeType)();
    }
}


/***/ }),

/***/ "./packages/core/src/entities/service.ts":
/*!***********************************************!*\
  !*** ./packages/core/src/entities/service.ts ***!
  \***********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Service": () => (/* binding */ Service)
/* harmony export */ });
/* harmony import */ var _communication_feature__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../communication.feature */ "./packages/core/src/communication.feature.ts");
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../symbols */ "./packages/core/src/symbols.ts");
/* harmony import */ var _env__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./env */ "./packages/core/src/entities/env.ts");
/* harmony import */ var _output__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./output */ "./packages/core/src/entities/output.ts");




class Service extends _output__WEBPACK_IMPORTED_MODULE_3__.FeatureOutput {
    static withType() {
        return {
            defineEntity(providedFrom) {
                return new Service(providedFrom, providedFrom, false);
            },
        };
    }
    constructor(providedFrom, visibleAt, remoteAccess, options = {}) {
        super(providedFrom, visibleAt, remoteAccess);
        this.providedFrom = providedFrom;
        this.visibleAt = visibleAt;
        this.remoteAccess = remoteAccess;
        this.options = options;
    }
    allowRemoteAccess(options) {
        return new Service(this.providedFrom, _env__WEBPACK_IMPORTED_MODULE_2__.AllEnvironments, true, options);
    }
    [_symbols__WEBPACK_IMPORTED_MODULE_1__.REGISTER_VALUE](runtimeEngine, providedValue, inputValue, featureID, entityKey) {
        if (this.remoteAccess) {
            const { communication } = runtimeEngine.get(_communication_feature__WEBPACK_IMPORTED_MODULE_0__["default"]).api;
            const serviceKey = runtimeEngine.entityID(featureID, entityKey);
            const providedFrom = (0,_env__WEBPACK_IMPORTED_MODULE_2__.normEnvVisibility)(this.providedFrom);
            const localEnv = communication.getEnvironmentName();
            if (providedFrom.has(localEnv) || providedFrom.has(_env__WEBPACK_IMPORTED_MODULE_2__.Universal.env)) {
                if (!providedValue) {
                    throw new Error(`Service is not provided at runtime.
Make sure the environment setup file exists and named correctly: [featureName].[envName].env.[ext]
Service name: ${entityKey}
Feature id: ${featureID}
Environment: ${localEnv}
                        `);
                }
                communication.registerAPI({ id: serviceKey }, providedValue);
                return providedValue;
            }
            // eslint-disable-next-line @typescript-eslint/no-unsafe-return
            return inputValue || this.getApiProxy(runtimeEngine, serviceKey);
        }
        return providedValue;
    }
    [_symbols__WEBPACK_IMPORTED_MODULE_1__.CREATE_RUNTIME](context, featureID, entityKey) {
        if (this.remoteAccess) {
            // eslint-disable-next-line @typescript-eslint/no-unsafe-return
            return this.getApiProxy(context, context.entityID(featureID, entityKey));
        }
    }
    getApiProxy(context, serviceKey) {
        const { communication } = context.get(_communication_feature__WEBPACK_IMPORTED_MODULE_0__["default"]).api;
        const instanceId = getSingleInstanceId(this.providedFrom);
        if (instanceId) {
            return communication.apiProxy({ id: instanceId }, { id: serviceKey }, this.options);
        }
        else {
            return {
                get: (token) => {
                    return communication.apiProxy(token, { id: serviceKey }, this.options);
                },
            };
        }
    }
}
function getSingleInstanceId(providedFrom) {
    if (isSingleInstance(providedFrom)) {
        return providedFrom.env;
    }
}
function isSingleInstance(providedFrom) {
    return (!!providedFrom &&
        providedFrom.endpointType &&
        providedFrom.endpointType === 'single');
}


/***/ }),

/***/ "./packages/core/src/entities/slot.ts":
/*!********************************************!*\
  !*** ./packages/core/src/entities/slot.ts ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Registry": () => (/* binding */ Registry),
/* harmony export */   "Slot": () => (/* binding */ Slot)
/* harmony export */ });
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../symbols */ "./packages/core/src/symbols.ts");
/* harmony import */ var _input__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./input */ "./packages/core/src/entities/input.ts");


class Registry {
    constructor() {
        this.items = [];
        this.callbacks = new Set();
    }
    register(item) {
        this.items.push(item);
        for (const callback of this.callbacks) {
            callback(item);
        }
    }
    [Symbol.iterator]() {
        return this.items[Symbol.iterator]();
    }
    subscribe(cb) {
        this.callbacks.add(cb);
    }
    unSubscribe(cb) {
        this.callbacks.delete(cb);
    }
    asArray() {
        return this.items;
    }
    stream(cb) {
        for (const item of this) {
            cb(item);
        }
        this.subscribe(cb);
        return () => this.unSubscribe(cb);
    }
}
/**
 * Set of user typed values, consumed at any flow that requires this feature.
 *
 * @example
 * Slot.withType<IUser>().defineEntity('main')
 */
class Slot extends _input__WEBPACK_IMPORTED_MODULE_1__.FeatureInput {
    /**
     * Provides the actual interface of each unit of the slot
     */
    static withType() {
        return {
            /**
             * Which env the slot will be assigned to.
             * @param env instance of the environment that the slot will be set upon
             */
            defineEntity(env) {
                return new Slot(env, env);
            },
        };
    }
    [_symbols__WEBPACK_IMPORTED_MODULE_0__.CREATE_RUNTIME]() {
        return new Registry();
    }
}


/***/ }),

/***/ "./packages/core/src/entities/value.ts":
/*!*********************************************!*\
  !*** ./packages/core/src/entities/value.ts ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Value": () => (/* binding */ Value)
/* harmony export */ });
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../symbols */ "./packages/core/src/symbols.ts");
/* harmony import */ var _output__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./output */ "./packages/core/src/entities/output.ts");


class Value extends _output__WEBPACK_IMPORTED_MODULE_1__.FeatureOutput {
    static withType() {
        return {
            defineEntity(providedFrom) {
                return new Value(providedFrom);
            },
        };
    }
    constructor(providedFrom) {
        super(providedFrom, providedFrom, false);
        this.providedFrom = providedFrom;
    }
    [_symbols__WEBPACK_IMPORTED_MODULE_0__.REGISTER_VALUE](_, providedValue) {
        return providedValue;
    }
    [_symbols__WEBPACK_IMPORTED_MODULE_0__.CREATE_RUNTIME]() {
        return;
    }
}


/***/ }),

/***/ "./packages/core/src/entity-helpers.ts":
/*!*********************************************!*\
  !*** ./packages/core/src/entity-helpers.ts ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "runtimeType": () => (/* binding */ runtimeType)
/* harmony export */ });
/**
 * Just a Symbol that is used as any type T at runtime.
 */
function runtimeType(name) {
    return Symbol(name);
}


/***/ }),

/***/ "./packages/core/src/helpers/flatten-tree.ts":
/*!***************************************************!*\
  !*** ./packages/core/src/helpers/flatten-tree.ts ***!
  \***************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "flattenTree": () => (/* binding */ flattenTree),
/* harmony export */   "returnsTrue": () => (/* binding */ returnsTrue)
/* harmony export */ });
const returnsTrue = () => true;
function flattenTree(root, children, predicate = returnsTrue) {
    const results = new Set();
    const visited = new Set();
    const toProcess = [root];
    while (toProcess.length) {
        const node = toProcess.shift();
        if (visited.has(node)) {
            continue;
        }
        visited.add(node);
        if (predicate(node)) {
            results.add(node);
        }
        toProcess.push(...children(node));
    }
    return results;
}


/***/ }),

/***/ "./packages/core/src/helpers/index.ts":
/*!********************************************!*\
  !*** ./packages/core/src/helpers/index.ts ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "flattenTree": () => (/* reexport safe */ _flatten_tree__WEBPACK_IMPORTED_MODULE_0__.flattenTree),
/* harmony export */   "injectScript": () => (/* reexport safe */ _web__WEBPACK_IMPORTED_MODULE_1__.injectScript),
/* harmony export */   "returnsTrue": () => (/* reexport safe */ _flatten_tree__WEBPACK_IMPORTED_MODULE_0__.returnsTrue),
/* harmony export */   "serializeError": () => (/* reexport safe */ _serialize_error__WEBPACK_IMPORTED_MODULE_2__.serializeError)
/* harmony export */ });
/* harmony import */ var _flatten_tree__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./flatten-tree */ "./packages/core/src/helpers/flatten-tree.ts");
/* harmony import */ var _web__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./web */ "./packages/core/src/helpers/web.ts");
/* harmony import */ var _serialize_error__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./serialize-error */ "./packages/core/src/helpers/serialize-error.ts");





/***/ }),

/***/ "./packages/core/src/helpers/serialize-error.ts":
/*!******************************************************!*\
  !*** ./packages/core/src/helpers/serialize-error.ts ***!
  \******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "serializeError": () => (/* binding */ serializeError)
/* harmony export */ });
function serializeError(error) {
    if (error instanceof Error) {
        return {
            // Custom properties
            ...error,
            // Non-enumerable properties, can't be added via spread
            name: error.name,
            message: error.message,
            stack: error.stack,
        };
    }
    return {
        name: 'Error',
        message: typeof error === 'string' ? error : JSON.stringify(error),
    };
}


/***/ }),

/***/ "./packages/core/src/helpers/web.ts":
/*!******************************************!*\
  !*** ./packages/core/src/helpers/web.ts ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "injectScript": () => (/* binding */ injectScript)
/* harmony export */ });
function injectScript(win, rootComId, scriptUrl) {
    return new Promise((res, rej) => {
        // This is the contract of the communication to get the root communication id
        win.name = rootComId;
        const scriptEl = win.document.createElement('script');
        scriptEl.src = scriptUrl;
        scriptEl.onload = () => res(win);
        scriptEl.onerror = (e) => rej(e);
        win.document.head.appendChild(scriptEl);
    });
}


/***/ }),

/***/ "./packages/core/src/run-engine-app.ts":
/*!*********************************************!*\
  !*** ./packages/core/src/run-engine-app.ts ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "FeatureLoadersRegistry": () => (/* binding */ FeatureLoadersRegistry),
/* harmony export */   "canAccessWindow": () => (/* binding */ canAccessWindow),
/* harmony export */   "getFeaturesDeep": () => (/* binding */ getFeaturesDeep),
/* harmony export */   "getTopWindow": () => (/* binding */ getTopWindow),
/* harmony export */   "run": () => (/* binding */ run),
/* harmony export */   "runEngineApp": () => (/* binding */ runEngineApp)
/* harmony export */ });
/* harmony import */ var _communication_feature__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./communication.feature */ "./packages/core/src/communication.feature.ts");
/* harmony import */ var _runtime_engine__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./runtime-engine */ "./packages/core/src/runtime-engine.ts");
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./helpers */ "./packages/core/src/helpers/index.ts");
/* harmony import */ var promise_assist__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! promise-assist */ "./node_modules/promise-assist/esm/deferred.js");




function run({ entryFeature, topLevelConfig = [], env, runOptions, }) {
    return new _runtime_engine__WEBPACK_IMPORTED_MODULE_1__.RuntimeEngine(env, topLevelConfig, runOptions).run(entryFeature);
}
const getFeaturesDeep = (feature) => (0,_helpers__WEBPACK_IMPORTED_MODULE_2__.flattenTree)(feature, (f) => f.dependencies);
function runEngineApp({ config = [], options, env, publicPath, features = [], resolvedContexts = {}, }) {
    const engine = new _runtime_engine__WEBPACK_IMPORTED_MODULE_1__.RuntimeEngine(env, [_communication_feature__WEBPACK_IMPORTED_MODULE_0__["default"].use({ config: { resolvedContexts, publicPath } }), ...config], options);
    const runningPromise = engine.run(features);
    return {
        engine,
        async dispose() {
            await runningPromise;
            for (const feature of features) {
                await engine.dispose(feature);
            }
        },
    };
}
class FeatureLoadersRegistry {
    constructor(featureMapping = new Map(), resolvedContexts = {}) {
        this.featureMapping = featureMapping;
        this.resolvedContexts = resolvedContexts;
        this.pendingLoaderRequests = new Map();
        this.loadedFeatures = new Set();
    }
    register(name, featureLoader) {
        var _a;
        this.featureMapping.set(name, featureLoader);
        (_a = this.pendingLoaderRequests.get(name)) === null || _a === void 0 ? void 0 : _a.resolve(featureLoader);
        this.pendingLoaderRequests.delete(name);
    }
    get(featureName) {
        const featureLoader = this.featureMapping.get(featureName);
        if (featureLoader) {
            return featureLoader;
        }
        let loaderPromise = this.pendingLoaderRequests.get(featureName);
        if (!loaderPromise) {
            loaderPromise = (0,promise_assist__WEBPACK_IMPORTED_MODULE_3__.deferred)();
            this.pendingLoaderRequests.set(featureName, loaderPromise);
        }
        return loaderPromise.promise;
    }
    getRegistered() {
        return [...this.featureMapping.keys()];
    }
    /**
     * returns all features which were actially loaded
     */
    async getLoadedFeatures(rootFeatureName, runtimeOptions = {}) {
        const loaded = [];
        const dependencies = await this.getFeatureDependencies(rootFeatureName);
        for await (const depName of dependencies.reverse()) {
            if (!this.loadedFeatures.has(depName)) {
                this.loadedFeatures.add(depName);
                const loader = this.get(depName);
                loaded.push(loader);
            }
        }
        const featureLoaders = await Promise.all(loaded);
        const allPreloadInitFunctions = [];
        for (const featureLoader of featureLoaders) {
            if (featureLoader.preload) {
                const featureInitFunctions = await featureLoader.preload(this.resolvedContexts);
                if (featureInitFunctions) {
                    allPreloadInitFunctions.push(...featureInitFunctions);
                }
            }
        }
        for (const initFunction of allPreloadInitFunctions) {
            await initFunction(runtimeOptions);
        }
        return Promise.all(featureLoaders.map(({ load }) => load(this.resolvedContexts)));
    }
    /**
     * returns all the dependencies of a feature. doesn't handle duplications
     */
    async getFeatureDependencies(featureName) {
        const dependencies = [featureName];
        const features = [featureName];
        while (features.length) {
            const { depFeatures } = await this.get(features.shift());
            for (const depFeature of depFeatures) {
                if (!dependencies.includes(depFeature)) {
                    dependencies.push(depFeature);
                    features.push(depFeature);
                }
            }
        }
        return dependencies;
    }
}
function getTopWindow(win) {
    while (win.parent && win.parent !== win && canAccessWindow(win.parent)) {
        win = win.parent;
    }
    return win;
}
function canAccessWindow(win) {
    try {
        return typeof win.location.search === 'string';
    }
    catch {
        return false;
    }
}


/***/ }),

/***/ "./packages/core/src/runtime-engine.ts":
/*!*********************************************!*\
  !*** ./packages/core/src/runtime-engine.ts ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "RuntimeEngine": () => (/* binding */ RuntimeEngine)
/* harmony export */ });
/* harmony import */ var _entities__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./entities */ "./packages/core/src/entities/index.ts");
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./symbols */ "./packages/core/src/symbols.ts");


class RuntimeEngine {
    constructor(entryEnvironment, topLevelConfig = [], runOptions = new Map()) {
        this.entryEnvironment = entryEnvironment;
        this.runOptions = runOptions;
        this.features = new Map();
        this.running = false;
        this.topLevelConfigMap = this.createConfigMap(topLevelConfig);
        this.referencedEnvs = new Set([..._entities__WEBPACK_IMPORTED_MODULE_0__.globallyProvidingEnvironments, ...(0,_entities__WEBPACK_IMPORTED_MODULE_0__.orderedEnvDependencies)(entryEnvironment)]);
    }
    get(feature) {
        const runningFeature = this.features.get(feature);
        if (runningFeature) {
            return runningFeature;
        }
        else {
            throw new Error(`missing feature ${feature.id}`);
        }
    }
    async run(features) {
        if (this.running) {
            throw new Error('Engine already running!');
        }
        this.running = true;
        if (!Array.isArray(features)) {
            features = [features];
        }
        for (const feature of features) {
            this.initFeature(feature);
        }
        const runPromises = [];
        for (const feature of features) {
            runPromises.push(this.runFeature(feature));
        }
        await Promise.all(runPromises);
        return this;
    }
    initFeature(feature) {
        let instance = this.features.get(feature);
        if (!instance) {
            instance = feature[_symbols__WEBPACK_IMPORTED_MODULE_1__.CREATE_RUNTIME](this);
        }
        return instance;
    }
    async runFeature(feature) {
        const featureInstance = this.features.get(feature);
        if (!featureInstance) {
            throw new Error('Could not find running feature: ' + feature.id);
        }
        await featureInstance[_symbols__WEBPACK_IMPORTED_MODULE_1__.RUN](this);
    }
    async dispose(feature) {
        const runningFeature = this.features.get(feature);
        if (runningFeature) {
            await runningFeature[_symbols__WEBPACK_IMPORTED_MODULE_1__.DISPOSE](this);
            this.features.delete(feature);
        }
    }
    getTopLevelConfig(featureId, configId) {
        return this.topLevelConfigMap[this.entityID(featureId, configId)] || [];
    }
    entityID(featureId, entityKey) {
        return `${featureId}.${entityKey}`;
    }
    createConfigMap(topLevelConfig) {
        const configMap = {};
        for (const [featureId, multiValue] of topLevelConfig) {
            for (const [configId, value] of Object.entries(multiValue)) {
                const key = this.entityID(featureId, configId);
                configMap[key] = configMap[key] || [];
                configMap[key].push(value);
            }
        }
        return configMap;
    }
}


/***/ }),

/***/ "./packages/core/src/runtime-metadata.feature.ts":
/*!*******************************************************!*\
  !*** ./packages/core/src/runtime-metadata.feature.ts ***!
  \*******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _entities_config__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./entities/config */ "./packages/core/src/entities/config.ts");
/* harmony import */ var _entities_feature__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./entities/feature */ "./packages/core/src/entities/feature.ts");


/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (new _entities_feature__WEBPACK_IMPORTED_MODULE_1__.Feature({
    id: 'runtimeMetadata',
    dependencies: [],
    api: {
        engineerMetadataConfig: new _entities_config__WEBPACK_IMPORTED_MODULE_0__.Config({
            applicationPath: '',
        }),
    },
}));


/***/ }),

/***/ "./packages/core/src/symbols.ts":
/*!**************************************!*\
  !*** ./packages/core/src/symbols.ts ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CONFIGURABLE": () => (/* binding */ CONFIGURABLE),
/* harmony export */   "CREATE_RUNTIME": () => (/* binding */ CREATE_RUNTIME),
/* harmony export */   "DISPOSE": () => (/* binding */ DISPOSE),
/* harmony export */   "ENGINE": () => (/* binding */ ENGINE),
/* harmony export */   "IDENTIFY_API": () => (/* binding */ IDENTIFY_API),
/* harmony export */   "REGISTER_VALUE": () => (/* binding */ REGISTER_VALUE),
/* harmony export */   "RUN": () => (/* binding */ RUN),
/* harmony export */   "RUN_OPTIONS": () => (/* binding */ RUN_OPTIONS),
/* harmony export */   "SERVICE_CONFIG": () => (/* binding */ SERVICE_CONFIG)
/* harmony export */ });
const RUN = Symbol.for('__ENGINE__RUN');
const DISPOSE = Symbol.for('__ENGINE__DISPOSE');
const IDENTIFY_API = Symbol.for('__ENGINE__IDENTIFY_API');
const CREATE_RUNTIME = Symbol.for('__ENGINE__CREATE');
const REGISTER_VALUE = Symbol.for('__ENGINE__REGISTER_VALUE');
const SERVICE_CONFIG = Symbol.for('__ENGINE__SERVICE_CONFIG');
const RUN_OPTIONS = Symbol.for('__ENGINE__RUN_OPTIONS');
const ENGINE = Symbol.for('__RUNTIME_ENGINE__');
const CONFIGURABLE = Symbol.for('__ENGINE__CONFIGURABLE');


/***/ }),

/***/ "./packages/core/src/types.ts":
/*!************************************!*\
  !*** ./packages/core/src/types.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "LogLevel": () => (/* binding */ LogLevel)
/* harmony export */ });
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./symbols */ "./packages/core/src/symbols.ts");

const dep = Symbol('');
var LogLevel;
(function (LogLevel) {
    LogLevel[LogLevel["DEBUG"] = 0] = "DEBUG";
    LogLevel[LogLevel["INFO"] = 1] = "INFO";
    LogLevel[LogLevel["WARN"] = 2] = "WARN";
    LogLevel[LogLevel["ERROR"] = 3] = "ERROR";
})(LogLevel || (LogLevel = {}));


/***/ }),

/***/ "./node_modules/@wixc3/common/dist/esm/chain.js":
/*!******************************************************!*\
  !*** ./node_modules/@wixc3/common/dist/esm/chain.js ***!
  \******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "chain": () => (/* binding */ chain)
/* harmony export */ });
/* harmony import */ var _iterables__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./iterables */ "./node_modules/@wixc3/common/dist/esm/iterables.js");
/* harmony import */ var _objects__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./objects */ "./node_modules/@wixc3/common/dist/esm/objects.js");


function chain(value) {
    const iterable = (value === undefined
        ? []
        : value === null
            ? [null]
            : typeof value === 'object' && Symbol.iterator in value
                ? value
                : [value]);
    return iterable === value ? chainIter(iterable) : chainElement(value);
}
function chainIter(iterable) {
    const toIter = { skip: _iterables__WEBPACK_IMPORTED_MODULE_0__.skip, map: _iterables__WEBPACK_IMPORTED_MODULE_0__.map, flatMap: _iterables__WEBPACK_IMPORTED_MODULE_0__.flatMap, filter: _iterables__WEBPACK_IMPORTED_MODULE_0__.filter, concat: _iterables__WEBPACK_IMPORTED_MODULE_0__.concat, flat: _iterables__WEBPACK_IMPORTED_MODULE_0__.flat, unique: _iterables__WEBPACK_IMPORTED_MODULE_0__.unique, sort: _iterables__WEBPACK_IMPORTED_MODULE_0__.sort };
    const toElm = { join: _iterables__WEBPACK_IMPORTED_MODULE_0__.join, last: _iterables__WEBPACK_IMPORTED_MODULE_0__.last, first: _iterables__WEBPACK_IMPORTED_MODULE_0__.first, isEmpty: _iterables__WEBPACK_IMPORTED_MODULE_0__.isEmpty, size: _iterables__WEBPACK_IMPORTED_MODULE_0__.size, at: _iterables__WEBPACK_IMPORTED_MODULE_0__.at, next: _iterables__WEBPACK_IMPORTED_MODULE_0__.next, prev: _iterables__WEBPACK_IMPORTED_MODULE_0__.prev, find: _iterables__WEBPACK_IMPORTED_MODULE_0__.find, some: _iterables__WEBPACK_IMPORTED_MODULE_0__.some, includes: _iterables__WEBPACK_IMPORTED_MODULE_0__.includes, every: _iterables__WEBPACK_IMPORTED_MODULE_0__.every, reduce: _iterables__WEBPACK_IMPORTED_MODULE_0__.reduce };
    const boundToIter = (0,_objects__WEBPACK_IMPORTED_MODULE_1__.mapValues)(toIter, (v) => (...args) => chainIter(v(iterable, ...args)));
    const boundToElm = (0,_objects__WEBPACK_IMPORTED_MODULE_1__.mapValues)(toElm, (v) => (...args) => chainElement(v(iterable, ...args)));
    return {
        value: iterable,
        iterable,
        ...boundToIter,
        ...boundToElm,
        forEach: (mapping) => {
            (0,_iterables__WEBPACK_IMPORTED_MODULE_0__.forEach)(iterable, mapping);
            return chainIter(iterable);
        },
    };
}
function chainElement(value) {
    const iterable = (value === undefined ? [] : [value]);
    return {
        ...chainIter(iterable),
        value,
    };
}
//# sourceMappingURL=chain.js.map

/***/ }),

/***/ "./node_modules/@wixc3/common/dist/esm/iterables.js":
/*!**********************************************************!*\
  !*** ./node_modules/@wixc3/common/dist/esm/iterables.js ***!
  \**********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "at": () => (/* binding */ at),
/* harmony export */   "concat": () => (/* binding */ concat),
/* harmony export */   "every": () => (/* binding */ every),
/* harmony export */   "filter": () => (/* binding */ filter),
/* harmony export */   "find": () => (/* binding */ find),
/* harmony export */   "first": () => (/* binding */ first),
/* harmony export */   "flat": () => (/* binding */ flat),
/* harmony export */   "flatMap": () => (/* binding */ flatMap),
/* harmony export */   "forEach": () => (/* binding */ forEach),
/* harmony export */   "groupBy": () => (/* binding */ groupBy),
/* harmony export */   "histogram": () => (/* binding */ histogram),
/* harmony export */   "includes": () => (/* binding */ includes),
/* harmony export */   "isEmpty": () => (/* binding */ isEmpty),
/* harmony export */   "isIterable": () => (/* binding */ isIterable),
/* harmony export */   "join": () => (/* binding */ join),
/* harmony export */   "last": () => (/* binding */ last),
/* harmony export */   "map": () => (/* binding */ map),
/* harmony export */   "next": () => (/* binding */ next),
/* harmony export */   "prev": () => (/* binding */ prev),
/* harmony export */   "reduce": () => (/* binding */ reduce),
/* harmony export */   "size": () => (/* binding */ size),
/* harmony export */   "skip": () => (/* binding */ skip),
/* harmony export */   "some": () => (/* binding */ some),
/* harmony export */   "sort": () => (/* binding */ sort),
/* harmony export */   "unique": () => (/* binding */ unique)
/* harmony export */ });
/* harmony import */ var _types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./types */ "./node_modules/@wixc3/common/dist/esm/types.js");

/**
 * Picks the last element of an iterable
 * @returns undefined for null/empty iterable
 */
function last(iterable) {
    let last;
    if (iterable) {
        for (const value of iterable) {
            last = value;
        }
    }
    return last;
}
/**
 * Picks the first element of an iterable
 * @returns undefined for null/empty iterable
 */
function first(iterable) {
    return at(iterable, 0);
}
/**
 * Checks if an iterable is empty
 */
function isEmpty(iterable) {
    for (const _ of iterable) {
        return false;
    }
    return true;
}
/**
 * Evaluate the size of an iterable
 * @returns elements count of iterable, 0 if null
 */
function size(iterable) {
    let size = 0;
    if (iterable) {
        for (const _ of iterable) {
            size++;
        }
    }
    return size;
}
/**
 * Finds element by index, including negative index
 * @see Array.at
 * @returns undefined if invalid index or null iterable
 */
function at(iterable, index) {
    if (iterable) {
        if (index < 0) {
            const iterAsArray = Array.from(iterable);
            return iterAsArray[iterAsArray.length + index];
        }
        let i = 0;
        for (const v of iterable) {
            if (i++ === index) {
                return v;
            }
        }
    }
    return undefined;
}
/**
 * Find the element following an item
 * @returns undefined if item is last or not found
 */
function next(iterable, item) {
    let wasFound = false;
    if (iterable) {
        for (const v of iterable) {
            if (wasFound) {
                return v;
            }
            if (v === item) {
                wasFound = true;
            }
        }
    }
    return undefined;
}
/**
 * Find the element before an item
 * @returns undefined if item is first or not found
 */
function prev(iterable, item) {
    let prev;
    if (iterable) {
        for (const v of iterable) {
            if (v === item) {
                return prev;
            }
            prev = v;
        }
    }
    return undefined;
}
/**
 * Creates iterable of unique elements
 * @param by - an element identifier (hash) function
 */
function* unique(iterable, by = (i) => i) {
    const known = new Set();
    if (iterable) {
        for (const v of iterable) {
            if (!known.has(by(v))) {
                known.add(by(v));
                yield v;
            }
        }
        known.clear();
    }
}
/**
 * Map iterable elements
 * @see Array.map
 */
function* map(iterable, mapFn) {
    if (iterable) {
        for (const v of iterable) {
            yield mapFn(v);
        }
    }
}
/**
 * @see Array.flatMap
 * @returns a mapped, flattened iterables
 */
function* flatMap(iterable, mapFn) {
    yield* flat(map(iterable, mapFn));
}
/**
 * @see Array.filter
 */
function* filter(iterable, predicate) {
    if (iterable) {
        for (const v of iterable) {
            if (predicate(v)) {
                yield v;
            }
        }
    }
}
/**
 * @see Array.concat
 * @returns a concatenated iterable
 */
function* concat(...iterables) {
    for (const v of iterables) {
        if (v) {
            yield* v;
        }
    }
}
/**
 * @see Array.forEach
 */
function forEach(iterable, fn) {
    if (iterable) {
        for (const v of iterable) {
            // eslint-disable-next-line @typescript-eslint/no-unsafe-argument
            fn(v);
        }
    }
}
/**
 * @see Array.find
 * @returns the first element the satisfies the predicate
 */
function find(iterable, predicate) {
    if (iterable) {
        for (const v of iterable) {
            if (predicate(v)) {
                return v;
            }
        }
    }
    return undefined;
}
/**
 * @see Array.includes
 * @returns item is an element of iterable
 */
function includes(iterable, item) {
    return !!find(iterable, (i) => i === item);
}
/**
 * @see Array.some
 * @returns there is an element satisfies the predicate
 */
function some(iterable, predicate) {
    return !!find(iterable, predicate);
}
/**
 * @see Array.every
 * @returns true is all elements satisfy the predicate
 */
function every(iterable, predicate) {
    for (const v of iterable) {
        if (!predicate(v)) {
            return false;
        }
    }
    return true;
}
/**
 * @see Array.flat
 * @param deep - if true, repeat the flattening until all elements are not iterable
 * @returns a flattened iterable,
 *      where elements that are iterable are spread into the result
 */
function* flat(iterable, deep = false) {
    if (iterable) {
        for (const v of iterable) {
            if (isIterable(v)) {
                // @ts-expect-error v is definitely iterable
                yield* deep ? flat(v) : v;
            }
            else {
                yield v;
            }
        }
    }
}
/**
 * Calculate a histogram of iterable elements
 * @returns an histogram map (element=\>count)
 */
function histogram(iterable) {
    const histogram = new Map();
    forEach(iterable, (i) => {
        const count = histogram.get(i) || 0;
        histogram.set(i, count + 1);
    });
    return histogram;
}
/**
 * @returns true if x is iterable
 */
function isIterable(x) {
    return (0,_types__WEBPACK_IMPORTED_MODULE_0__.isDefined)(x) && typeof x === 'object' && Symbol.iterator in x;
}
/**
 * @see Array<T>.sort
 * @param by - comparator, returns a negative value if a should precede b
 */
function sort(iterable, by) {
    return iterable ? [...iterable].sort(by) : [];
}
/**
 * @see Array.reduce
 * @returns reduced object
 */
function reduce(iterable, reducer, initial) {
    let acc = initial;
    if (iterable) {
        for (const item of iterable) {
            acc = reducer(acc, item);
        }
    }
    return acc;
}
/**
 * @see Array.join
 */
function join(iterable, separator) {
    if (!iterable) {
        return '';
    }
    let result = first(iterable) || '';
    let prev = null;
    for (const v of skip(iterable, 1)) {
        if (prev) {
            result = result + separator + prev;
        }
        prev = v;
    }
    if (prev) {
        result = result + separator + prev;
    }
    return result;
}
/**
 * Skips the first elements of an iterable
 */
function* skip(iterable, count) {
    if (iterable) {
        for (const item of iterable) {
            if (count === 0) {
                yield item;
            }
            else {
                count--;
            }
        }
    }
}
/**
 * Groups elements by the value of a property
 * @returns A map of the value to an array of elements
 */
function groupBy(elements, property) {
    return reduce(elements, (acc, element) => {
        const propertyValue = acc.get(element[property]);
        if (propertyValue) {
            propertyValue.push(element);
        }
        else {
            acc.set(element[property], [element]);
        }
        return acc;
    }, new Map());
}
//# sourceMappingURL=iterables.js.map

/***/ }),

/***/ "./node_modules/@wixc3/common/dist/esm/objects.js":
/*!********************************************************!*\
  !*** ./node_modules/@wixc3/common/dist/esm/objects.js ***!
  \********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "awaitRecord": () => (/* binding */ awaitRecord),
/* harmony export */   "defaults": () => (/* binding */ defaults),
/* harmony export */   "exclude": () => (/* binding */ exclude),
/* harmony export */   "getIn": () => (/* binding */ getIn),
/* harmony export */   "isPlainObject": () => (/* binding */ isPlainObject),
/* harmony export */   "mapKeys": () => (/* binding */ mapKeys),
/* harmony export */   "mapObject": () => (/* binding */ mapObject),
/* harmony export */   "mapValues": () => (/* binding */ mapValues),
/* harmony export */   "newMacrotask": () => (/* binding */ newMacrotask),
/* harmony export */   "pick": () => (/* binding */ pick),
/* harmony export */   "remap": () => (/* binding */ remap),
/* harmony export */   "reportError": () => (/* binding */ reportError),
/* harmony export */   "reverseObject": () => (/* binding */ reverseObject)
/* harmony export */ });
/* harmony import */ var promise_assist__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! promise-assist */ "./node_modules/promise-assist/esm/sleep.js");
/* harmony import */ var _chain__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./chain */ "./node_modules/@wixc3/common/dist/esm/chain.js");


function exclude(...excluded) {
    return function (t) {
        for (const item of excluded) {
            if (item === t) {
                return false;
            }
        }
        return true;
    };
}
/**
 * returns an object composed of the picked object properties
 * @example
 * ```ts
 * pick({ a: 1, b: 2 }, ['a']) // => { a: 1 }
 * ```
 */
function pick(record, keys) {
    const subset = {};
    for (const key of keys) {
        subset[key] = record[key];
    }
    return subset;
}
/**
 * Maps key value pairs of a plain object
 */
function mapObject(obj, mapping) {
    return Object.fromEntries(Object.entries(obj).map(mapping));
}
/**
 * Maps values of a plain object
 */
function mapValues(obj, mapping) {
    return Object.fromEntries(Object.entries(obj).map(([k, v]) => [k, mapping(v, k)]));
}
/**
 * Maps values of a plain object
 */
function mapKeys(obj, mapping) {
    return Object.fromEntries(Object.entries(obj).map(([k, v]) => [mapping(k, v), v]));
}
/**
 * Checks that value is a POJO
 */
function isPlainObject(value) {
    return value !== null && typeof value === 'object' && Object.getPrototypeOf(value) === Object.prototype;
}
/**
 * Logs an error
 */
function reportError(ex) {
    // eslint-disable-next-line no-console, @typescript-eslint/no-unsafe-member-access, @typescript-eslint/no-unsafe-call, @typescript-eslint/no-unsafe-return
    console.error(ex);
}
/**
 * Awaits a record of promises, and returns a record of their results.
 */
async function awaitRecord(obj) {
    const out = {};
    for (const [key, promise] of Object.entries(obj)) {
        out[key] = await promise;
    }
    return out;
}
const newMacrotask = () => (0,promise_assist__WEBPACK_IMPORTED_MODULE_0__.sleep)(0);
/**
 * Reverses keys-values of an object, ignoring falsy values.
 * First takes on value collisions.
 * @returns a new object with the values as keys and the keys as values
 * @example
 * ```ts
 * reverseObject({ a: 'y', b: 'z'}) // => { y: 'a', z: 'b' }
 * ```
 */
function reverseObject(obj) {
    const reversedObject = {};
    for (const [key, value] of Object.entries(obj)) {
        if (value) {
            reversedObject[value] || (reversedObject[value] = key);
        }
    }
    return reversedObject;
}
/**
 * Returns an object where missing keys and values/keys
 * that satisfy shouldUseDefault
 * to the value in shouldUseDefault.
 *
 * @example
 * ```ts
 * defaults({}, {a:0}) // => {a:0}
 * defaults({a:1}, {a:0}) // => {a:1}
 * defaults({a:{}}, {a:{b:1}}) // => {a:{b:1}}
 * ```
 * by default, any undefined value will be replaced
 * @param deep - [true] perform a deep comparison
 * @example
 * ```ts
 * defaults({a:{}}, {a:{b:1}}, false) // => {a:{}}
 * ```
 * @param shouldUseDefault - value/key for which shouldUseDefault
 * returns true will be taken from defaultValues,
 * ignoring source.
 * k is provided as a dot separated path
 * @example
 * ```ts
 * defaults({a:{b:1}}, {a:{b:2}}, true, (_,k)=>k==='a.b') // => {a:{b:2}}
 * defaults({a:1}, {a:2}, true, v=>v===1) // => {a:2}
 * ```
 * @returns a new object with merged source and defaultValues
 */
function defaults(_source, _defaultValues, deep = true, shouldUseDefault = (v, _key) => v === undefined) {
    const parseObj = (src, dft, parentKey = '') => {
        if (isPlainObject(src)) {
            const result = {};
            for (const [key, value] of Object.entries(src)) {
                const fullKey = (parentKey ? parentKey + '.' : '') + key;
                const _default = isPlainObject(dft) ? dft[key] : undefined;
                if (shouldUseDefault(value, fullKey)) {
                    result[key] = _default;
                }
                else {
                    result[key] = deep ? parseObj(value, _default, fullKey) : value;
                }
            }
            if (isPlainObject(dft)) {
                for (const [key, _default] of Object.entries(dft)) {
                    if (!(key in src)) {
                        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
                        result[key] = _default;
                    }
                }
            }
            return result;
        }
        else {
            // @ts-expect-error non object values should only affect type when misused
            return shouldUseDefault(src) ? dft : src;
        }
    };
    return parseObj(_source, _defaultValues);
}
/**
 * @param obj - The object to query
 * @param path - The path of the property to get.
 * @returns The value at `path` of `object` id exists, `undefined` otherwise
 * @example
 * ```ts
 * getIn({ a: { b: 'c' } }, ['a', 'b']) // => c
 * ```
 */
function getIn(obj, path) {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-return
    return path.reduce((value, key) => value === null || value === void 0 ? void 0 : value[key], obj);
}
const DELETE = Symbol();
/**
 * remaps keys of obj based on rename map object,
 * @param rename - key:key name in obj, value: new name (string) OR remap.DELETE
 * @returns
 */
const remap = (obj, rename) => Object.fromEntries((0,_chain__WEBPACK_IMPORTED_MODULE_1__.chain)(Object.entries(obj))
    // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
    .filter(([key]) => rename[key] !== remap.DELETE)
    .map(([key, value]) => 
// eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
[rename[key] || key, value]).iterable);
// @ts-expect-error setting the DELETE const
remap.DELETE = DELETE;
//# sourceMappingURL=objects.js.map

/***/ }),

/***/ "./node_modules/@wixc3/common/dist/esm/types.js":
/*!******************************************************!*\
  !*** ./node_modules/@wixc3/common/dist/esm/types.js ***!
  \******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "isDefined": () => (/* binding */ isDefined),
/* harmony export */   "isMap": () => (/* binding */ isMap),
/* harmony export */   "isSet": () => (/* binding */ isSet),
/* harmony export */   "toMap": () => (/* binding */ toMap)
/* harmony export */ });
/**
 * Validates s is an instance of Map
 * @returns true if s is a Map
 */
const isMap = (m) => m instanceof Map;
/**
 * Validates s is an instance of Set
 * @returns true if s is a Set
 */
const isSet = (s) => s instanceof Set;
/**
 * Given a value of type Nullable<T>, validates value is T
 * @returns true if value is defined (not null or undefined)
 */
function isDefined(value) {
    return value !== null && value !== undefined;
}
/**
 * Coverts and object into a Map
 * @param obj - POJO
 * @returns A map with the same entries as obj
 */
const toMap = (obj) => new Map(Object.entries(obj));
//# sourceMappingURL=types.js.map

/***/ }),

/***/ "./node_modules/@wixc3/patterns/dist/esm/event-emitter.js":
/*!****************************************************************!*\
  !*** ./node_modules/@wixc3/patterns/dist/esm/event-emitter.js ***!
  \****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "EventEmitter": () => (/* binding */ EventEmitter)
/* harmony export */ });
/* harmony import */ var _signal__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./signal */ "./node_modules/@wixc3/patterns/dist/esm/signal.js");

/**
 * A simple event emitter
 */
class EventEmitter {
    constructor() {
        this.events = new Map();
        this.emitOnce = new Map();
        /**
         * Check if an event has subscribers
         * @returns true if event has subscribers
         */
        this.hasSubscribers = (event) => this.events.has(event);
        /**
         * Subscribe a handler for event
         */
        this.subscribe = (event, handler) => {
            const bucket = this.events.get(event);
            bucket ? bucket.add(handler) : this.events.set(event, new _signal__WEBPACK_IMPORTED_MODULE_0__.Signal([handler]));
        };
        /**
         * {@inheritDoc EventEmitter.subscribe}
         */
        this.on = this.subscribe;
        /**
         * Adds a handler that will be called at most once
         */
        this.once = (event, handler) => {
            this.off(event, handler);
            const bucket = this.emitOnce.get(event);
            bucket ? bucket.add(handler) : this.emitOnce.set(event, new _signal__WEBPACK_IMPORTED_MODULE_0__.Signal([handler]));
        };
        /**
         * Unsubscribe a handler from event
         */
        this.unsubscribe = (event, handler) => {
            let bucket = this.events.get(event);
            bucket === null || bucket === void 0 ? void 0 : bucket.delete(handler);
            (bucket === null || bucket === void 0 ? void 0 : bucket.size) === 0 && this.events.delete(event);
            bucket = this.emitOnce.get(event);
            bucket === null || bucket === void 0 ? void 0 : bucket.delete(handler);
            (bucket === null || bucket === void 0 ? void 0 : bucket.size) === 0 && this.events.delete(event);
        };
        /**
         * {@inheritDoc EventEmitter.unsubscribe}
         */
        this.off = this.unsubscribe;
        /**
         * Drop all subscriptions of a signal
         * @param event - signal id
         */
        this.delete = (event) => {
            this.events.delete(event);
            this.emitOnce.delete(event);
        };
        /**
         * Drop all subscriptions
         */
        this.clear = () => {
            this.events = new Map();
            this.emitOnce = new Map();
        };
        /**
         * {@inheritDoc Signal.notify}
         * @param event - eve
         * @param data - event data
         */
        this.notify = (event, data) => {
            var _a, _b;
            (_a = this.events.get(event)) === null || _a === void 0 ? void 0 : _a.notify(data);
            (_b = this.emitOnce.get(event)) === null || _b === void 0 ? void 0 : _b.notify(data);
            this.emitOnce.delete(event);
        };
        /**
         * {@inheritDoc EventEmitter.notify}
         */
        this.emit = this.notify;
    }
}
//# sourceMappingURL=event-emitter.js.map

/***/ }),

/***/ "./node_modules/@wixc3/patterns/dist/esm/set-multi-map.js":
/*!****************************************************************!*\
  !*** ./node_modules/@wixc3/patterns/dist/esm/set-multi-map.js ***!
  \****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "SetMultiMap": () => (/* binding */ SetMultiMap),
/* harmony export */   "isSetMultiMap": () => (/* binding */ isSetMultiMap)
/* harmony export */ });
/* harmony import */ var _wixc3_common__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wixc3/common */ "./node_modules/@wixc3/common/dist/esm/iterables.js");
/* harmony import */ var _wixc3_common__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wixc3/common */ "./node_modules/@wixc3/common/dist/esm/chain.js");

/**
 * Maps keys to a set of values
 * @example
 * ```ts
 * const m = new SetMultiMap([['a',1],['a',2]])
 * m.add('a',3)
 * m.has('a',1) // => true
 * m.has('a',2) // => true
 * m.has('a',3) // => true
 * m.has('a',4) // => false
 * ```
 */
class SetMultiMap {
    constructor(entries) {
        this.map = new Map();
        (0,_wixc3_common__WEBPACK_IMPORTED_MODULE_0__.forEach)(entries, ([key, val]) => {
            this.add(key, val);
        });
    }
    get size() {
        return (0,_wixc3_common__WEBPACK_IMPORTED_MODULE_1__.chain)(this.map)
            .map(([_, { size }]) => size)
            .reduce((sum, size) => sum + size, 0).value;
    }
    get(key) {
        return this.map.get(key);
    }
    add(key, value) {
        const valueSet = this.map.get(key);
        if (valueSet) {
            valueSet.add(value);
        }
        else {
            this.map.set(key, new Set([value]));
        }
        return this;
    }
    clear() {
        this.map.clear();
    }
    delete(key, value) {
        const valueSet = this.map.get(key);
        if (valueSet) {
            const wasInSet = valueSet.delete(value);
            if (valueSet.size === 0) {
                this.map.delete(key);
            }
            return wasInSet;
        }
        return false;
    }
    deleteKey(key) {
        return this.map.delete(key);
    }
    has(key, value) {
        const valueSet = this.map.get(key);
        return valueSet ? valueSet.has(value) : false;
    }
    hasKey(key) {
        const existingSet = this.map.get(key);
        return !!existingSet && existingSet.size > 0;
    }
    [Symbol.iterator]() {
        return this.entries();
    }
    *entries() {
        const { map } = this;
        for (const [key, valueSet] of map.entries()) {
            for (const value of valueSet) {
                yield [key, value];
            }
        }
    }
    *values() {
        const { map } = this;
        for (const valueSet of map.values()) {
            yield* valueSet.values();
        }
    }
    keys() {
        return this.map.keys();
    }
}
function isSetMultiMap(x) {
    return x instanceof (SetMultiMap);
}
//# sourceMappingURL=set-multi-map.js.map

/***/ }),

/***/ "./node_modules/@wixc3/patterns/dist/esm/signal.js":
/*!*********************************************************!*\
  !*** ./node_modules/@wixc3/patterns/dist/esm/signal.js ***!
  \*********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Signal": () => (/* binding */ Signal)
/* harmony export */ });
/**
 * Signal is a simple event emitter for one type of event.

 * @example
 * ```ts
 * const foodArrived = new Signal<Food>();
 *
 * foodArrived.subscribe(() => {
 *   console.log('Food arrived!');
 * });
 *
 * foodArrived.notify(new Food('pizza'));
 * ```
 *
 * @example Usage in a class:
 * ```ts
 * class LoginService {
 *     public onLoginSuccess = new Signal<User>();
 *     public onLoginFailure = new Signal<Error>();
 *     public onLoginStatusChange = new Signal<Status>();
 * }
 * ```
 * @remarks
 * Use Signals a public api for emitting events.
 * Naming a signal is like naming the event the it triggers.
 * If the name sounds like a property try to add a `on` prefix or `Change/Signal` suffix.
 * All methods are bound to the Signal instance
 *
 * Notice that the Signals are public.
 * We don't need to implement specific subscriptions on the class, unless we need to expose it as a remote service.
 */
class Signal extends Set {
    constructor() {
        super(...arguments);
        /**
         * Subscribe a notification callback
         * @param handler - Will be executed with a data arg when a notification occurs
         */
        this.subscribe = (handler) => {
            this.add(handler);
        };
        /**
         * Unsubscribe an existing callback
         */
        this.unsubscribe = (handler) => {
            this.delete(handler);
        };
        /**
         * Notify all subscribers with arg data
         */
        this.notify = (data) => {
            for (const handler of this) {
                handler(data);
            }
        };
    }
}
/**
 * Basic type safe event emitter

 * @example
 * ```ts
 * const ms = new EventEmitter<{ onChange: { id: 'onChange' }; onDelete: { id: 'onDelete' } }>();
 * ms.subscribe('onChange', (event) => {
 *    event.id; // 'onChange'
 * });
 * ms.subscribe('onDelete', (event) => {
 *   event.id; // 'onDelete'
 * });
 *
 * ms.notify('onChange', { id: 'onChange' }); // event is type safe
 * ```
 * @example <caption>payload type mismatch</caption>
 * ```ts
 * ms.notify('onChange', { id: 'onDelete' }); // ERROR!!!
 * ```
 * @example <caption>payload type mismatch</caption>
 * ```ts
 * ms.notify('onSomethingElse', { id: 'onDelete' }); // ERROR!!!
 * ```
 */
//# sourceMappingURL=signal.js.map

/***/ }),

/***/ "./node_modules/promise-assist/esm/deferred.js":
/*!*****************************************************!*\
  !*** ./node_modules/promise-assist/esm/deferred.js ***!
  \*****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "deferred": () => (/* binding */ deferred)
/* harmony export */ });
/**
 * Creates a deferred Promise, where resolve/reject
 * are exposed to the place that holds the promise.
 *
 * Generally bad practice, but there are use-cases where one mixes
 * callback-based API with Promise API and this is helpful.
 */
function deferred() {
    let resolve;
    let reject;
    const promise = new Promise((res, rej) => {
        resolve = res;
        reject = rej;
    });
    return { promise, resolve, reject };
}
//# sourceMappingURL=deferred.js.map

/***/ }),

/***/ "./node_modules/promise-assist/esm/sleep.js":
/*!**************************************************!*\
  !*** ./node_modules/promise-assist/esm/sleep.js ***!
  \**************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "sleep": () => (/* binding */ sleep)
/* harmony export */ });
/**
 * Creates a delayed Promise that resolves
 * after waiting the provided ms
 *
 * @param ms milliseconds to wait before resolving the Promise
 */
function sleep(ms) {
    return new Promise((resolve) => setTimeout(resolve, ms));
}
//# sourceMappingURL=sleep.js.map

/***/ }),

/***/ "socket.io-client":
/*!********************************************************************************************************************!*\
  !*** external {"commonjs":"socket.io-client","commonjs2":"socket.io-client","amd":"socket.io-client","root":"io"} ***!
  \********************************************************************************************************************/
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE_socket_io_client__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
/*!************************************!*\
  !*** ./packages/core/src/index.ts ***!
  \************************************/
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "AllEnvironments": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.AllEnvironments),
/* harmony export */   "BaseHost": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.BaseHost),
/* harmony export */   "CALLBACK_TIMEOUT": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.CALLBACK_TIMEOUT),
/* harmony export */   "COM": () => (/* reexport safe */ _communication_feature__WEBPACK_IMPORTED_MODULE_9__["default"]),
/* harmony export */   "CONFIGURABLE": () => (/* reexport safe */ _symbols__WEBPACK_IMPORTED_MODULE_7__.CONFIGURABLE),
/* harmony export */   "CREATE_RUNTIME": () => (/* reexport safe */ _symbols__WEBPACK_IMPORTED_MODULE_7__.CREATE_RUNTIME),
/* harmony export */   "Communication": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.Communication),
/* harmony export */   "Config": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.Config),
/* harmony export */   "DISPOSE": () => (/* reexport safe */ _symbols__WEBPACK_IMPORTED_MODULE_7__.DISPOSE),
/* harmony export */   "DUPLICATE_REGISTER": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.DUPLICATE_REGISTER),
/* harmony export */   "ENGINE": () => (/* reexport safe */ _symbols__WEBPACK_IMPORTED_MODULE_7__.ENGINE),
/* harmony export */   "ENV_DISCONNECTED": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.ENV_DISCONNECTED),
/* harmony export */   "Environment": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.Environment),
/* harmony export */   "EnvironmentContext": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.EnvironmentContext),
/* harmony export */   "EventEmitterHost": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.EventEmitterHost),
/* harmony export */   "Feature": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.Feature),
/* harmony export */   "FeatureInput": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.FeatureInput),
/* harmony export */   "FeatureLoadersRegistry": () => (/* reexport safe */ _run_engine_app__WEBPACK_IMPORTED_MODULE_5__.FeatureLoadersRegistry),
/* harmony export */   "FeatureOutput": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.FeatureOutput),
/* harmony export */   "GLOBAL_REF": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.GLOBAL_REF),
/* harmony export */   "HOST_REMOVED": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.HOST_REMOVED),
/* harmony export */   "IDENTIFY_API": () => (/* reexport safe */ _symbols__WEBPACK_IMPORTED_MODULE_7__.IDENTIFY_API),
/* harmony export */   "INSTANCE_ID_PARAM_NAME": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.INSTANCE_ID_PARAM_NAME),
/* harmony export */   "LogLevel": () => (/* reexport safe */ _types__WEBPACK_IMPORTED_MODULE_8__.LogLevel),
/* harmony export */   "LoggerService": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.LoggerService),
/* harmony export */   "MISSING_COM_CONTEXT": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.MISSING_COM_CONTEXT),
/* harmony export */   "MISSING_CONTEXT_FOR_API_PROXY": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.MISSING_CONTEXT_FOR_API_PROXY),
/* harmony export */   "MISSING_ENV": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.MISSING_ENV),
/* harmony export */   "MISSING_FORWARD_FOR_MESSAGE": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.MISSING_FORWARD_FOR_MESSAGE),
/* harmony export */   "MapRegistry": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.MapRegistry),
/* harmony export */   "MapSlot": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.MapSlot),
/* harmony export */   "MultiCounter": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.MultiCounter),
/* harmony export */   "OrderedRegistry": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.OrderedRegistry),
/* harmony export */   "OrderedSlot": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.OrderedSlot),
/* harmony export */   "REGISTER_VALUE": () => (/* reexport safe */ _symbols__WEBPACK_IMPORTED_MODULE_7__.REGISTER_VALUE),
/* harmony export */   "REMOTE_CALL_FAILED": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.REMOTE_CALL_FAILED),
/* harmony export */   "RUN": () => (/* reexport safe */ _symbols__WEBPACK_IMPORTED_MODULE_7__.RUN),
/* harmony export */   "RUN_OPTIONS": () => (/* reexport safe */ _symbols__WEBPACK_IMPORTED_MODULE_7__.RUN_OPTIONS),
/* harmony export */   "Registry": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.Registry),
/* harmony export */   "RuntimeEngine": () => (/* reexport safe */ _runtime_engine__WEBPACK_IMPORTED_MODULE_6__.RuntimeEngine),
/* harmony export */   "RuntimeFeature": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.RuntimeFeature),
/* harmony export */   "RuntimeMetadata": () => (/* reexport safe */ _runtime_metadata_feature__WEBPACK_IMPORTED_MODULE_10__["default"]),
/* harmony export */   "SERVICE_CONFIG": () => (/* reexport safe */ _symbols__WEBPACK_IMPORTED_MODULE_7__.SERVICE_CONFIG),
/* harmony export */   "SPAWNED_MORE_THEN_ONCE": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.SPAWNED_MORE_THEN_ONCE),
/* harmony export */   "Service": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.Service),
/* harmony export */   "SingleEndpointContextualEnvironment": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.SingleEndpointContextualEnvironment),
/* harmony export */   "Slot": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.Slot),
/* harmony export */   "UNKNOWN_CALLBACK_ID": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.UNKNOWN_CALLBACK_ID),
/* harmony export */   "Universal": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.Universal),
/* harmony export */   "WindowInitializerService": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.WindowInitializerService),
/* harmony export */   "WsClientHost": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.WsClientHost),
/* harmony export */   "canAccessWindow": () => (/* reexport safe */ _run_engine_app__WEBPACK_IMPORTED_MODULE_5__.canAccessWindow),
/* harmony export */   "declareComEmitter": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.declareComEmitter),
/* harmony export */   "deferredIframeInitializer": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.deferredIframeInitializer),
/* harmony export */   "flattenTree": () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_1__.flattenTree),
/* harmony export */   "getFeaturesDeep": () => (/* reexport safe */ _run_engine_app__WEBPACK_IMPORTED_MODULE_5__.getFeaturesDeep),
/* harmony export */   "getTopWindow": () => (/* reexport safe */ _run_engine_app__WEBPACK_IMPORTED_MODULE_5__.getTopWindow),
/* harmony export */   "globallyProvidingEnvironments": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.globallyProvidingEnvironments),
/* harmony export */   "iframeInitializer": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.iframeInitializer),
/* harmony export */   "initializeContextualEnv": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.initializeContextualEnv),
/* harmony export */   "injectScript": () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_1__.injectScript),
/* harmony export */   "ipcInitializer": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.ipcInitializer),
/* harmony export */   "isIframe": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.isIframe),
/* harmony export */   "isMessage": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.isMessage),
/* harmony export */   "isWindow": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.isWindow),
/* harmony export */   "isWorkerContext": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.isWorkerContext),
/* harmony export */   "multiTenantMethod": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.multiTenantMethod),
/* harmony export */   "normEnvVisibility": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.normEnvVisibility),
/* harmony export */   "orderedEnvDependencies": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.orderedEnvDependencies),
/* harmony export */   "reportError": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.reportError),
/* harmony export */   "returnsTrue": () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_1__.returnsTrue),
/* harmony export */   "run": () => (/* reexport safe */ _run_engine_app__WEBPACK_IMPORTED_MODULE_5__.run),
/* harmony export */   "runEngineApp": () => (/* reexport safe */ _run_engine_app__WEBPACK_IMPORTED_MODULE_5__.runEngineApp),
/* harmony export */   "runtimeType": () => (/* reexport safe */ _entity_helpers__WEBPACK_IMPORTED_MODULE_4__.runtimeType),
/* harmony export */   "serializeError": () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_1__.serializeError),
/* harmony export */   "socketClientInitializer": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.socketClientInitializer),
/* harmony export */   "testEnvironmentCollision": () => (/* reexport safe */ _entities__WEBPACK_IMPORTED_MODULE_2__.testEnvironmentCollision),
/* harmony export */   "webWorkerInitializer": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.webWorkerInitializer),
/* harmony export */   "windowInitializer": () => (/* reexport safe */ _com__WEBPACK_IMPORTED_MODULE_0__.windowInitializer)
/* harmony export */ });
/* harmony import */ var _com__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./com */ "./packages/core/src/com/index.ts");
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./helpers */ "./packages/core/src/helpers/index.ts");
/* harmony import */ var _entities__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./entities */ "./packages/core/src/entities/index.ts");
/* harmony import */ var _common_types__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./common-types */ "./packages/core/src/common-types.ts");
/* harmony import */ var _entity_helpers__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./entity-helpers */ "./packages/core/src/entity-helpers.ts");
/* harmony import */ var _run_engine_app__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./run-engine-app */ "./packages/core/src/run-engine-app.ts");
/* harmony import */ var _runtime_engine__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./runtime-engine */ "./packages/core/src/runtime-engine.ts");
/* harmony import */ var _symbols__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./symbols */ "./packages/core/src/symbols.ts");
/* harmony import */ var _types__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./types */ "./packages/core/src/types.ts");
/* harmony import */ var _communication_feature__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./communication.feature */ "./packages/core/src/communication.feature.ts");
/* harmony import */ var _runtime_metadata_feature__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./runtime-metadata.feature */ "./packages/core/src/runtime-metadata.feature.ts");
















})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});
//# sourceMappingURL=engine-core.js.map