"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.runIPCEnvironment = void 0;
const engine_core_1 = require("@wixc3/engine-core");
const engine_core_node_1 = require("@wixc3/engine-core-node");
const node_environment_1 = require("./node-environment");
async function runIPCEnvironment(options) {
    var _a;
    const disposeHandlers = new Set();
    const host = new engine_core_node_1.IPCHost(process);
    disposeHandlers.add(() => host.dispose());
    const config = [
        ...((_a = options.config) !== null && _a !== void 0 ? _a : []),
        engine_core_1.COM.use({
            config: {
                connectedEnvironments: {
                    [options.parentEnvName]: {
                        id: options.parentEnvName,
                        host,
                    },
                },
            },
        }),
    ];
    const { dispose } = await (0, node_environment_1.runNodeEnvironment)({
        ...options,
        host,
        config,
    });
    disposeHandlers.add(() => dispose());
    return {
        close: async () => {
            for (const disposeHandler of disposeHandlers) {
                await disposeHandler();
            }
        },
    };
}
exports.runIPCEnvironment = runIPCEnvironment;
//# sourceMappingURL=ipc-environment.js.map