"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const parse_cli_arguments_1 = require("./parse-cli-arguments");
const forked_process_1 = require("./forked-process");
const launch_http_server_1 = require("./launch-http-server");
const process_communication_1 = require("./process-communication");
const { preferredPort, socketServerOptions: socketServerOptionsJson, requiredPaths: requiredPathsJson, _: [providedPath = process.cwd()], } = (0, parse_cli_arguments_1.parseCliArguments)(process.argv.slice(1));
const requiredPaths = JSON.parse(requiredPathsJson);
const socketServerOptions = JSON.parse(socketServerOptionsJson);
const basePath = (0, path_1.resolve)(providedPath);
const httpServerPort = preferredPort ? parseInt(preferredPort, 10) : undefined;
(async () => {
    var _a;
    for (const requiredModule of requiredPaths) {
        try {
            await (_a = require.resolve(requiredModule, { paths: [basePath] }), Promise.resolve().then(() => __importStar(require(_a))));
        }
        catch (ex) {
            throw new Error(`failed requiring: ${requiredModule} ${(ex === null || ex === void 0 ? void 0 : ex.stack) || String(ex)}`);
        }
    }
    const { socketServer, close, port } = await (0, launch_http_server_1.launchEngineHttpServer)({
        staticDirPath: (0, path_1.join)(basePath, 'dist'),
        httpServerPort,
        socketServerOptions,
    });
    const parentProcess = new forked_process_1.ForkedProcess(process);
    (0, process_communication_1.createIPC)(parentProcess, socketServer, { port, onClose: close });
    parentProcess.postMessage({ id: 'initiated' });
})().catch((e) => {
    console.error(e);
    process.exitCode = 1;
});
//# sourceMappingURL=remote-node-entry.js.map