"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.runWSEnvironment = void 0;
const engine_core_node_1 = require("@wixc3/engine-core-node");
const node_environment_1 = require("./node-environment");
function runWSEnvironment(socketServer, startEnvironmentOptions) {
    const socketServerNamespace = socketServer.of(startEnvironmentOptions.name);
    const wsHost = new engine_core_node_1.WsServerHost(socketServerNamespace);
    return {
        start: async () => {
            const runtimeEngine = await (0, node_environment_1.runNodeEnvironment)({
                ...startEnvironmentOptions,
                host: wsHost,
            });
            return {
                runtimeEngine: runtimeEngine.engine,
                close: async () => {
                    wsHost.dispose();
                    await runtimeEngine.dispose();
                },
                host: wsHost,
            };
        },
    };
}
exports.runWSEnvironment = runWSEnvironment;
//# sourceMappingURL=ws-environment.js.map