"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.worker = void 0;
const getMessageData = (message) => {
    if (message instanceof MessageEvent) {
        return message.data;
    }
    return message;
};
class UniversalWorkerUser {
    constructor(self) {
        this.self = self;
    }
    postMessage(message) {
        // transferables are here to support the browser polyfill
        this.self.postMessage(getMessageData(message), message['transferables']);
    }
    addEventListener(type, callback) {
        this.self.addEventListener(type, (e) => {
            callback({
                data: 'data' in e ? e.data : undefined,
                error: 'error' in e ? e.error : undefined,
            });
        });
    }
}
exports.worker = new UniversalWorkerUser(self);
//# sourceMappingURL=browser-worker-scope.js.map