"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.worker = void 0;
const worker_threads_1 = require("worker_threads");
const port = (function getPort() {
    if (!worker_threads_1.parentPort) {
        throw new Error('parentPort required for worker processors');
    }
    return worker_threads_1.parentPort;
})();
class UniversalWorkerUser {
    constructor(portOrWorkerSelf) {
        this.portOrWorkerSelf = portOrWorkerSelf;
        this.workerData = worker_threads_1.workerData;
    }
    postMessage(message) {
        this.portOrWorkerSelf.postMessage(message);
    }
    addEventListener(type, callback) {
        this.portOrWorkerSelf.on(type, function MessageFromNodeWorker(message) {
            callback({ data: message });
        });
    }
}
exports.worker = new UniversalWorkerUser(port);
//# sourceMappingURL=node-worker-scope.js.map