"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Worker = void 0;
const worker_threads_1 = require("worker_threads");
class NodeWorker {
    constructor(url, options) {
        this.worker = new worker_threads_1.Worker(url, options);
    }
    postMessage(message) {
        this.worker.postMessage(message);
    }
    addEventListener(type, callback) {
        this.worker.on(type, (message) => callback({ data: message }));
    }
    terminate() {
        return this.worker.terminate();
    }
}
exports.Worker = NodeWorker;
//# sourceMappingURL=node-worker.js.map