"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findFileUpSync = void 0;
function findFileUpSync(directoryPath, fileName, host) {
    for (const directoryInChain of pathChainToRoot(directoryPath, host.dirname)) {
        const filePath = host.join(directoryInChain, fileName);
        try {
            if (host.statSync(filePath).isFile()) {
                return filePath;
            }
        }
        catch { }
    }
    return;
}
exports.findFileUpSync = findFileUpSync;
function* pathChainToRoot(currentPath, dirname) {
    let lastPath;
    while (lastPath !== currentPath) {
        yield currentPath;
        lastPath = currentPath;
        currentPath = dirname(currentPath);
    }
}
//# sourceMappingURL=find-up.js.map