"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.watchEscape = void 0;
function watchEscape(rootLayer) {
    const onKeyDown = (event) => {
        var _a, _b;
        if (event.key !== `Escape` || event.defaultPrevented || event.repeat) {
            return;
        }
        let stopped = false;
        const wrappedEvent = Object.assign({}, event, {
            stopPropagation() {
                stopped = true;
                event.stopPropagation();
            },
            stopImmediatePropagation() {
                stopped = true;
                event.stopImmediatePropagation();
            },
        });
        const layers = rootLayer.generateDisplayList();
        for (let i = layers.length - 1; i >= 0; --i) {
            if (stopped) {
                return;
            }
            const layer = layers[i];
            (_b = (_a = layer.settings).onEscape) === null || _b === void 0 ? void 0 : _b.call(_a, wrappedEvent);
        }
    };
    window.addEventListener(`keydown`, onKeyDown);
    return {
        stop() {
            window.removeEventListener(`keydown`, onKeyDown);
        },
    };
}
exports.watchEscape = watchEscape;
//# sourceMappingURL=escape.js.map