"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isContainedBy = exports.findContainingLayer = exports.isBrowser = void 0;
exports.isBrowser = typeof window !== 'undefined';
function findContainingLayer(element) {
    let current = element;
    while (current) {
        if (current.tagName === `ZEEJS-LAYER`) {
            return current;
        }
        current = current.parentElement;
    }
    return null;
}
exports.findContainingLayer = findContainingLayer;
function isContainedBy(element, possibleContainer) {
    let current = element;
    while (current) {
        if (current === possibleContainer ||
            current.compareDocumentPosition(possibleContainer) & document.DOCUMENT_POSITION_CONTAINS) {
            return true;
        }
        current = findContainingLayer(current);
        if (!current) {
            return false;
        }
        current = document.querySelector(`[data-origin="${current.id}"]`);
    }
    return false;
}
exports.isContainedBy = isContainedBy;
//# sourceMappingURL=utils.js.map