"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Layer = void 0;
const root_1 = require("./root");
const react_1 = __importStar(require("react"));
const react_dom_1 = __importDefault(require("react-dom"));
// ToDo: handle styling on portal root
const Layer = ({ children, overlap = `window`, backdrop = `none`, onClickOutside, onMouseIntersection, onFocusChange, onEscape, }) => {
    const parentLayer = (0, react_1.useContext)(root_1.zeejsContext);
    const layer = (0, react_1.useMemo)(() => parentLayer.createLayer({
        settings: {
            overlap,
            backdrop,
            onClickOutside,
            onMouseIntersection: () => {
                if (onMouseIntersection) {
                    onMouseIntersection(layer.state.mouseInside);
                }
            },
            onFocusChange: () => {
                if (onFocusChange) {
                    onFocusChange(layer.state.focusInside);
                }
            },
            onEscape: (event) => {
                if (onEscape) {
                    onEscape(event);
                }
            },
        },
    }), []);
    // update 
    layer.settings.onClickOutside = onClickOutside;
    (0, react_1.useEffect)(() => {
        return () => {
            parentLayer.removeLayer(layer);
        };
    }, []);
    return (react_1.default.createElement(root_1.zeejsContext.Provider, { value: layer },
        react_1.default.createElement("zeejs-origin", { tabIndex: 0, "data-origin": layer.id }, layer.element ? react_dom_1.default.createPortal(children, layer.element) : children)));
};
exports.Layer = Layer;
//# sourceMappingURL=layer.js.map