"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TreeItemWithLaneRenderer = exports.calcItemSize = void 0;
const react_1 = __importDefault(require("react"));
const lane_item_renderer_1 = require("../tree-items/lanes/lane-item-renderer");
const element_item_renderer_1 = require("../tree-items/lanes/element-item-renderer");
const marker_item_renderer_1 = require("../tree-items/lanes/marker-item-renderer");
const calcItemSize = (item) => {
    return item.data.kind === 'element'
        ? (0, element_item_renderer_1.calcElementSize)(item)
        : item.data.kind === 'lane'
            ? (0, lane_item_renderer_1.calcLaneSize)(item)
            : (0, marker_item_renderer_1.calcMarkerSize)(item);
};
exports.calcItemSize = calcItemSize;
const TreeItemWithLaneRenderer = (props) => {
    return props.data.kind === 'element' ? (react_1.default.createElement(element_item_renderer_1.ElementRenderer, { ...props })) : props.data.kind === 'lane' ? null : (react_1.default.createElement(marker_item_renderer_1.MarkerRenderer, { ...props }));
};
exports.TreeItemWithLaneRenderer = TreeItemWithLaneRenderer;
//# sourceMappingURL=tree-item-with-lane-renderer.js.map