"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_board_1 = require("@wixc3/react-board");
const react_1 = __importDefault(require("react"));
const board_plugins_1 = require("../../board-plugins");
const data_grid_1 = require("../data-grid");
function cellRenderer(key) {
    const renderer = (props) => {
        return react_1.default.createElement("div", null, props.data[key]);
    };
    renderer.displayName = 'renderer ' + key;
    return renderer;
}
const fNames = ['Shlomo', 'shraga', 'benny', 'zolthar'];
const lNames = ['ben shvili', 'hasarot', 'the destroyer', 'levi'];
function randomFromArr(arr) {
    return arr[Math.floor(Math.random() * arr.length)];
}
const createItems = (count = 1000, from = 0) => {
    return new Array(count).fill('').map((_, idx) => ({
        age: Math.ceil(Math.random() * 120),
        firstName: randomFromArr(fNames),
        lastName: randomFromArr(lNames),
        id: 'a' + (idx + from),
    }));
};
exports.default = (0, react_board_1.createBoard)({
    name: 'Data Grid',
    Board: () => (react_1.default.createElement(data_grid_1.DataGrid, { columns: [
            {
                cellRenderer: cellRenderer('firstName'),
                header: react_1.default.createElement("div", null, "First name"),
                id: 'fName',
            },
            {
                cellRenderer: cellRenderer('lastName'),
                header: react_1.default.createElement("div", null, "Last name"),
                id: 'lastName',
            },
            {
                cellRenderer: cellRenderer('age'),
                header: react_1.default.createElement("div", null, "Age"),
                id: 'age',
            },
        ], columnSizesControl: () => [200, 200, 200], items: createItems(), getId: (item) => item.id, gridRoot: {
            el: 'div',
            props: {
                style: {
                    height: '100%',
                },
            },
        } })),
    plugins: [board_plugins_1.projectThemesPlugin],
    environmentProps: {
        canvasWidth: 461,
        canvasHeight: 400,
        windowHeight: 400,
    },
});
//# sourceMappingURL=data-grid.board.js.map