"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.columnContext = exports.DataGrid = exports.GridRoot = exports.gridRootParent = exports.forwardGridRoot = exports.createGridRoot = exports.gridRoot = exports.GridRootPropMapping = void 0;
const react_1 = __importStar(require("react"));
const use_element_slot_1 = require("../hooks/use-element-slot");
const use_scroll_1 = require("../hooks/use-scroll");
const use_state_controls_1 = require("../hooks/use-state-controls");
const scroll_list_1 = require("../scroll-list/scroll-list");
const data_grid_st_css_1 = require("./data-grid.st.css");
exports.GridRootPropMapping = {
    className: use_element_slot_1.concatClasses,
    style: use_element_slot_1.mergeObjectInternalWins,
};
_a = (0, use_element_slot_1.defineElementSlot)(use_element_slot_1.defaultRoot, exports.GridRootPropMapping), exports.gridRoot = _a.slot, exports.createGridRoot = _a.create, exports.forwardGridRoot = _a.forward, exports.gridRootParent = _a.parentSlot, exports.GridRoot = _a.Slot;
function DataGrid({ columns, scrollListRoot, isHorizontal, gridRoot, columnSizesControl, ...props }) {
    const headerRef = (0, react_1.useRef)(null);
    const scrollListRef = (0, react_1.useRef)(null);
    // const headerSize = useElementDimension(headerRef, isHorizontal, true);
    const [columnSizes, updateColumnSizes] = (0, use_state_controls_1.useStateControls)(columnSizesControl, []);
    const listHorizontalScroll = (0, use_scroll_1.useScroll)({ isHorizontal: true, ref: scrollListRef });
    const listeners = (0, react_1.useRef)(new Set());
    const contextValue = (0, react_1.useMemo)(() => ({
        columns,
        sizes: columnSizes,
    }), [columnSizes, columns]);
    const resizers = (0, react_1.useMemo)(() => columns.map((_col, idx) => (ev) => {
        const resizer = ev.currentTarget;
        const listener = (ev) => {
            const left = resizer.parentElement.getBoundingClientRect().left;
            const newSizes = [...columnSizes];
            newSizes.splice(idx, 1, ev.pageX - left);
            updateColumnSizes(newSizes);
        };
        const endListener = (_ev) => {
            window.removeEventListener('mousemove', listener);
            window.removeEventListener('mouseup', endListener);
        };
        listeners.current.add({ cb: listener, eventName: 'mousemove' });
        listeners.current.add({ cb: endListener, eventName: 'mouseup' });
        window.addEventListener('mousemove', listener);
        window.addEventListener('mouseup', endListener);
    }), [columns, columnSizes, updateColumnSizes]);
    (0, react_1.useEffect)(() => {
        return () => {
            // eslint-disable-next-line react-hooks/exhaustive-deps
            const listen = [...listeners.current];
            for (const { eventName, cb } of listen) {
                window.removeEventListener(eventName, cb);
            }
        };
    }, []);
    return (react_1.default.createElement(exports.columnContext.Provider, { value: contextValue },
        react_1.default.createElement(exports.GridRoot, { slot: gridRoot, props: {
                className: data_grid_st_css_1.classes.root,
                style: {
                    [data_grid_st_css_1.vars.columns]: columnSizes.map((col) => col + 'px').join(' '),
                },
            } },
            react_1.default.createElement("div", { className: data_grid_st_css_1.classes.header, ref: headerRef },
                react_1.default.createElement("div", { className: data_grid_st_css_1.classes.internalHeader, style: {
                        left: -listHorizontalScroll + 'px',
                    } }, columns.map((col, idx) => (react_1.default.createElement("div", { key: col.id, className: data_grid_st_css_1.classes.headerCell },
                    col.header,
                    react_1.default.createElement("div", { className: data_grid_st_css_1.classes.resizer, onMouseDown: resizers[idx] })))))),
            react_1.default.createElement(scroll_list_1.ScrollList, { ...props, ItemRenderer: DataRow, scrollListRoot: (0, scroll_list_1.forwardScrollListRoot)(scrollListRoot, {
                    style: {
                        height: `100%`,
                        overflowY: 'auto',
                    },
                    ref: scrollListRef,
                }), isHorizontal: isHorizontal, scrollWindow: scrollListRef })),
        react_1.default.createElement("div", { style: {
                [data_grid_st_css_1.vars.columns]: columnSizes.map((col) => col + 'px').join(' '),
            }, className: data_grid_st_css_1.classes.root })));
}
exports.DataGrid = DataGrid;
exports.columnContext = (0, react_1.createContext)({
    columns: [],
    sizes: [],
});
function DataRow({ id, ...props }) {
    const { columns } = (0, react_1.useContext)(exports.columnContext);
    return (react_1.default.createElement("div", { "data-id": id, className: data_grid_st_css_1.classes.row }, columns.map((col) => (react_1.default.createElement("div", { key: col.id, className: data_grid_st_css_1.classes.cell },
        react_1.default.createElement(col.cellRenderer, { id: id, ...props }))))));
}
//# sourceMappingURL=data-grid.js.map