"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useScroll = void 0;
const react_1 = require("react");
const use_delayed_update_1 = require("./use-delayed-update");
/** if ref is not supplied use scroll will return the window scroll */
const useScroll = ({ isHorizontal, ref, disabled = false, }) => {
    const trigger = (0, use_delayed_update_1.useDelayedUpdate)();
    (0, react_1.useEffect)(() => {
        if (!disabled) {
            const target = ref ? ref.current : window;
            target === null || target === void 0 ? void 0 : target.addEventListener('scroll', trigger);
            return () => target === null || target === void 0 ? void 0 : target.removeEventListener('scroll', trigger);
        }
        else {
            return;
        }
    }, [disabled, ref, trigger]);
    if (!(ref === null || ref === void 0 ? void 0 : ref.current)) {
        return isHorizontal ? window.scrollX : window.scrollY;
    }
    return (isHorizontal ? ref.current.scrollLeft : ref.current.scrollTop) || 0;
};
exports.useScroll = useScroll;
//# sourceMappingURL=use-scroll.js.map