"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTransmittedCB = void 0;
/* eslint-disable @typescript-eslint/no-unsafe-return */
/* eslint-disable @typescript-eslint/no-unsafe-argument */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
const react_1 = require("react");
function useTransmittedCB() {
    const cbs = (0, react_1.useRef)(new Set()).current;
    const cb = (0, react_1.useCallback)((...args) => {
        let val = undefined;
        for (const cb of cbs) {
            val = cb(...args);
        }
        return val;
    }, [cbs]);
    function useTransmit(cb) {
        cbs.add(cb);
        (0, react_1.useEffect)(() => {
            return () => {
                cbs.delete(cb);
            };
        }, [cb]);
    }
    return { cb, useTransmit };
}
exports.useTransmittedCB = useTransmittedCB;
//# sourceMappingURL=use-transmitted-events.js.map