"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InputWithClear = void 0;
const react_1 = __importStar(require("react"));
const use_state_controls_1 = require("../hooks/use-state-controls");
const icons_1 = require("../icons");
const input_with_clear_st_css_1 = require("./input-with-clear.st.css");
exports.InputWithClear = react_1.default.forwardRef((props, ref) => {
    const defaultRef = (0, react_1.useRef)(null);
    const usedRef = (ref || defaultRef);
    const { valueControl, onKeyDown, ...inputProps } = props;
    const [value, setValue] = (0, use_state_controls_1.useStateControls)(valueControl, '');
    const onClear = (0, react_1.useCallback)(() => {
        setValue('');
    }, [setValue]);
    const onChange = (0, react_1.useCallback)((ev) => {
        setValue(ev.currentTarget.value);
    }, [setValue]);
    const keyDown = (0, react_1.useCallback)((ev) => {
        if (onKeyDown) {
            onKeyDown(ev);
        }
    }, [onKeyDown]);
    return (react_1.default.createElement("div", { className: (0, input_with_clear_st_css_1.st)(input_with_clear_st_css_1.classes.root, props.className), onClick: (0, react_1.useCallback)(() => {
            if (usedRef.current) {
                usedRef.current.focus();
            }
        }, [usedRef]) },
        react_1.default.createElement("input", { ...inputProps, className: input_with_clear_st_css_1.classes.input, value: value, onChange: onChange, onKeyDown: keyDown, ref: usedRef }),
        react_1.default.createElement(icons_1.XIcon, { className: input_with_clear_st_css_1.classes.clear, onClick: onClear })));
});
exports.InputWithClear.displayName = 'InputWithClear';
//# sourceMappingURL=input-with-clear.js.map