"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.List = exports.RootSlot = exports.listRootParent = exports.forwardListRoot = exports.createListRoot = exports.listRoot = exports.ListRootPropMapping = void 0;
const react_1 = __importStar(require("react"));
const use_element_slot_1 = require("../hooks/use-element-slot");
const use_id_based_event_1 = require("../hooks/use-id-based-event");
const use_keyboard_nav_1 = require("../hooks/use-keyboard-nav");
const use_state_controls_1 = require("../hooks/use-state-controls");
exports.ListRootPropMapping = {
    style: use_element_slot_1.mergeObjectInternalWins,
    onClick: use_element_slot_1.callInternalFirst,
    onmousemove: use_element_slot_1.callInternalFirst,
    onKeyPress: use_element_slot_1.callInternalFirst,
    onKeyDown: use_element_slot_1.callInternalFirst,
    tabIndex: use_element_slot_1.preferExternal,
    ref: use_element_slot_1.preferExternal,
};
_a = (0, use_element_slot_1.defineElementSlot)(use_element_slot_1.defaultRoot, exports.ListRootPropMapping), exports.listRoot = _a.slot, exports.createListRoot = _a.create, exports.forwardListRoot = _a.forward, exports.listRootParent = _a.parentSlot, exports.RootSlot = _a.Slot;
function List({ listRoot, selectionControl, focusControl, getId, ItemRenderer, items, transmitKeyPress, onItemMount, onItemUnmount, }) {
    var _a, _b;
    const [selectedId, setSelectedId] = (0, use_state_controls_1.useStateControls)(selectionControl, undefined);
    const [focusedId, setFocusedId] = (0, use_state_controls_1.useStateControls)(focusControl, undefined);
    const defaultRef = (0, react_1.useRef)();
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    const actualRef = ((_a = listRoot === null || listRoot === void 0 ? void 0 : listRoot.props) === null || _a === void 0 ? void 0 : _a.ref) || defaultRef;
    const onMouseMove = (0, use_id_based_event_1.useIdListener)(setFocusedId);
    const onClick = (0, use_id_based_event_1.useIdListener)(setSelectedId);
    const onKeyPress = (0, use_keyboard_nav_1.useIdBasedKeyboardNav)(actualRef, focusedId, setFocusedId, selectedId, setSelectedId);
    if (transmitKeyPress) {
        transmitKeyPress((0, use_element_slot_1.callInternalFirst)(onKeyPress, (_b = listRoot === null || listRoot === void 0 ? void 0 : listRoot.props) === null || _b === void 0 ? void 0 : _b.onKeyPress));
    }
    return (react_1.default.createElement(exports.RootSlot, { slot: listRoot, props: {
            ref: actualRef,
            onMouseMove,
            onClick,
            onKeyPress,
            onKeyDown: onKeyPress,
            tabIndex: 0,
        } }, items.map((item) => {
        const id = getId(item);
        return (react_1.default.createElement(ItemRendererWrapped, { ItemRenderer: ItemRenderer, onMount: onItemMount, onUnmount: onItemUnmount, key: id, id: id, data: item, focus: setFocusedId, isFocused: focusedId === id, isSelected: selectedId === id, select: setSelectedId }));
    })));
}
exports.List = List;
function ItemRendererWrapped({ ItemRenderer, onMount, onUnmount, ...props }) {
    (0, react_1.useEffect)(() => {
        onMount === null || onMount === void 0 ? void 0 : onMount(props.data);
        return () => onUnmount === null || onUnmount === void 0 ? void 0 : onUnmount(props.data);
    }, [onMount, onUnmount, props.data]);
    return react_1.default.createElement(ItemRenderer, { ...props });
}
//# sourceMappingURL=list.js.map