"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_board_1 = require("@wixc3/react-board");
const promise_assist_1 = require("promise-assist");
const react_1 = __importStar(require("react"));
const board_assets_1 = require("../../board-assets");
const board_plugins_1 = require("../../board-plugins");
const scroll_list_1 = require("../scroll-list");
exports.default = (0, react_board_1.createBoard)({
    name: 'ScrollList — infinite scroll',
    Board: () => {
        const [items, updateItems] = (0, react_1.useState)((0, board_assets_1.createItems)());
        const [loadingState, updateLoadingState] = (0, react_1.useState)('idle');
        const loadMore = (0, react_1.useCallback)(async (count) => {
            updateLoadingState('loading');
            await (0, promise_assist_1.sleep)(500);
            updateItems(items.concat((0, board_assets_1.createItems)(count, items.length)));
            updateLoadingState('idle');
        }, [items]);
        return (react_1.default.createElement(scroll_list_1.ScrollList, { ItemRenderer: board_assets_1.ItemRenderer, items: items, getId: board_assets_1.getId, itemCount: -1, loadMore: loadMore, loadingState: loadingState }));
    },
    environmentProps: {
        windowWidth: 884,
        canvasWidth: 400,
        windowHeight: 597,
    },
    plugins: [
        board_plugins_1.scenarioPlugin.use({
            title: 'should load more items when reaching end',
            events: [(0, board_plugins_1.hoverAction)('[data-id="a8"]'), (0, board_plugins_1.clickAction)('[data-id="a8"]'), (0, board_plugins_1.scrollAction)(-1), (0, board_plugins_1.scrollAction)(0)],
        }),
        board_plugins_1.projectThemesPlugin,
    ],
});
//# sourceMappingURL=infinite-scrolling.board.js.map