"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_board_1 = require("@wixc3/react-board");
const react_1 = __importDefault(require("react"));
const board_assets_1 = require("../../board-assets");
const board_plugins_1 = require("../../board-plugins");
const scroll_list_1 = require("../scroll-list");
const items = (0, board_assets_1.createItems)();
const elementRef = {
    current: null,
};
exports.default = (0, react_board_1.createBoard)({
    name: 'ScrollList — items change size',
    Board: () => (react_1.default.createElement(scroll_list_1.ScrollList, { ItemRenderer: board_assets_1.ExpandableItemRenderer, items: items, getId: board_assets_1.getId, listRoot: {
            el: 'div',
            props: {
                style: {
                    display: 'grid',
                    gridTemplateColumns: '1fr',
                },
            },
        }, scrollListRoot: {
            el: 'div',
            props: {
                style: {
                    width: '200px',
                    height: '400px',
                    overflow: 'auto',
                },
                ref: elementRef,
            },
        }, scrollWindow: elementRef })),
    environmentProps: {
        windowWidth: 500,
        canvasWidth: 400,
        windowHeight: 500,
    },
    plugins: [
        board_plugins_1.scenarioPlugin.use({
            title: 'should listen to item resize',
            events: [
                (0, board_plugins_1.clickAction)('[data-id="a0"] button'),
                (0, board_plugins_1.clickAction)('[data-id="a1"] button'),
                (0, board_plugins_1.clickAction)('[data-id="a2"] button'),
                (0, board_plugins_1.expectElement)('[data-id="a5"]'),
            ],
        }),
        board_plugins_1.projectThemesPlugin,
    ],
});
//# sourceMappingURL=items-change-size.board.js.map