"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_board_1 = require("@wixc3/react-board");
const react_1 = __importDefault(require("react"));
const board_assets_1 = require("../../board-assets");
const board_plugins_1 = require("../../board-plugins");
const scroll_list_1 = require("../scroll-list");
const items = (0, board_assets_1.createItems)();
exports.default = (0, react_board_1.createBoard)({
    name: 'ScrollList — items in row',
    Board: () => (react_1.default.createElement(scroll_list_1.ScrollList, { ItemRenderer: board_assets_1.ItemRenderer, items: items, getId: board_assets_1.getId, listRoot: {
            props: {
                style: {
                    display: 'grid',
                    gridTemplateColumns: '1fr 1fr 1fr',
                    gridGap: '50px',
                },
            },
        }, scrollListRoot: {
            props: {
                style: {
                    height: '100%',
                },
            },
        }, itemGap: 50, itemsInRow: 3 })),
    environmentProps: {
        windowWidth: 500,
        canvasWidth: 400,
        windowHeight: 500,
    },
    plugins: [
        board_plugins_1.scenarioPlugin.use({
            skip: true,
            events: [
                (0, board_plugins_1.hoverAction)('[data-id="a8"]'),
                (0, board_plugins_1.expectElementStyle)('[data-id="a8"]', {
                    color: 'rgb(0, 0, 255)',
                }),
                (0, board_plugins_1.hoverAction)('[data-id="a9"]'),
                (0, board_plugins_1.expectElementsStyle)({
                    '[data-id="a8"]': {
                        color: 'rgb(0, 0, 0)',
                    },
                    '[data-id="a9"]': {
                        color: 'rgb(0, 0, 255)',
                    },
                }),
                (0, board_plugins_1.clickAction)('[data-id="a9"]'),
                (0, board_plugins_1.expectElementStyle)('[data-id="a9"]', {
                    backgroundColor: 'rgb(0, 0, 255)',
                }),
                (0, board_plugins_1.clickAction)('[data-id="a11"]'),
                (0, board_plugins_1.scrollAction)(-1),
                (0, board_plugins_1.scrollAction)(0),
            ],
        }),
        board_plugins_1.projectThemesPlugin,
    ],
});
//# sourceMappingURL=items-in-row.board.js.map