"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_board_1 = require("@wixc3/react-board");
const react_1 = __importStar(require("react"));
const board_assets_1 = require("../../board-assets");
const board_plugins_1 = require("../../board-plugins");
const actions_1 = require("../../board-plugins/scenario-plugin/actions");
const scroll_list_1 = require("../scroll-list");
const items = (0, board_assets_1.createItems)();
const elementRef = {
    current: null,
};
const ItemRenderer = (props) => {
    return (react_1.default.createElement("div", { style: {
            height: '50px',
            display: 'flex',
            alignItems: 'center',
        }, "data-id": props.id },
        props.data.title,
        " ",
        props.isSelected && '(selected)'));
};
/**
 * Right now scrolling to selection is supported for finite lists that provide ref to scrollWindow.
 */
exports.default = (0, react_board_1.createBoard)({
    name: 'ScrollList — scroll to selected item',
    Board: () => {
        const initialSelectedIndex = 442;
        const [selectedItem, setSelectedItem] = (0, react_1.useState)(`a${initialSelectedIndex}`);
        const [input, setInput] = (0, react_1.useState)(initialSelectedIndex);
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("div", { style: {
                    position: 'sticky',
                    textAlign: 'right',
                    top: 0,
                    zIndex: 1,
                } },
                react_1.default.createElement("label", null,
                    "ID:",
                    react_1.default.createElement("input", { id: actions_1.selectItemInput, value: input, onChange: (event) => setInput(parseInt(event.target.value)) })),
                react_1.default.createElement("button", { id: actions_1.selectItemButton, onClick: () => setSelectedItem(`a${input}`) }, "Select")),
            react_1.default.createElement(scroll_list_1.ScrollList, { scrollWindow: elementRef, ItemRenderer: ItemRenderer, items: items, itemSize: () => 50, getId: board_assets_1.getId, selectionControl: [selectedItem, board_assets_1.noop], scrollToSelection: true, scrollListRoot: {
                    el: 'div',
                    props: {
                        id: 'list',
                        style: {
                            width: '200px',
                            height: '400px',
                            overflow: 'auto',
                        },
                        ref: elementRef,
                    },
                } })));
    },
    environmentProps: {
        canvasWidth: 500,
        windowHeight: 600,
        windowWidth: 600,
    },
    plugins: [
        board_plugins_1.scenarioPlugin.use({
            title: 'should scroll selected element into view',
            resetBoard: () => {
                window.scrollTo(0, 0);
            },
            events: [
                ...[0, 555, 341, 999, 823, 543, 0, 123, 942].flatMap((index) => [
                    (0, actions_1.selectItemByIndex)(index.toString()),
                    (0, actions_1.checkItemRenderState)(`a${index}`),
                ]),
            ],
        }),
        board_plugins_1.projectThemesPlugin,
    ],
});
//# sourceMappingURL=scroll-to-selection.board.js.map