"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var _a, _b;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScrollList = exports.ListOverlaySlot = exports.scrollListOverlayParent = exports.RootSlot = exports.scrollListRoot = exports.forwardScrollListRoot = void 0;
const react_1 = __importStar(require("react"));
const hooks_1 = require("../hooks");
const list_1 = require("../list/list");
const preloader_1 = require("../preloader/preloader");
const circle_preloader_st_css_1 = require("../preloader/variants/circle-preloader.st.css");
const helpers_1 = require("./helpers");
const hooks_2 = require("./hooks");
const scroll_list_st_css_1 = require("./scroll-list.st.css");
const defaultPreloader = {
    el: preloader_1.Preloader,
    props: {
        className: circle_preloader_st_css_1.classes.root,
    },
};
const ScrollListRootPropMapping = {
    style: hooks_1.mergeObjectInternalWins,
    className: hooks_1.concatClasses,
};
const { forward: forwardListRoot, slot: listRoot } = (0, list_1.listRootParent)(hooks_1.defaultRoot, ScrollListRootPropMapping);
const { Slot: PreloaderSlot } = (0, hooks_1.defineElementSlot)(defaultPreloader, {});
_a = (0, hooks_1.defineElementSlot)(hooks_1.defaultRoot, ScrollListRootPropMapping), exports.forwardScrollListRoot = _a.forward, exports.scrollListRoot = _a.slot, exports.RootSlot = _a.Slot;
_b = (0, hooks_1.defineElementSlot)(defaultPreloader, {}), exports.scrollListOverlayParent = _b.parentSlot, exports.ListOverlaySlot = _b.Slot;
const RELATIVE_POSITION = {
    position: 'relative', // non-static position so that overlay can be positioned absolutely in relation to it
};
function ScrollList({ items, isHorizontal = false, scrollWindow, itemCount, getId, ItemRenderer, estimatedItemSize, focusControl, loadMore, scrollOffset, itemSize = false, scrollListRoot, listRoot, selectionControl, scrollToSelection = false, extraRenderSize = 0.5, unmountItems, preloader, loadingState, itemGap = 0, itemsInRow = 1, transmitKeyPress, overlay, }) {
    var _a, _b;
    const defaultScrollListRef = (0, react_1.useRef)();
    const scrollListRef = ((_a = scrollListRoot === null || scrollListRoot === void 0 ? void 0 : scrollListRoot.props) === null || _a === void 0 ? void 0 : _a.ref) || defaultScrollListRef;
    const defaultListRef = (0, react_1.useRef)(null);
    const listRef = ((_b = listRoot === null || listRoot === void 0 ? void 0 : listRoot.props) === null || _b === void 0 ? void 0 : _b.ref) || defaultListRef;
    const scrollPosition = (0, hooks_1.useScroll)({
        isHorizontal,
        ref: scrollWindow,
    });
    const scrollWindowSize = (0, hooks_1.useElementSize)(scrollWindow, !isHorizontal);
    const mountedItems = (0, react_1.useRef)(new Set(''));
    const [selected, setSelected] = (0, hooks_1.useStateControls)(selectionControl, undefined);
    const [focused, setFocused] = (0, hooks_1.useStateControls)(focusControl, undefined);
    const getItemInfo = (0, react_1.useCallback)((data) => ({
        data,
        isFocused: focused === getId(data),
        isSelected: selected === getId(data),
    }), [getId, focused, selected]);
    const getItemDimensions = (0, react_1.useMemo)(() => {
        if (itemSize === false) {
            return itemSize;
        }
        if (typeof itemSize === 'number') {
            return {
                width: itemSize,
                height: itemSize,
            };
        }
        return (item) => {
            var _a;
            const itemInfo = getItemInfo(item);
            const dimension = (_a = itemSize(itemInfo)) !== null && _a !== void 0 ? _a : 0;
            return {
                width: dimension,
                height: dimension,
            };
        };
    }, [itemSize, getItemInfo]);
    const itemsDimensions = (0, hooks_1.useElementDimensions)(listRef, items, getId, getItemDimensions, true);
    const { itemsSizes, averageItemSize } = (0, helpers_1.getItemSizes)({
        itemsDimensions: itemsDimensions.current,
        isHorizontal,
        items,
        getId,
        estimatedItemSize,
    });
    const itemsNumber = itemCount === undefined ? items.length : itemCount === -1 ? items.length + 5000 : itemCount;
    const rowsNumbers = Math.ceil(itemsNumber / itemsInRow);
    const gapsNumber = Math.ceil((itemsNumber - 1) / itemsInRow);
    const maxScrollSize = averageItemSize * rowsNumbers + itemGap * gapsNumber;
    const { firstShownItemIndex, lastShownItemIndex, firstWantedPixel } = (0, hooks_2.useScrollListPosition)({
        items,
        getId,
        getItemInfo,
        maxScrollSize,
        itemSize,
        itemGap,
        itemsInRow,
        averageItemSize,
        isHorizontal,
        unmountItems,
        extraRenderSize,
        scrollWindowSize,
        itemsDimensions,
        scrollPosition,
        scrollOffset,
        scrollListRef,
    });
    (0, hooks_2.useLoadMoreOnScroll)({
        loadMore,
        loadingState,
        renderSize: scrollWindowSize * (1 + extraRenderSize),
        lastShownItemIndex,
        averageItemSize,
        loadedItemsNumber: items.length,
    });
    (0, hooks_2.useScrollListScrollToSelected)({
        scrollWindow,
        scrollListRef,
        scrollToSelection,
        items,
        getId,
        selected,
        averageItemSize,
        mountedItems,
        isHorizontal,
        extraRenderSize,
        scrollWindowSize,
        itemsDimensions,
    });
    const shownItems = (0, react_1.useMemo)(() => items.slice(firstShownItemIndex, lastShownItemIndex), [items, firstShownItemIndex, lastShownItemIndex]);
    const listStyle = {
        position: 'absolute',
        top: isHorizontal ? 0 : `${firstWantedPixel}px`,
        left: isHorizontal ? `${firstWantedPixel}px` : 0,
    };
    // TODO: causes re-rendering which I think is not needed
    const listRootWithStyle = forwardListRoot(listRoot || hooks_1.defaultRoot, {
        style: listStyle,
        ref: listRef,
    });
    const focusControlMemoized = (0, react_1.useMemo)(() => [focused, setFocused], [focused, setFocused]);
    const selectionControlMemoized = (0, react_1.useMemo)(() => [selected, setSelected], [selected, setSelected]);
    const onItemMount = (0, react_1.useCallback)((item) => mountedItems.current.add(getId(item)), [getId]);
    const onItemUnmount = (0, react_1.useCallback)((item) => mountedItems.current.delete(getId(item)), [getId]);
    return (react_1.default.createElement(exports.RootSlot, { slot: scrollListRoot, props: {
            className: scroll_list_st_css_1.classes.root,
            style: RELATIVE_POSITION,
            ref: scrollListRef,
        } },
        react_1.default.createElement(list_1.List, { items: shownItems, getId: getId, ItemRenderer: ItemRenderer, onItemMount: onItemMount, onItemUnmount: onItemUnmount, listRoot: listRootWithStyle, focusControl: focusControlMemoized, selectionControl: selectionControlMemoized, transmitKeyPress: transmitKeyPress }),
        overlay ? (react_1.default.createElement(exports.ListOverlaySlot, { slot: overlay, props: {
                itemSizes: itemsSizes,
                shownItems,
                avgSize: averageItemSize,
                style: {
                    ...listStyle,
                    width: '100%',
                    height: '100%',
                },
            } })) : null,
        react_1.default.createElement("div", { style: {
                height: `${maxScrollSize + 1}px`,
            } }, loadingState === 'loading' ? react_1.default.createElement(PreloaderSlot, { slot: preloader }) : null)));
}
exports.ScrollList = ScrollList;
//# sourceMappingURL=scroll-list.js.map