"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.formatErrorMessage=exports.NodeEnvironmentManager=void 0;const engine_electron_commons_1=require("@wixc3/engine-electron-commons"),engine_electron_host_1=require("@wixc3/engine-electron-host"),electron_1=require("electron"),universal_1=require("../universal");class NodeEnvironmentManager{constructor(n){this.communication=n,this.runningEnvironments=new Map,this.featureSetupOptions={},this.processCwd=void 0,this.startEnvironmentErrorHandler=void 0,this.environmentCrashHandler=void 0,this.registerIpcHandlerForStartEnvironmentRequests()}setFeatureSetupOptions(n){this.featureSetupOptions=n}setProcessCwd(n){this.processCwd=n}onStartEnvironmentError(n){this.startEnvironmentErrorHandler=n}onEnvironmentCrash(n){this.environmentCrashHandler=n}async disposeEnvironment(n){var e;const r=getEnvironmentName(n),t=null===(e=this.runningEnvironments.get(r))||void 0===e?void 0:e.dispose;this.runningEnvironments.delete(r),this.communication.clearEnvironment(r),await(null==t?void 0:t())}async disposeAllEnvironments(){const n=Array.from(this.runningEnvironments.values());return await Promise.allSettled(n.map((({environment:n})=>this.disposeEnvironment(n))))}async startEnvironment(n){var e;const r=getEnvironmentName(n.engineEnvironment);if(this.runningEnvironments.has(r))throw new Error("Cannot start another instance of already running environment");try{const e=await engine_electron_host_1.runtimeArgumentsProvider.getRuntimeArguments(),t=(0,engine_electron_commons_1.initializeNodeEnvironment)({env:n.engineEnvironment,environmentStartupOptions:{environmentContextName:n.engineEnvironmentContextName},communication:this.communication,runtimeArguments:{...e,runtimeOptions:Object.entries(this.featureSetupOptions)},processOptions:{cwd:this.processCwd}});let o=!1;t.onExit((({exitCode:n,signal:e,errorMessage:r})=>{var i;if(!o&&0!==n){const o=`The '${t.id}' environment quit unexpectedly.\nExit code: '${String(n)}', signal: '${String(e)}', details:\n\n`+formatErrorMessage(r);null===(i=this.environmentCrashHandler)||void 0===i||i.call(this,o)}}));const i=async()=>{o=!0,await t.dispose()};this.runningEnvironments.set(r,{environment:n.engineEnvironment,dispose:i}),await t.environmentIsReady}catch(n){throw null===(e=this.startEnvironmentErrorHandler)||void 0===e||e.call(this,n),n}}registerIpcHandlerForStartEnvironmentRequests(){electron_1.ipcMain.handle(universal_1.ipcChannels.startNodeEnv,((n,e)=>this.startEnvironment(e)))}}exports.NodeEnvironmentManager=NodeEnvironmentManager;const getEnvironmentName=n=>n.env,thrownErrorRegEx=/^(Error|TypeError|RangeError|ReferenceError|SyntaxError|\[UnhandledPromiseRejection).*/m;function formatErrorMessage(n){const e=n.match(thrownErrorRegEx);if(e){const[r]=e;return`${r}\n\n${n}`}return n}exports.formatErrorMessage=formatErrorMessage;