"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Resource=exports.ResourceSnapshot=void 0;const types_1=require("./types"),utils_1=require("./utils"),resource_manager_1=require("./resource-manager"),universal_1=require("@wixc3/editor-commons/universal");class ResourceSnapshot{constructor(e,s){this.ofVer=e,this.disposer=s,this.disposed=!1}dispose(){this.disposer(this),this.disposed=!0}isDisposed(){return this.disposed}}exports.ResourceSnapshot=ResourceSnapshot;class Resource{constructor(e,s,t){this.id=e,this.validateChange=t,this.ready=void 0,this.subscribers=new Set,this.disposeSubscribers=new Set,this.status={valid:!0},this.disposed=!1,this.base=void 0,this.changes=[],this.invertingChanges=[],this.projections={},this.snaps=new Set,this.lastProjection=void 0,this.batchStart=void 0,this._ready=!1,this.disposeCheckTimer=void 0,this.disposeSnap=e=>{if(!this.snaps.has(e))throw(0,utils_1.unknownVersionError)(e.ofVer,this.getSerializedId(),this.currentVersion);this.snaps.delete(e);const s=e.ofVer,t=[...this.snaps];!!t.find((e=>e.ofVer===s))||delete this.projections[s];const i=t.reduce(((e,s)=>Math.min(e,s.ofVer)),Number.MAX_SAFE_INTEGER),r=this.changes.findIndex((e=>e.version>i));if(r>0){const e=this.changes.splice(0,r),s=(e,s)=>{let t=e;for(const e of s)if((0,types_1.isFullChange)(e))t=e.value;else{const{value:s}=this.manipulator.reducer(t,e);t=s}return t};this.base={value:s(this.base.value,e.map((e=>e.change))),version:i}}},this.serializedId=(0,resource_manager_1.serializeId)(e),this.users=new Set,this.provider=s.provider,this.manipulator=s.manipulator||utils_1.fullChangeManipulator,this.batcher=s.batcher,this.resourceTypeId=s.resourceType,this.currentVersion=types_1.FIRST_VERSION,this.provider.dispose&&this.disposeSubscribers.add(this.provider.dispose);try{const s=this.provider.provide(e,this);(0,utils_1.isPromise)(s)?(this.ready=new Promise(((e,s)=>{this._resolveReady=e})),s.then((e=>{this.base={value:e.value,version:types_1.FIRST_VERSION},this.status=e.status||{valid:!0},this.lastProjection=e.value,this.triggerDisposeCheck(),this._ready=!0,this.ready=void 0,this._resolveReady(e.value)})).catch((e=>{console.error(e),this.invalidate(`Provider of resource type ${this.getType()} and id ${this.getSerializedId()} failed to provide value, reason: ${e}`),this.base=void 0,this._ready=!0,this.ready=void 0,this._resolveReady(void 0)}))):(this._ready=!0,this.base={value:s.value,version:types_1.FIRST_VERSION},this.lastProjection=s.value,this.status=s.status||{valid:!0})}catch(e){console.error(e),this.invalidate(`Provider of resource type ${this.getType()} id ${this.getSerializedId()} failed to provide value, error: ${e}`),this.base=void 0,this._ready=!0,this.ready=void 0}}getType(){return this.resourceTypeId}getId(){return this.id}getSerializedId(){return this.serializedId}getManipulator(){return this.manipulator}getCurrentVersion(){return this.currentVersion}isChanged(){return this.currentVersion!==types_1.FIRST_VERSION}getBatcher(){return this.batcher}createSnapshot(){const e=new ResourceSnapshot(this.currentVersion,this.disposeSnap);return this.snaps.add(e),this.projections[this.currentVersion]||(this.isReady()?this.projections[this.currentVersion]=this.isValid()?this.getLatest():void 0:this.ready.then((()=>{this.snaps.size&&(this.projections[this.currentVersion]=this.isValid()?this.getLatest():void 0)})).catch(universal_1.reportError)),e}isReady(){return this._ready}applyChange(e,s=!1){var t;return null===(t=this.validateChange)||void 0===t||t.call(this,e),this.applyChangeInternal(e,s)}applyChanges(e,s=!1){this.batcher.batchIfNeeded((()=>{for(const t of e)this.applyChange(t,s)}))}applyChangeInternal(e,s=!1){if(this.disposed&&!s)throw(0,utils_1.disposedResourceError)(this.getType(),this.getSerializedId());if(!this.status.valid&&!s)throw(0,utils_1.invalidResourceError)(this.getType(),this.getSerializedId(),this.getInvalidationMessage());if(!this.isReady()&&!s)throw(0,utils_1.nonReadyResourceError)(this.getType(),this.getSerializedId());const t=void 0!==this.lastProjection?this.lastProjection:this.base.value,i=()=>{if(this.batcher.inAtomic){this.batcher.registerForBatch(this,this.getSerializedId(),this.resourceTypeId,!1);const e=this.getType(),s=this.getSerializedId();this.batcher.getAtomicSnapshot(e,s)||this.batcher.setAtomicSnapshot(e,s,this.createSnapshot())}this.batchStart||(this.batchStart=this.createSnapshot());const s=this.applyChangesInternal(t,[e]),i=this.wrapWithVersion(this.changes,e)[0];this.currentVersion=i.version,this.changes.push(i),this.lastProjection=s,this.dispatchOrPend(!1)};if(void 0!==this.batcher.getRunningBatchId()&&this.batcher.isBatching())i();else{const e=this.batcher.runAtomic(i);if("failure"===e.status)throw e.error}}subscribe(e){this.subscribers.add(e)}subscribeToDispose(e){this.disposeSubscribers.add(e)}subscribeOnce(e){const s=t=>{this.subscribers.delete(s),e(t)};this.subscribers.add(s)}unsubscribe(e,s=!0){this.subscribers.delete(e),s&&this.triggerDisposeCheck()}unsubscribeAll(e=!0){this.subscribers=new Set([]),e&&this.triggerDisposeCheck()}async waitForValid(){if(!this.isValid()){const e=new Promise((e=>{const s=()=>{this.isValid()?e():this.subscribeOnce(s)};this.subscribeOnce(s)}));await e}}getProjection(e){return this.projections[e.ofVer]}getChangesBetweenVersion(e,s){return void 0===e?[]:this.getAnyChangesBetweenVersionInternal(this.changes,e.ofVer,s.ofVer)}getChangesFromVersion(e){return this.getAnyChangesBetweenVersionInternal(this.changes,e.ofVer,this.currentVersion)}getInvertingChangesBetweenVersion(e,s){return void 0===e?[]:this.getAnyChangesBetweenVersionInternal(this.invertingChanges,e.ofVer,s.ofVer).reverse()}getInvertingChangesFromVersion(e){return this.getAnyChangesBetweenVersionInternal(this.invertingChanges,e.ofVer,this.currentVersion).reverse()}getLatest(){if(!this.isReady())throw(0,utils_1.unknownResourceError)(this.getType(),this.getSerializedId());return this.lastProjection}getSavedChangeCount(){return this.changes.length}getSnapsCount(){return this.snaps.size}isDisposed(){return this.disposed}use(e){this.users.add(e)}release(e,s=!0){this.users.delete(e),s&&this.triggerDisposeCheck()}commit(e){this.clearBatchStart(),this.dispatchEvent({batchId:e})}revert(){if(this.batchStart){const e=this.projections[this.batchStart.ofVer];this.changes=this.changes.slice(0,this.changes.findIndex((e=>e.version===this.batchStart.ofVer))+1),this.lastProjection=e,this.currentVersion=this.batchStart.ofVer,this.clearBatchStart()}}clearBatchStart(){this.batchStart&&(this.batchStart.dispose(),this.batchStart=void 0)}onResourceDisposed(){}invalidate(e){this.setStatus({valid:!1,message:e})}restore(){this.setStatus({valid:!0})}isValid(){return this.status.valid}getInvalidationMessage(){return this.status.message}setStatus(e){return(e.valid!==this.status.valid||e.message!==this.status.message)&&(this.status=e,void 0!==this.batcher.getRunningBatchId()&&this.batcher.isBatching()?this.dispatchOrPend(!0):this.batcher.batchAll((()=>{this.dispatchOrPend(!0)})),!0)}getStatus(){return this.status}revertChanges(e){const s=this.changes.length-e.length,t=new Array(s+1);t[0]=(0,types_1.fullChange)(this.base.value);for(let e=0;e<s;e++)t[e+1]=this.changes[e].change;const i=this.getManipulator(),r=i.squasher?i.squasher(t):t;for(const e of r)this.applyChange(e);return 0!=r.length}dispatchEvent(e){const s={...e,serializedId:this.serializedId,id:this.id};for(const e of this.subscribers)e(s)}dispose(){void 0!==this.disposeCheckTimer&&(clearTimeout(this.disposeCheckTimer),this.disposeCheckTimer=void 0),this.subscribers.clear(),this.disposed=!0,this.batcher&&this.batcher.unregisterFromBatch(this,this.getSerializedId(),this.resourceTypeId);for(const e of this.disposeSubscribers)e(this);this.base=void 0,this.changes=[],this.invertingChanges=[]}triggerDisposeCheck(){void 0!==this.disposeCheckTimer&&clearTimeout(this.disposeCheckTimer),this.disposeCheckTimer=setTimeout((()=>{this.disposeCheckTimer=void 0,this.disposeIfUnused()}),10)}disposeIfUnused(){this.isDisposed()||0!==this.users.size||0!==this.subscribers.size||this.dispose()}getAnyChangesBetweenVersionInternal(e,s,t){const i=[];if(s>=t)return i;s=s===types_1.FIRST_VERSION?0:s+1,t+=1;for(let r=0;r<e.length;r++){const{version:h,change:a}=e[r];if(h>=s&&h<t&&i.push(a),h===t)break}return i}dispatchOrPend(e){this.batcher&&this.batcher.isBatching()?this.batcher.registerForBatch(this,this.getSerializedId(),this.resourceTypeId,e):this.dispatchEvent()}wrapWithVersion(e,...s){let t=e.length?e[e.length-1].version:this.currentVersion;return s.map((e=>(t++,{change:e,version:t})))}applyChangesInternal(e,s){let t=e;for(const e of s)if((0,types_1.isFullChange)(e)){const s=t;t=e.value,this.invertingChanges.push(...this.wrapWithVersion(this.invertingChanges,(0,types_1.fullChange)(s)))}else{const{value:s,invertingChanges:i}=this.manipulator.reducer(t,e);t=s,this.invertingChanges.push(...this.wrapWithVersion(this.invertingChanges,...i))}return t}}exports.Resource=Resource;