"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.GitService=void 0;const tslib_1=require("tslib"),path_1=require("@file-services/path"),universal_1=require("@wixc3/editor-commons/universal"),universal_2=require("../universal"),git_url_parse_1=tslib_1.__importDefault(require("git-url-parse")),utils_1=require("./utils"),universal_3=require("@wixc3/editor-commons/dist/universal"),promise_assist_1=require("promise-assist");class GitService extends universal_3.Disposable{constructor(t,e,i,s,a,r,n,o,c){super(),this.git=t,this.gitRepoStatusSyncer=s,this.gitEventEmitter=a,this.realPath=r,this.fsSyncer=n,this.fileAssetsResourceManager=o,this.projectPath=c,this.isInitialized=!1,this.gitRootFolder=void 0,this.gitRepoStatusResource=e.get(universal_2.GIT_REPO_STATUS_RESOURCE_ID,this),this.gitMergeStateResource=i.get(universal_2.GIT_MERGER_STATE_RESOURCE_ID,this),this.init().then((()=>{this.isInitialized=!0}))}async init(){this.gitRootFolder=await(0,utils_1.getGitRootFolder)(this.git,this.realPath)}async doDispose(){this.gitRepoStatusResource.release(this),this.gitMergeStateResource.release(this)}async getParsedRemoteOriginUrl(){const t=await this.git.getRemoteUrl();if(t)return(0,path_1.isAbsolute)(t)?parseLocalGitUrl(t):(0,git_url_parse_1.default)(t)}async getLogEntries(t){return(await this.git.raw(["log",`--format=${t}`])).trim()}undoLastCommit(){return this.git.raw(["reset","HEAD~"])}async undoChanges(t){const e=await this.forceStatusUpdate(),i=new Set(e.staged),s=t.filter((t=>i.has(t))).map((t=>(0,path_1.relative)(this.projectPath,t)));await this.git.raw(["reset","HEAD","-q",...s]);const a=t.map((t=>(0,path_1.relative)(this.projectPath,t))),r=new Set(this.filterFilesByStatus(e.filesMap,(({modificationStatus:t})=>t===universal_2.GitFileModificationStatus.Added))),n=[],o=[];for(const t of a)r.has(t)?n.push(t):o.push(t);n.length&&await this.cleanUntrackedPaths(n),o.length&&await this.git.raw(["checkout","-q",...o])}async revertAll(){await this.resetHard();const{filesMap:t}=await this.forceStatusUpdate(),e=this.getUntrackedGitPaths(t);await this.cleanUntrackedPaths(e)}async commitFiles(t,e){const i=e.map((t=>(0,path_1.relative)(this.projectPath,t))),{filesMap:s}=await this.forceStatusUpdate(),a=new Set(this.getUntrackedGitPaths(s)),r=i.filter((t=>a.has(t)));r.length&&await this.git.raw(["add","-A",...r]);try{return await this.git.commit(t,i)}catch(t){throw await this.git.raw(["reset","-q","HEAD",...r]),t}}async mergeFrom(t){const e=await this.git.merge([t]);this.gitMergeStateResource.applyPatch((t=>{t.lastMergeResult=e}))}async commitAll(t){const{filesMap:e}=await this.forceStatusUpdate(),i=this.getUntrackedGitPaths(e);try{return await this.git.raw(["add","-A",this.projectPath]),await this.git.commit(t)}catch(t){throw await this.git.raw(["reset","-q","HEAD",...i]),t}}async history({limit:t=50,skip:e}={}){const i={"--max-count":t.toString()};return e&&(i["--skip"]=e.toString()),this.git.log(i)}async createNewBranch(t){await this.git.raw(["checkout","-b",t]),this.gitEventEmitter.emit("createBranch",{branchName:t})}async switchBranch(t,e){this.fsSyncer.suspendAndAccumulateEvents();try{const i=["-q"];if(e){const e=await this.getTrackingLocalBranch(t);e?(await this.git.checkout(e,i),t=e):(i.push("--track"),await this.git.checkout(t,i),t=(await this.git.status()).current,this.gitEventEmitter.emit("createBranch",{branchName:t}))}else await this.git.checkout(t,i)}finally{await(0,promise_assist_1.sleep)(1e3),this.fsSyncer.resumeAndProcessAccumulatedEvents(),this.fileAssetsResourceManager.reEvaluateValue(this.projectPath)}return this.gitEventEmitter.emit("switchBranch",{branchName:t}),t}async getCurrentBranch(){return(await this.git.raw(["rev-parse","--abbrev-ref","HEAD"])).trim()}async pushCurrentBranch(){const t=await this.getCurrentBranch();await this.git.raw(["push","-u","origin",t])}async getTrackingBranch(t){return(await this.git.raw(["for-each-ref","--format","%(upstream:short)",`refs/heads/${t}`])).trim()||void 0}async forceStatusUpdate(){if(!this.gitRepoStatusResource.isValid())throw new Error(this.gitRepoStatusResource.getInvalidationMessage());await Promise.all([new Promise((t=>this.gitRepoStatusResource.subscribeOnce(t))),this.gitRepoStatusSyncer.updateStatus({force:!0})]);const t=this.gitRepoStatusResource.getLatest();if(null===t)throw new Error("GitRepoStatusResource is null after being updated, check GitRepoStatusResourceSyncer");return t}async getFileHeadContent(t){if(!this.gitRootFolder)throw new Error("Git root folder is not set");const e=(0,path_1.relative)(this.gitRootFolder,t);return this.git.show([`HEAD:${(0,universal_1.replaceWinSlashes)(e)}`])}async getPullRequestType(){const t=await this.getParsedRemoteOriginUrl();if(t)return"github.com"===t.resource?"PULL_REQUEST":await this.isGitlabInstanceDomain(t.resource)?"MERGE_REQUEST":void 0}async getNewPullRequestUrl(t){const e=await this.getParsedRemoteOriginUrl();if(!e)return;const i=e.resource,s=e.full_name,a=encodeURIComponent(t);return"github.com"===i?`https://github.com/${s}/compare/${a}?quick_pull=1`:await this.isGitlabInstanceDomain(i)?`https://${i}/${s}/-/merge_requests/new?merge_request%5Bsource_branch%5D=${a}`:void 0}isGitlabInstanceDomain(t){return Promise.resolve(t.includes("gitlab"))}async cleanUntrackedPaths(t){const e=groupByDir(t);await Promise.all(Object.values(e).map((t=>this.git.raw(["clean","-f","-q",...t]))))}async getTrackingLocalBranch(t){const e=(await this.git.raw(["for-each-ref","--format","%(refname:short)::%(upstream:short)","refs/heads"])).trim().split("\n");for(const i of e){const[e,s]=i.split("::");if(s===t)return e}}async resetHard(){await this.git.raw(["reset","HEAD","--hard","-q"])}getUntrackedGitPaths(t){return this.filterFilesByStatus(t,(t=>!t.tracked))}filterFilesByStatus(t,e){return Object.entries(t).filter((([,t])=>e(t))).map((([t])=>t)).map((t=>(0,path_1.relative)(this.projectPath,t)))}}function groupByDir(t){return t.reduce(((t,e)=>{const i=path_1.win32.dirname(e);return t[i]||(t[i]=new Set),t[i].add(e),t}),{})}function parseLocalGitUrl(t){const e=(0,path_1.basename)(t),i=(0,path_1.dirname)(t);return{name:e,href:t,full_name:t,owner:i,protocol:"file",protocols:["file"],organization:i,resource:"",user:"",pathname:"",hash:"",search:"",token:"",source:"",port:0,ref:"",filepathtype:"",filepath:""}}exports.GitService=GitService;