"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.GitSyncRepoService=void 0;const constants_1=require("../universal/constants"),universal_1=require("@wixc3/git-commands-feature/universal"),universal_2=require("@wixc3/editor-commons/dist/universal");class GitSyncRepoService extends universal_2.Disposable{constructor(t,e,s,i,r,n){super(),this.git=t,this.gitService=e,this.gitFetcher=s,this.gitEventEmitter=r,this.trackingBranchManager=n,this.handleFetchStart=()=>{this.syncRepoResource.startFetching()},this.handleFetchEnd=()=>{this.syncRepoResource.doneFetching()},this.handleFetchFailed=()=>{this.syncRepoResource.fetchingFailed()},this.syncRepoResource=i.get(constants_1.GIT_SYNC_REPO_RESOURCE_ID,this),this.disposables.add((()=>this.syncRepoResource.release(this)))}init(){this.disposalGuard(),this.gitEventEmitter.on("fetchStart",this.handleFetchStart),this.gitEventEmitter.on("fetchEnd",this.handleFetchEnd),this.gitEventEmitter.on("fetchFailed",this.handleFetchFailed),this.disposables.add((()=>{this.gitEventEmitter.off("fetchStart",this.handleFetchStart),this.gitEventEmitter.off("fetchEnd",this.handleFetchEnd),this.gitEventEmitter.off("fetchFailed",this.handleFetchFailed)}))}async syncRepo(){this.disposalGuard();const{ahead:t,behind:e,filesMap:s}=await this.gitService.forceStatusUpdate();if(Object.keys(s).length)throw new Error("Cannot sync repo while having uncommitted changes");if(e&&!this.isDisposed){const{status:t}=await this.pull();if("conflict"===t)return t}t&&!this.isDisposed&&await this.push()}async pull(){this.disposalGuard(),this.syncRepoResource.startPulling();try{await this.git.pull(),this.gitEventEmitter.emit("pull",void 0);const{conflicted:t}=await this.gitService.forceStatusUpdate();if(t.length)return{status:"conflict"}}catch(t){throw(0,universal_1.isGitHttpsAuthError)(t)?t:new Error(constants_1.PULL_FAILED)}finally{this.syncRepoResource.donePulling()}return{status:"done"}}async push(){this.disposalGuard(),this.syncRepoResource.startPushing();try{await this.git.push()}catch(t){throw(0,universal_1.isGitHttpsAuthError)(t)?t:new Error(constants_1.PUSH_FAILED)}finally{this.syncRepoResource.donePushing(),await this.gitService.forceStatusUpdate()}}async fetch(){this.disposalGuard();try{await this.gitFetcher.fetch()}catch(t){throw(0,universal_1.isGitHttpsAuthError)(t)?t:new Error(constants_1.FETCH_FAILED)}}async pushCurrentBranch(){this.disposalGuard(),this.syncRepoResource.startPushing();try{await this.gitService.pushCurrentBranch()}catch(t){throw(0,universal_1.isGitHttpsAuthError)(t)?t:new Error(constants_1.PUSH_FAILED)}finally{this.syncRepoResource.donePushing()}this.isDisposed||this.trackingBranchManager.reEvaluateValue(constants_1.GIT_TRACKING_BRANCH_RESOURCE_ID)}}exports.GitSyncRepoService=GitSyncRepoService;