"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.NewComponentService=void 0;const universal_1=require("@wixc3/editor-commons/universal"),universal_2=require("@wixc3/project-feature/universal"),universal_3=require("@wixc3/simulation-capabilities-feature/universal"),universal_4=require("../universal"),constants_1=require("./constants"),template_registry_1=require("./templates/template-registry");class NewComponentService{constructor(e,t,r,s,o,n){this.idService=e,this.simulationListManager=t,this.rawConfig=r,this.fs=s,this.simulationProcessingService=o,this.projectPath=n}async createComponent(e){const{componentName:t,templateId:r,componentDir:s,simulationName:o,simulationPath:n}=e,a=this.getConfig();if(a.status===universal_4.ResultStatus.Error)return{status:a.status,errors:a.errors};const i=this.validateDataForComponentCreation(e);if(i)return{status:universal_4.ResultStatus.Error,errors:i};const l=this.getTemplate(r,t,a.data.fileNamingConvention);if(!l)throw new Error(universal_4.newComponentErrorMessages[universal_4.ErrorCode.TemplateNotFound]);const u=this.toAbsolutePath(s),m=this.fs.join(u,l.getComponentFileName()),v=this.toAbsolutePath(n),d=l.getComponentExportName(),{writeFileSync:c,ensureDirectorySync:p}=this.fs;p(u);const g=this.waitForBoardListResourceUpdate();for(const e of l.getFiles()){c(this.fs.join(u,e.name),e.contents)}return this.simulationProcessingService.createBoard({name:o,filePath:v,componentRef:(0,universal_3.getComponentRef)(m,d)}),await g,{status:universal_4.ResultStatus.Success,data:{componentExportName:d,componentPath:m,simulationPath:v}}}getInitialDataForDialog(){const e=this.getConfig();if(e.status===universal_4.ResultStatus.Error)return e;const t=this.createTemplateRegistry(),r=this.projectPath,s=constants_1.defaultComponentName,o=t.getTemplateDetails(),n=o[0].id,a=this.suggestDataForDialog(s,n);return a.status===universal_4.ResultStatus.Error?a:{status:universal_4.ResultStatus.Success,data:{componentName:s,templateList:o,projectPath:r,templateId:n,...a.data}}}suggestDataForDialog(e,t,r){var s,o;const n=this.getConfig();if(n.status===universal_4.ResultStatus.Error)return n;const a=n.data,{fs:i,projectPath:l}=this,{fileNamingConvention:u}=a,m=i.join(l,a.newComponent.componentsPath),v=null!==(o=null===(s=this.getTemplate(t,e,u))||void 0===s?void 0:s.getFileNames())&&void 0!==o?o:[],d=(0,universal_1.toNamingConvention)(e,u),c=i.join(m,d),{boardName:p,boardPath:g}=this.simulationProcessingService.suggestNameAndPathForBoardWithComponent(c,e,r);return{status:universal_4.ResultStatus.Success,data:{componentFiles:v,componentDir:i.relative(l,c),simulationName:p,simulationPath:i.relative(l,g)}}}getConfig(){var e;const{rawConfig:t}=this;if(!(0,universal_1.isRecord)(t)||!(0,universal_1.isRecord)(t.newComponent))return{status:universal_4.ResultStatus.Error,errors:{config:{code:universal_4.ErrorCode.ConfigComponentsPathNotSpecified,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.ConfigComponentsPathNotSpecified]}}};const{componentsPath:r,templatesPath:s}=t.newComponent,o=Object.keys(t.newComponent).filter((e=>!(0,universal_4.isNewComponentConfigOption)(e))).map((e=>`"${e}"`));return o.length?{status:universal_4.ResultStatus.Error,errors:{config:{code:universal_4.ErrorCode.ConfigUnknownOptions,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.ConfigUnknownOptions](o.join(", "))}}}:void 0===r?{status:universal_4.ResultStatus.Error,errors:{config:{code:universal_4.ErrorCode.ConfigComponentsPathNotSpecified,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.ConfigComponentsPathNotSpecified]}}}:"string"==typeof r&&(0,universal_4.isSourcePathFormatValid)(r,this.fs.sep)?void 0===s||"string"==typeof s&&(0,universal_4.isSourcePathFormatValid)(s,this.fs.sep)?void 0===s||this.fs.directoryExistsSync(this.fs.join(this.projectPath,s))?void 0===t.fileNamingConvention||"string"==typeof t.fileNamingConvention&&(0,universal_1.isValidNamingConvention)(t.fileNamingConvention)?(0,universal_1.getPackagePath)(this.fs.join(this.projectPath,r),this.fs)?{status:universal_4.ResultStatus.Success,data:{newComponent:{componentsPath:r,templatesPath:s},fileNamingConvention:null!==(e=t.fileNamingConvention)&&void 0!==e?e:universal_2.defaultFileNamingConvention}}:{status:universal_4.ResultStatus.Error,errors:{config:{code:universal_4.ErrorCode.PackageJsonNotFound,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.PackageJsonNotFound]}}}:{status:universal_4.ResultStatus.Error,errors:{config:{code:universal_4.ErrorCode.ConfigFileNamingConventionIsInvalid,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.ConfigFileNamingConventionIsInvalid]}}}:{status:universal_4.ResultStatus.Error,errors:{config:{code:universal_4.ErrorCode.ConfigTemplatesPathDirNotFound,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.ConfigTemplatesPathDirNotFound](s)}}}:{status:universal_4.ResultStatus.Error,errors:{config:{code:universal_4.ErrorCode.ConfigTemplatesPathInvalidFormat,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.ConfigTemplatesPathInvalidFormat](String(s))}}}:{status:universal_4.ResultStatus.Error,errors:{config:{code:universal_4.ErrorCode.ConfigComponentsPathInvalidFormat,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.ConfigComponentsPathInvalidFormat](String(t.componentsPath))}}}}validateDataForComponentCreation(e){const{componentName:t,templateId:r,componentDir:s,simulationName:o,simulationPath:n}=e,a={...(0,universal_4.validateComponentName)(t),...this.validateTemplate(r),...this.validateComponentDir(s),...this.validateSimulationName(o),...this.validateSimulationPath(n)};return Object.keys(a).length?a:void 0}validateTemplate(e){const t=this.createTemplateRegistry().findTemplate(e);if(!t)return{templateId:{code:universal_4.ErrorCode.TemplateNotFound,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.TemplateNotFound]}};const r=t.validate();return r?{templateId:r}:void 0}validateComponentDir(e){if(!(0,universal_4.isSourcePathFormatValid)(e,this.fs.sep))return{componentDir:{code:universal_4.ErrorCode.ComponentDirInvalidFormat,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.ComponentDirInvalidFormat]}};const t=this.toAbsolutePath(e);if(!(0,universal_1.isSubPath)(t,this.projectPath,this.fs))return{componentDir:{code:universal_4.ErrorCode.ComponentDirOutOfProject,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.ComponentDirOutOfProject]}};const{directoryExistsSync:r,readdirSync:s}=this.fs;if(r(t)){const e=s(t),r=0===e.length,o=e.every((e=>e.startsWith(".")));if(!r&&!o)return{componentDir:{code:universal_4.ErrorCode.ComponentDirIsNotEmpty,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.ComponentDirIsNotEmpty]}}}}validateSimulationName(e){return e&&(0,universal_4.isSimulationNameValid)(e)?void 0:{simulationName:{code:universal_4.ErrorCode.BoardNameIsInvalid,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.BoardNameIsInvalid]}}}validateSimulationPath(e){if(!(0,universal_4.isSourcePathFormatValid)(e,this.fs.sep))return{simulationPath:{code:universal_4.ErrorCode.BoardPathInvalidFormat,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.BoardPathInvalidFormat]}};if(this.fs.basename(e)===universal_3.boardExtension)return{simulationPath:{code:universal_4.ErrorCode.BoardFileNameIsMissing,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.BoardFileNameIsMissing]}};const t=this.toAbsolutePath(e);return(0,universal_1.isSubPath)(t,this.projectPath,this.fs)?this.fs.existsSync(t)?{simulationPath:{code:universal_4.ErrorCode.BoardAlreadyExists,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.BoardAlreadyExists]}}:void 0:{simulationPath:{code:universal_4.ErrorCode.BoardFileOutOfProject,message:universal_4.newComponentErrorMessages[universal_4.ErrorCode.BoardFileOutOfProject]}}}toAbsolutePath(e){return this.fs.isAbsolute(e)?e:this.fs.join(this.projectPath,e)}getTemplate(e,t,r){const s=this.createTemplateRegistry().findTemplate(e);if(s)return s.setComponentName(t),s.setFileNamingConvention(r),s}waitForBoardListResourceUpdate(){return new Promise((e=>{const t=this.simulationListManager.get("");t.isValid()&&t.subscribeOnce((()=>e()))}))}createTemplateRegistry(){const e=this.getConfig();if(e.status===universal_4.ResultStatus.Error)throw new Error("Config is not valid");const t=new template_registry_1.TemplateRegistry(this.fs,this.idService),{templatesPath:r}=e.data.newComponent;return r&&t.setTemplatesPath(this.fs.join(this.projectPath,r)),t}}exports.NewComponentService=NewComponentService;