"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const tslib_1=require("tslib"),react_1=tslib_1.__importDefault(require("react")),lodash_debounce_1=tslib_1.__importDefault(require("lodash.debounce")),path_1=require("@file-services/path"),feature_1=require("@wixc3/react-renderer-feature/feature"),file_extensions_1=require("../universal/file-extensions"),main_1=require("@wixc3/editor-commons/main"),universal_1=require("@wixc3/editor-commons/universal"),main_2=require("@wixc3/notifications-feature/main"),feature_2=require("@wixc3/project-feature/feature"),main_3=require("../main"),project_ui_feature_1=tslib_1.__importDefault(require("./project-ui.feature")),panel_storage_1=require("../main/services/panel-storage"),delete_confirmation_1=require("../main/components/delete-confirmation/delete-confirmation"),undo_redo_1=require("../main/components/undo-redo/undo-redo"),universal_2=require("../universal"),content_1=require("../universal/content"),file_icon_context_1=require("../main/services/file-icon-context"),file_type_icon_1=require("../universal/file-type-icon"),create_open_file_1=require("../main/utils/create-open-file"),new_fs_item_dialog_1=require("../main/components/new-fs-item-dialog/new-fs-item-dialog"),analytics_1=require("../universal/analytics"),DELETE_FILE_CONFIRMATION_PANEL_TYPE="deleteFile";function getInvalidConfigFileNotificationProps(e="",t){return{id:"invalidConfigToastId",type:"error",text:content_1.notifications.invalidWcsConfigFile.title(e),dismissButton:!0,autoDismiss:!1,button:{text:content_1.notifications.invalidWcsConfigFile.buttonText,onClick:t}}}function registerContextMenuActions({contextMenuSlot:e,projectService:t,panelStore:i,copyPasteManager:n,openFile:o,track:a}){e.register({id:"copy",icon:react_1.default.createElement(main_1.DuplicateSmallIcon,null),label:content_1.fileActions.copy,action:e=>n.setCopyPath(e),section:universal_2.ContextMenuSections.Main,test:(e,t,i)=>t||i}),e.register({id:"cut",icon:react_1.default.createElement(main_1.CutoutIcon,null),label:content_1.fileActions.cut,section:universal_2.ContextMenuSections.Main,action:e=>n.setCopyPath(e,!0),test:()=>!0}),e.register({id:"paste",label:content_1.fileActions.paste,icon:react_1.default.createElement(main_1.PasteIcon,null),section:universal_2.ContextMenuSections.Main,action:e=>n.pasteCopied(e),test:()=>n.isPasteAvailable()}),e.register({id:"new_file",icon:react_1.default.createElement(main_1.AddFileIcon,null),label:content_1.fileActions.newFile,action:e=>{i.openOverlay({id:new_fs_item_dialog_1.NEW_FS_ITEM_DIALOG,panelType:new_fs_item_dialog_1.NEW_FS_ITEM_DIALOG,panelProps:{kind:"File",onCreate:async i=>{const{resolve:n}=(0,universal_1.isWindowsStyleAbsolutePath)(e)?path_1.win32:path_1.posix,r=n(e,i);await t.ensureFileExists(r),o(r,(()=>{a(analytics_1.FILE_OPEN_EVENT,(0,analytics_1.createFileOpenEventProps)(r,"file-explorer-right-click-menu-create-file"))}))},onClose:()=>i.closePanel(new_fs_item_dialog_1.NEW_FS_ITEM_DIALOG)}})},test:(e,t)=>t,section:universal_2.ContextMenuSections.New}),e.register({id:"new_folder",icon:react_1.default.createElement(main_1.NewFolderSmallIcon,null),label:content_1.fileActions.newFolder,action:e=>{i.openOverlay({id:new_fs_item_dialog_1.NEW_FS_ITEM_DIALOG,panelType:new_fs_item_dialog_1.NEW_FS_ITEM_DIALOG,panelProps:{kind:"Folder",onCreate:async i=>{const{resolve:n}=(0,universal_1.isWindowsStyleAbsolutePath)(e)?path_1.win32:path_1.posix,o=n(e,i);await t.addFolder(o)},onClose:()=>i.closePanel(new_fs_item_dialog_1.NEW_FS_ITEM_DIALOG)}})},test:(e,t)=>t,section:universal_2.ContextMenuSections.New}),e.register({id:"copy_relative_path",section:universal_2.ContextMenuSections.Clipboard,icon:react_1.default.createElement(main_1.DuplicateSmallIcon,null),label:content_1.fileActions.copyRelativePath,action:async e=>{const i=await t.getProjectPath();return navigator.clipboard.writeText((0,universal_1.replaceWinSlashes)(path_1.win32.relative(i,e)))},test:()=>!0}),e.register({id:"remove",label:content_1.fileActions.delete,section:universal_2.ContextMenuSections.Delete,icon:react_1.default.createElement(main_1.DeleteSmallIcon,null),action:e=>{i.openOverlay({id:"deleteFileConfirmation",panelType:DELETE_FILE_CONFIRMATION_PANEL_TYPE,panelProps:{onFileDelete:()=>t.removeEntity(e),onClose:()=>i.closePanel("deleteFileConfirmation"),filePath:e}})},test:(e,t,i)=>t||i})}project_ui_feature_1.default.setup(feature_1.mainEnv,(({run:e,onDispose:t,fileTreeConfig:{openedItems:i},openFileSlot:n,fileStylingSlot:o,fileStylingConfig:a,contextMenuSlot:r,decorationIconsSlot:l,openFilesConfig:s,fileIconSlot:c,renderFileIconConfig:_},{analytics:{analyticsService:{track:u}},project:{projectService:f,directoryManagerMain:d,fileManagerMain:p,undoRedoService:m,pluggableProjectConfigMain:g},gui:{sidebarPanelSlot:E,panelStore:y,panelFactory:F,overlayPanelFactory:P,router:S,headerPanelSlot:v,contextSlot:I},notifications:{toastBarStackResource:w},storage:{sessionStorageService:T}})=>{o.setSortingOrder(a),c.setSortingOrder(_);const b={},C=e=>{b[e.extension]={...e}};c.subscribe(C);const x={getFileIconByFilePath:e=>(0,file_type_icon_1.getFileIcon)({filePath:e,extensions:b}),getFileIconByTreeItem:e=>(0,file_type_icon_1.getFileIconByTreeItem)({dataItem:e,extensions:b})};I.register({context:file_icon_context_1.FileIconContext,value:x.getFileIconByFilePath});for(const[e,t]of Object.entries(file_extensions_1.fileExtensions))c.register({Icon:t,extension:e});const M=new main_3.FileTreeStore(d,f.getProjectPath,i),N=new main_3.CopyPasteManager(f),h=new main_3.SlotsProcessor(r,n,o,l,S,x),O=new main_3.OpenFilesService(s.targetAreaGroup,y,x),A=(0,create_open_file_1.createOpenFile)(n,S);v.register({id:universal_2.UNDO_REDO_BUTTONS_ID,Header:()=>react_1.default.createElement(undo_redo_1.UndoRedoContainer,{undoRedoService:m}),alignment:"right"}),registerContextMenuActions({contextMenuSlot:r,projectService:f,copyPasteManager:N,openFile:A,panelStore:y,track:u});const D=async(e,t)=>{const i=await f.changeBaseName(e,t);for(const{test:t,panelFactoryType:o}of n.values())if(t(e)){O.renameFileTab({panelFactoryType:o,props:{filePath:i},oldFileName:e});break}};E.register({id:universal_2.FILE_EXPLORER_TYPE,title:content_1.title,factory:()=>react_1.default.createElement(main_3.FileExplorer,{getProjectName:f.getProjectName,onFileRename:D,onNodeMove:f.moveEntity,copyPasteManager:N,fileTreeStore:M,onSelect:A,toggledItemsIds:i,slotsProcessor:h}),icon:react_1.default.createElement(main_1.ArticleIcon,null)}),l.register((0,main_3.initModifiedIconPlugin)(p)),o.register((0,main_3.initModifiedStylePlugin)(p)),P.register({id:DELETE_FILE_CONFIRMATION_PANEL_TYPE,factory:e=>react_1.default.createElement(delete_confirmation_1.DeleteConfirmation,{...e})}),P.register({id:new_fs_item_dialog_1.NEW_FS_ITEM_DIALOG,factory:e=>react_1.default.createElement(new_fs_item_dialog_1.NewFsItemDialog,{...e})}),n.stream(((e,{panelFactoryType:t,factory:i,area:n,tabTitle:o=path_1.win32.basename})=>{i&&F.register({id:t,factory:i,route:e=>{const{filePath:t,type:i}=e;if(!t||!i)throw new Error("Required query params missing");const a=x.getFileIconByFilePath(t);return{icon:a&&react_1.default.createElement(a,null),title:o(t),id:O.getPanelId(t,i),props:{filePath:t},area:n}}})}));return e((async()=>{await M.init();for(const{filePath:e,panelType:t}of s.openFiles)O.openFile({props:{filePath:e},panelFactoryType:t});const e=new panel_storage_1.PanelStorage(T,y,F,await f.getProjectPath());e.restore();const i=()=>e.store();y.subscribe(i);const n=await g.getReady(feature_2.PROJECT_CONFIG_NAME),o=(0,lodash_debounce_1.default)((()=>{(async e=>{const{valid:t,message:i}=e.getStatus(),n=await f.getProjectPath(),o=await f.join(n,feature_2.PROJECT_CONFIG_NAME);if(!await f.fileExists(o))return;if(t)return void(0,main_2.closeToastNotification)({toastBarStackResource:w,id:i});(0,main_2.openToastNotification)({toastBarStackResource:w,props:getInvalidConfigFileNotificationProps(i,(()=>A(o,(()=>u(analytics_1.FILE_OPEN_EVENT,(0,analytics_1.createFileOpenEventProps)(o,"toast-bar-config-notification"))))))})})(n)}),300);n.subscribe(o),o(),t((()=>{c.unSubscribe(C),y.unsubscribe(i),n.unsubscribe(o)}))})),{fileTreeStore:M,copyPasteManager:N,openFilesService:O,slotsProcessor:h,fileIconService:x}}));