"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.TextShadowLayerInput=exports.SingleShadowInput=exports.TextShadowLayerInputInner=exports.SingleShadowInputInner=exports.ShadowTypes=exports.DEFAULT_SHADOW_INPUT_COLOR=void 0;var ShadowTypes,tslib_1=require("tslib"),react_1=tslib_1.__importDefault(require("react")),stylable_panel_common_1=require("@wixc3/stylable-panel-common"),stylable_panel_components_1=require("@wixc3/stylable-panel-components"),stylable_panel_drivers_1=require("@wixc3/stylable-panel-drivers"),utils_1=require("../../../utils"),shadow_utils_1=require("../../../visualizer-factories/shadows-visualizer-factory/shadow-utils"),generated_visualizers_1=require("../../../generated-visualizers"),translate_1=require("../../../hosts/translate"),color_picker_1=require("../../../pickers/color-picker/color-picker"),single_shadow_input_st_css_1=require("./single-shadow-input.st.css");exports.DEFAULT_SHADOW_INPUT_COLOR="rgba(0,0,0,0.2)",function(e){e.OUTER_SHADOW="outerShadow",e.INNER_SHADOW="innerShadow"}(ShadowTypes=exports.ShadowTypes||(exports.ShadowTypes={}));var DEFAULT_SHADOW_ATTRIBUTES=stylable_panel_common_1.DIMENSION_INPUT_DEFAULTS.singleShadowInput;function toDegrees(e){return e*(180/Math.PI)}function toRadians(e){return e*Math.PI/180}function round(e,s){return s=Math.pow(10,s),Math.round(e*s)/s}var _a=stylable_panel_drivers_1.StylablePanelTranslationKeys.picker.shadow,innerShadowToggleSectionLabel=_a.innerShadowToggleSectionLabel,outerShadowToggleLabel=_a.outerShadowToggleLabel,innerShadowToggleLabel=_a.innerShadowToggleLabel,OUTER_SHADOW=ShadowTypes.OUTER_SHADOW,INNER_SHADOW=ShadowTypes.INNER_SHADOW,getToggleInsetControls=function(e,s,n){return[{id:OUTER_SHADOW,label:n(outerShadowToggleLabel),checked:!e,onChange:s},{id:INNER_SHADOW,label:n(innerShadowToggleLabel),checked:e,onChange:s}]};function ShadowInput(e){var s={angle:DEFAULT_SHADOW_ATTRIBUTES.angle.value,distance:DEFAULT_SHADOW_ATTRIBUTES.distance,spread:e?"":DEFAULT_SHADOW_ATTRIBUTES.spread,blur:DEFAULT_SHADOW_ATTRIBUTES.blur,color:exports.DEFAULT_SHADOW_INPUT_COLOR,inset:!1},n=function(n){function a(){var e,a=this;return(a=n.apply(this,tslib_1.__spreadArray([],tslib_1.__read(arguments),!1))||this).shadowValues=tslib_1.__assign({},s),a.value=a.props.value,a.shorthandApi=(0,utils_1.createShorthandOpenerApi)((null!==(e=a.props.drivers)&&void 0!==e?e:(0,utils_1.createDeclarationVisualizerDrivers)()).variables),a.changeColor=function(e,s){var n,t,l=a.props.siteVarsDriver,o=null!==(t=null===(n=null==l?void 0:l.evalDeclarationValue)||void 0===n?void 0:n.bind(l))&&void 0!==t?t:stylable_panel_drivers_1.DEFAULT_EVAL_DECLARATION_VALUE;a.shadowValues.color=o(e),a.callChange("color",s),a.forceUpdate()},a.changeInset=function(){a.shadowValues.inset=!a.shadowValues.inset,a.callChange(),a.forceUpdate()},a.changeAngle=function(e){var s=parseInt(e||"",10);isNaN(s)||(a.shadowValues.angle=toRadians((s+90)%360),a.callChange())},a.changeDistance=function(e){e&&void 0!==(0,stylable_panel_components_1.parseNumberUnit)(e).value&&(a.shadowValues.distance=e,a.callChange())},a.changeBlur=function(e){a.shadowValues.blur=e||DEFAULT_SHADOW_ATTRIBUTES.blur,a.callChange("blur-radius")},a.changeSpread=function(e){a.shadowValues.spread=e||DEFAULT_SHADOW_ATTRIBUTES.spread,a.callChange("spread-radius")},a}return tslib_1.__extends(a,n),a.prototype.render=function(){return react_1.default.createElement("div",{className:(0,single_shadow_input_st_css_1.style)(single_shadow_input_st_css_1.classes.root,this.props.className)},this.renderColorGroup(),react_1.default.createElement("div",{className:single_shadow_input_st_css_1.classes.longDivider}),e?null:this.renderInsetController(),e?null:react_1.default.createElement("div",{className:single_shadow_input_st_css_1.classes.longDivider}),this.renderDirectionController(),react_1.default.createElement("div",{className:single_shadow_input_st_css_1.classes.longDivider}),this.renderDistanceController(),react_1.default.createElement("div",{className:single_shadow_input_st_css_1.classes.longDivider}),this.renderBlurController(),e?null:react_1.default.createElement("div",{className:single_shadow_input_st_css_1.classes.longDivider}),e?null:this.renderSizeController())},a.prototype.componentWillMount=function(){this.setValues()},a.prototype.componentDidUpdate=function(){this.setValues()},a.prototype.getValueWithValidUnit=function(e){return e?"".concat(e.number).concat(e.unit):void 0},a.prototype.setValues=function(){var n,a,t,l;if(this.value&&""!==this.value&&this.shorthandApi){var o=this.props.siteVarsDriver,r=null!==(a=null===(n=null==o?void 0:o.evalDeclarationValue)||void 0===n?void 0:n.bind(o))&&void 0!==a?a:stylable_panel_drivers_1.DEFAULT_EVAL_DECLARATION_VALUE,i=(0,shadow_utils_1.parseShadow)(e?"text-shadow":"box-shadow",r(this.value),this.shorthandApi)[0],_=i["offset-x"].number,c=i["offset-y"].number,u=Math.round(Math.sqrt(_*_+c*c));this.shadowValues.distance=u+"px",0!==u&&(this.shadowValues.angle=Math.atan2(c,_)),this.shadowValues.blur=null!==(t=this.getValueWithValidUnit(i["blur-radius"]))&&void 0!==t?t:DEFAULT_SHADOW_ATTRIBUTES.blur,this.shadowValues.spread=e?"":null!==(l=this.getValueWithValidUnit(i["spread-radius"]))&&void 0!==l?l:DEFAULT_SHADOW_ATTRIBUTES.spread,this.shadowValues.color=i.color,this.shadowValues.inset=!!i.inset}else this.shadowValues=tslib_1.__assign({},s)},a.prototype.getCssStringValue=function(){var s=(0,stylable_panel_components_1.parseNumberUnit)(this.shadowValues.distance),n=round(s.value*round(Math.cos(this.shadowValues.angle),5),2)+"px",a=round(s.value*round(Math.sin(this.shadowValues.angle),5),2)+"px",t=!isNaN(parseFloat(this.shadowValues.blur)),l=!e&&!isNaN(parseFloat(this.shadowValues.spread)),o="";l?o=t?this.shadowValues.blur+" ":"0 ":t&&(o=this.shadowValues.blur+" ");var r=l?this.shadowValues.spread+" ":"",i=""!==this.shadowValues.color&&void 0!==this.shadowValues.color?this.shadowValues.color:"";return"".concat(this.shadowValues.inset?"inset ":"").concat(n," ").concat(a," ").concat(o).concat(r).concat(i).trim()},a.prototype.renderColorGroup=function(){var e=this,s=(0,translate_1.getTranslate)(this.props.panelHost),n=this.shadowValues.color,a=!n||n===shadow_utils_1.EMPTY_COLOR;return react_1.default.createElement(stylable_panel_components_1.CompositeBlock,{className:single_shadow_input_st_css_1.classes.colorGroup,title:s(stylable_panel_drivers_1.StylablePanelTranslationKeys.picker.shadow.colorLabel),singleLine:!0},react_1.default.createElement(stylable_panel_components_1.BackgroundBox,{className:single_shadow_input_st_css_1.classes.colorBox,value:n,noColor:a,showNoColorDiagonal:!0,onClick:function(){return e.openColorPicker(a?shadow_utils_1.EMPTY_COLOR:n)}}))},a.prototype.renderInsetController=function(){var e=(0,translate_1.getTranslate)(this.props.panelHost);return react_1.default.createElement(stylable_panel_components_1.CompositeBlock,{className:single_shadow_input_st_css_1.classes.group,title:e(innerShadowToggleSectionLabel)},react_1.default.createElement(stylable_panel_components_1.RadioGroup,{className:single_shadow_input_st_css_1.classes.insetGroup,values:getToggleInsetControls(this.shadowValues.inset,this.changeInset,e)}))},a.prototype.renderDirectionController=function(){var e=this.props.panelHost,s=(0,translate_1.getTranslate)(e),n=this.getKnobAngle()+DEFAULT_SHADOW_ATTRIBUTES.angle.unit,a=(0,generated_visualizers_1.getDimensionConfig)({id:stylable_panel_common_1.DIMENSION_ID.SINGLE_SHADOW_DEGREES_RANGE,dimensionUnits:null==e?void 0:e.dimensionUnits,customUnits:stylable_panel_common_1.DEGREES_RANGE,dimensionKeywords:null==e?void 0:e.dimensionKeywords});return react_1.default.createElement(stylable_panel_components_1.CompositeBlock,{className:single_shadow_input_st_css_1.classes.group,title:s(stylable_panel_drivers_1.StylablePanelTranslationKeys.picker.shadow.directionInputLabel)},react_1.default.createElement(stylable_panel_components_1.DimensionInput,{className:single_shadow_input_st_css_1.classes.inputElementAngle,value:n,config:a,useDisplaySymbol:!0,isSlider:!0,isSliderCyclicKnob:!0,isInputCyclic:!0,onChange:this.changeAngle,showUnitErrors:null==e?void 0:e.showDimensionErrors,translate:s,translationKeys:stylable_panel_drivers_1.StylablePanelTranslationKeys.component.dimensionInput}))},a.prototype.renderDistanceController=function(){var e=this.props.panelHost,s=(0,translate_1.getTranslate)(e),n=(0,generated_visualizers_1.getDimensionConfig)({id:stylable_panel_common_1.DIMENSION_ID.SINGLE_SHADOW_DISTANCE,dimensionUnits:null==e?void 0:e.dimensionUnits,customUnits:stylable_panel_common_1.SINGLE_SHADOW_DISTANCE,dimensionKeywords:null==e?void 0:e.dimensionKeywords});return react_1.default.createElement(stylable_panel_components_1.CompositeBlock,{className:single_shadow_input_st_css_1.classes.group,title:s(stylable_panel_drivers_1.StylablePanelTranslationKeys.picker.shadow.distanceInputLabel)},react_1.default.createElement(stylable_panel_components_1.DimensionInput,{className:single_shadow_input_st_css_1.classes.inputElementDistance,value:this.shadowValues.distance,config:n,isSlider:!0,keepRange:!0,onChange:this.changeDistance,showUnitErrors:null==e?void 0:e.showDimensionErrors,translate:s,translationKeys:stylable_panel_drivers_1.StylablePanelTranslationKeys.component.dimensionInput}))},a.prototype.renderBlurController=function(){var e=this.props.panelHost,s=(0,translate_1.getTranslate)(e),n=(0,generated_visualizers_1.getDimensionConfig)({id:stylable_panel_common_1.DIMENSION_ID.SINGLE_SHADOW_BLUR,dimensionUnits:null==e?void 0:e.dimensionUnits,customUnits:stylable_panel_common_1.SINGLE_SHADOW_BLUR,dimensionKeywords:null==e?void 0:e.dimensionKeywords});return react_1.default.createElement(stylable_panel_components_1.CompositeBlock,{className:single_shadow_input_st_css_1.classes.group,title:s(stylable_panel_drivers_1.StylablePanelTranslationKeys.picker.shadow.blurInputLabel)},react_1.default.createElement(stylable_panel_components_1.DimensionInput,{className:single_shadow_input_st_css_1.classes.inputElementBlur,value:this.shadowValues.blur,config:n,isSlider:!0,keepRange:!0,onChange:this.changeBlur,showUnitErrors:null==e?void 0:e.showDimensionErrors,translate:s,translationKeys:stylable_panel_drivers_1.StylablePanelTranslationKeys.component.dimensionInput}))},a.prototype.renderSizeController=function(){var e=this.props.panelHost,s=(0,translate_1.getTranslate)(e),n=(0,generated_visualizers_1.getDimensionConfig)({id:stylable_panel_common_1.DIMENSION_ID.SINGLE_SHADOW_SPREAD,dimensionUnits:null==e?void 0:e.dimensionUnits,customUnits:stylable_panel_common_1.SINGLE_SHADOW_SPREAD,dimensionKeywords:null==e?void 0:e.dimensionKeywords});return react_1.default.createElement(stylable_panel_components_1.CompositeBlock,{className:single_shadow_input_st_css_1.classes.group,title:s(stylable_panel_drivers_1.StylablePanelTranslationKeys.picker.shadow.sizeInputLabel)},react_1.default.createElement(stylable_panel_components_1.DimensionInput,{className:single_shadow_input_st_css_1.classes.inputElementSpread,value:this.shadowValues.spread,config:n,isSlider:!0,keepRange:!0,onChange:this.changeSpread,showUnitErrors:null==e?void 0:e.showDimensionErrors,translate:s,translationKeys:stylable_panel_drivers_1.StylablePanelTranslationKeys.component.dimensionInput}))},a.prototype.openColorPicker=function(e){var s=this,n=this.props,a=n.drivers,t=n.siteVarsDriver,l=n.panelHost;if(null==l?void 0:l.onOpenPanel){var o=(0,translate_1.getTranslate)(l),r=tslib_1.__assign(tslib_1.__assign({className:single_shadow_input_st_css_1.classes.colorPicker,title:o(stylable_panel_drivers_1.StylablePanelTranslationKeys.controller.shadows.colorPickerTitle)},(0,color_picker_1.getColorPickerAPI)({currentColor:e,onChange:this.changeColor,onAstChange:this.changeColor,drivers:a})),{siteVarsDriver:t,panelHost:l,onHover:function(n){return s.changeColor(n||e)}});l.onOpenPanel(color_picker_1.ColorPicker.panelName,r)}},a.prototype.callChange=function(e,s){var n=this.getCssStringValue();this.value=n,this.props.onChange(n,e,s)},a.prototype.getKnobAngle=function(){return((toDegrees(this.shadowValues.angle)+270)%360).toFixed(0)},a.panelName=e?"textShadow":"boxShadow",a}(react_1.default.Component);return n}exports.SingleShadowInputInner=ShadowInput(!1),exports.TextShadowLayerInputInner=ShadowInput(!0),exports.SingleShadowInput=(0,stylable_panel_components_1.OptimisticWrapper)(exports.SingleShadowInputInner,{onMouseDown:function(e){e.setActive()},onMouseUp:function(e){e.setIdle()},onChange:function(e){for(var s=[],n=1;n<arguments.length;n++)s[n-1]=arguments[n];e.onChange.apply(e,tslib_1.__spreadArray([],tslib_1.__read(s),!1))}}),exports.TextShadowLayerInput=(0,stylable_panel_components_1.OptimisticWrapper)(exports.TextShadowLayerInputInner,{});