"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.ListViewStateController=void 0;const list_view_types_1=require("./list-view-types"),sui_utils_1=require("@wixc3/sui-utils"),list_view_search_1=require("./list-view-search");class ListViewStateController{constructor(t){this.listView=t,this.isDirty=!1;const{selectionStartId:e,currentNavigatableItemId:i,selectedIds:s,disabledIds:r,typeAheadValue:n}=t.getListViewState();this.originalState=this.currentState={selectionStartId:null!==e||t.isNotSupportingSelection()?e:i,currentNavigatableItemId:i,selectedIds:s,disabledIds:r,typeAheadValue:n}}setCurrentState(t){this.currentState=t,this.isDirty=!0}getCurrentState(){return this.currentState}hasCurrentChanged(){return this.originalState.currentNavigatableItemId!==this.currentState.currentNavigatableItemId}hasStateChanged(){if(this.isDirty){const{disabledIds:t,selectedIds:e,currentNavigatableItemId:i,selectionStartId:s,typeAheadValue:r}=this.originalState,{disabledIds:n,selectedIds:a,currentNavigatableItemId:l,selectionStartId:c,typeAheadValue:d}=this.currentState;return d!==r||c!==s||l!==i||!(0,sui_utils_1.arrayEqual)(a,e)||!(0,sui_utils_1.arrayEqual)(n,t)}return!1}moveNext(){const t=this.currentState,e=t.currentNavigatableItemId;if(null!==e){const i=this.getNextNavigatableItemId(e);null!==i&&this.setCurrentState({...t,currentNavigatableItemId:i})}return this}movePrev(){const t=this.currentState,e=t.currentNavigatableItemId;if(null!==e){const i=this.getPrevEnabledItemId(e);null!=i&&this.setCurrentState({...t,currentNavigatableItemId:i})}return this}isItemEnabled(t){const e=this.listView.getListViewItemById(t);if(e&&(!0===e.isDisabled||!0===e.isExcluded))return!1;const i=this.currentState.disabledIds;return null===i||!i.includes(t)}isSelectable(t){const e=this.listView.getListViewItemById(t);return!!e&&this.isSelectableDataSourceItem(e)}isSelectableDataSourceItem(t){return(0,list_view_types_1.listViewDataItemIsSelectable)(t)&&!t.isExcluded}isNavigatableDataSourceItem(t){return!t.isExcluded&&!t.isDisabled}isSelected(t){const e=this.currentState.selectedIds;return null!==e&&e.includes(t)}canNavigateToItem(t){const e=this.listView.getListViewItemById(t);return!!e&&this.isNavigatableDataSourceItem(e)&&this.isItemEnabled(t)}canSelectItem(t){return this.isSelectable(t)&&this.isItemEnabled(t)}moveToItem(t){return this.setCurrentItemId(t)}setCurrentItemId(t){return this.getCurrentItemId()!==t&&this.canNavigateToItem(t)&&this.setCurrentState({...this.currentState,currentNavigatableItemId:t}),this}setSelectionStartId(t){return this.isItemEnabled(t)&&this.setCurrentState({...this.currentState,selectionStartId:t}),this}resolveNextFocusedItemByTypeAheadText(t,e){if(e){const i=this.getNavigationScopeItemsIds(),s=i.length,r=(0,sui_utils_1.arrayFindIndex)(i,(e=>e===t));let n;const a=this.listView.getTypeAheadStrategy();if(null===a)throw new Error("TypeAhead Navigation not supported");const l=a.typeAheadNavigationType;if(l===list_view_types_1.TypeAheadNavigationType.GoToNext&&1===e.length)n=r>=0?(r+1)%s:0;else{if(!(l===list_view_types_1.TypeAheadNavigationType.StayOnCurrent||l===list_view_types_1.TypeAheadNavigationType.GoToNext&&e.length>1))throw new Error("Not supported type ahead navigation type");n=r>=0?r:0}for(let t=0,r=n;t<s;t++,r=(r+1)%s){const t=i[r],s=this.listView.getListViewItemById(t),n=s.typeAheadText;if(n&&n.toLowerCase().startsWith(e.toLowerCase()))return s.id}}return null}getNextNavigatableItemId(t){const e=this.getNavigationScopeItemsIds(),i=e.indexOf(t);if(i>=0){let t=i;return t++,t>=e.length&&(t=this.listView.isCyclic()?0:e.length-1),e[t]}return null}getPrevEnabledItemId(t){const e=this.getNavigationScopeItemsIds(),i=e.indexOf(t);if(i>=0){let t=i;return t--,t<0&&(t=this.listView.isCyclic()?e.length+t:0),e[t]}return null}getSelectableItemsIds(){const t=new Set(this.currentState.disabledIds);return this.getListViewItemsArray().filter((e=>this.isSelectableDataSourceItem(e)&&!t.has(e.id))).map((t=>t.id))}getNavigatableItems(){const t=new Set(this.currentState.disabledIds);return this.getListViewItemsArray().filter((e=>this.isNavigatableDataSourceItem(e)&&!t.has(e.id)))}getNavigationScopeItemsIds(){return this.reduceToItemsInNavigationScope(this.getNavigatableItems()).map((t=>t.id))}reduceToItemsInNavigationScope(t){const{searchMatchingFunction:e,searchText:i,navigationScopeReducingBySearchStrategy:s}=this.listView.props;if(i&&e&&s!==list_view_search_1.NavigationScopeReducingBySearchStrategy.NeverReduce){const r=t.filter((t=>e(i,t)));switch(s){case list_view_search_1.NavigationScopeReducingBySearchStrategy.ReduceAlways:return r;case list_view_search_1.NavigationScopeReducingBySearchStrategy.ReduceOnlyWhenHasMatches:return r.length>0?r:t;case list_view_search_1.NavigationScopeReducingBySearchStrategy.ReduceOnlyWhenHasMultipleMatches:return r.length>1?r:t}}return t}getListViewItemsArray(){return this.listView.getListViewItemsArray()}getItemIndex(t){return this.listView.findItemIndex(t)}getItemsInRange(t,e,i){const{selectableOnly:s=!1,enabledOnly:r=!0,reduceNavigationScopeByTypeAheadText:n=!0}=i;if(null===t&&null===e)return[];null===t?t=e:null===e&&(e=t);const a=this.getItemIndex(t),l=this.getItemIndex(e),c=Math.min(a,l),d=Math.max(a,l);let u=this.getListViewItemsArray().slice(c,d+1);return(s||r)&&(u=u.filter((t=>(!s||(0,list_view_types_1.listViewDataItemIsSelectable)(t))&&(!r||!this.isItemDisabled(t.id))))),n&&(u=this.reduceToItemsInNavigationScope(u)),u.map((t=>t.id))}addItemsInRangeToSelection(t,e){this.assertMultiple();const i=this.currentState;let{selectedIds:s}=i;s=s||[];const r=this.getItemsInRange(t,e,{selectableOnly:!0,enabledOnly:!0}),n=new Set(r);for(let t=0;t<s.length;t++){const e=s[t];n.has(e)||r.push(e)}return this.setCurrentState({...i,selectedIds:r}),this}toggleItemSelection(t){this.assertSelectionSupported();const e=this.listView;return this.isSelected(t)?this.removeItemFromSelection(t):e.isMultiSelection()?this.addItemToSelection(t):e.isSingleSelection()&&this.selectItem(t),this}selectItemsInRange(t,e){this.assertMultiple();const i=this.getItemsInRange(t,e,{selectableOnly:!0,enabledOnly:!0});return this.setCurrentState({...this.currentState,selectedIds:i}),this}removeItemFromSelection(t){this.assertSelectionSupported();const e=this.currentState,{selectedIds:i,selectionStartId:s}=e,r=this.isSelected(t);let n=i||[];const a=n.indexOf(t);return r&&(n=(0,sui_utils_1.arrayClone)(n),n.splice(a,1)),this.setCurrentState({...e,selectionStartId:this.isItemEnabled(t)?t:s,selectedIds:n}),this}handleInteractiveSelection(t,e){const i=this.listView,s=i.props.keymapController,r=s.isCtrlKey(e),n=s.isShiftKey(e);this.isItemEnabled(t)&&(null===this.getCurrentItemId()&&this.setCurrentItemId(this.getNavigationScopeItemsIds()[0]),null===this.getSelectionStartId()&&i.isSupportingSelection()&&this.setSelectionStartId(this.getCurrentItemId()),r&&n?i.isMultiSelection()?this.addItemsInRangeToSelection(this.getSelectionStartId(),t):i.isSingleSelection()&&this.selectItem(t):n?i.isMultiSelection()?this.selectItemsInRange(this.getSelectionStartId(),t):i.isSingleSelection()&&this.selectItem(t):r?i.isNotSupportingSelection()||this.toggleItemSelection(t):i.isNotSupportingSelection()||this.selectItem(t),this.setCurrentItemId(t))}selectItem(t){this.assertSelectionSupported();const e=this.currentState,{selectionStartId:i}=e,s=this.canSelectItem(t);return this.setCurrentState({...e,selectionStartId:this.isItemEnabled(t)?t:i,selectedIds:s?[t]:[]}),this}clearSelection(){return this.setCurrentState({...this.currentState,selectionStartId:null,selectedIds:[]}),this}clearCurrentItem(){return this.setCurrentState({...this.currentState,currentNavigatableItemId:null,selectionStartId:null}),this}disableItem(t){const e=this.currentState,{disabledIds:i}=e,s=this.isSelected(t);let r=i||[];this.isItemEnabled(t)&&(r=(0,sui_utils_1.arrayClone)(r),r.push(t)),this.listView.isSupportingSelection()&&s&&this.removeItemFromSelection(t);const n=this.currentState;let a=n.selectionStartId;a===t&&(a=null);let l=n.currentNavigatableItemId;return l===t&&(l=null),this.setCurrentState({...n,selectionStartId:a,currentNavigatableItemId:l,disabledIds:r}),this}enableItem(t){const e=this.currentState,{disabledIds:i}=e,s=!this.isItemEnabled(t);let r=i||[];const n=r.indexOf(t);return s&&(r=(0,sui_utils_1.arrayClone)(r),r.splice(n,1)),this.setCurrentState({...e,disabledIds:r}),this}toggleItemDisabled(t){return this.isItemEnabled(t)?this.disableItem(t):this.enableItem(t),this}isItemDisabled(t){return!this.isItemEnabled(t)}addItemToSelection(t){this.assertMultiple();const e=this.currentState,{selectedIds:i,selectionStartId:s}=e,r=this.isSelected(t),n=this.canSelectItem(t);let a=i||[];return!r&&n&&(a=(0,sui_utils_1.arrayClone)(a),a.push(t)),this.setCurrentState({...e,selectionStartId:this.isItemEnabled(t)?t:s,selectedIds:a}),this}setTypeAheadValue(t){const e=this.currentState;return this.setCurrentState({...e,typeAheadValue:t}),this}navigateToItemBasedOnCurrentTypeAhead(t){const e=this.currentState.typeAheadValue;return null!==e&&this.navigateToItemBasedOnTypeAhead(e,t),this}navigateToItemBasedOnTypeAhead(t,e){const i=this.getCurrentItemId();if(null!==i){const s=this.resolveNextFocusedItemByTypeAheadText(i,t);if(null!=s)e&&this.listView.isSupportingSelection()&&this.selectItem(s),this.setCurrentState({...this.currentState,currentNavigatableItemId:s});else if(2===t.length){if(this.listView.getTypeAheadStrategy().typeAheadNavigationType===list_view_types_1.TypeAheadNavigationType.GoToNext){const i=t.slice(1,2);this.setTypeAheadValue(i),this.navigateToItemBasedOnCurrentTypeAhead(e)}}}return this}moveToNextSearchMatchingItem(t,e){const{searchMatchingFunction:i,selectionType:s}=this.listView.props;if(void 0===e&&(e=s!==list_view_types_1.ListViewSelectionType.None),i){const s=this.getNavigatableItems(),r=this.getCurrentItemId(),n=null!==r?(0,sui_utils_1.arrayFindIndex)(s,(t=>t.id===r)):-1,a=(0,sui_utils_1.arrayFindValue)(s,(e=>i(t,e)),-1===n?0:n,!0);if(a){const t=a.id;this.setCurrentItemId(t),e&&this.selectItem(t)}}}getSelectionStartId(){return this.currentState.selectionStartId}getCurrentItemId(){return this.currentState.currentNavigatableItemId}assertMultiple(){if(!this.listView.isMultiSelection())throw new Error("Supported Only In Multiple Selection")}assertSelectionSupported(){if(this.listView.isNotSupportingSelection())throw new Error("Supported Only In List View With Selection")}}exports.ListViewStateController=ListViewStateController;