"use strict";var __importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.SchemaBuilder=exports.defaultSettings=void 0;const typescript_1=__importDefault(require("typescript")),typescript_schema_core_1=require("@wixc3/typescript-schema-core"),type_to_schema_1=require("./type-to-schema"),module_to_schema_1=require("./module-to-schema"),utils_1=require("./utils"),schema_blob_1=require("./schema-blob"),get_inlined_schema_1=require("./get-inlined-schema");function overrideResolveGenericsAndIntersection(e,t,s){return e.settings.useResolvedSchemasForGenerics===t&&e.settings.resolveIntersection===s?e:Object.assign(Object.assign({},e),{settings:Object.assign(Object.assign({},e.settings),{useResolvedSchemasForGenerics:t,resolveIntersection:s})})}exports.defaultSettings={useResolvedSchemasForGenerics:!1,followOtherFiles:!1,analysisMaxDepth:30,schemaMaxDepth:30,includePropertiesOfOtherFiles:!0,resolveIntersection:!1,genericTypeResolutionPredicate:()=>!0,adjustFilePath:e=>e};class SchemaBuilder{constructor(e,t={},s=!1){this.program=e,this.ignoreSymbolErrors=s,this.settings=Object.assign(Object.assign({},exports.defaultSettings),t),this.env=this.resetEnv(),this.ignoreSymbolErrors=s}getProgram(){return this.program}setProgram(e){this.program=e,this.resetEnv()}getSchemas(e,t,s=this.settings.useResolvedSchemasForGenerics,i=this.settings.resolveIntersection){var r,n,o,c;const l=overrideResolveGenericsAndIntersection(this.env,s,i);l.fileName=this.settings.adjustFilePath(e),l.dependencies=new Set;const h=this.isSymbolExportedFromModule(e,t),a=(0,type_to_schema_1.getSchemas)(l,t,h),d={name:a.name,dependencies:[...l.dependencies]};return(null===(r=a.definition)||void 0===r?void 0:r.schema)&&(d.definition=null===(n=a.definition)||void 0===n?void 0:n.schema),(null===(o=a.property)||void 0===o?void 0:o.schema)&&(d.property=null===(c=a.property)||void 0===c?void 0:c.schema),d}getSchemasForAllSymbols(e,t=this.settings.useResolvedSchemasForGenerics,s=this.settings.resolveIntersection){return e.map((e=>this.getSchemas(e.filePath,e.symbol,t,s)))}getSchemasForAllSymbolsAsBlob(e,t=this.settings.useResolvedSchemasForGenerics,s=this.settings.resolveIntersection){const i=e.map((e=>this.getSchemasNonInlined(e.filePath,e.symbol,t,s)));return(0,schema_blob_1.createSymbolSchemaBlob)(this.env,i,t,s)}getTypeSchema(e,t,s=this.settings.useResolvedSchemasForGenerics,i=this.settings.resolveIntersection){const r=overrideResolveGenericsAndIntersection(this.env,s,i);r.fileName=this.settings.adjustFilePath(e);const n=this.isSymbolExportedFromModule(e,t),o=(0,type_to_schema_1.describeSchemaForSymbol)(r,t,!1,n);if(o)return o.schema}getSchemaForTsType(e,t,s=this.settings.useResolvedSchemasForGenerics,i=this.settings.resolveIntersection){const r=overrideResolveGenericsAndIntersection(this.env,s,i);r.fileName=this.settings.adjustFilePath(e);const n=(0,type_to_schema_1.describeSchemaForType)(r,t);return(0,get_inlined_schema_1.getInlinedSchema)(r,n,s,i)}getValueSchema(e,t,s=this.settings.useResolvedSchemasForGenerics,i=this.settings.resolveIntersection){const r=overrideResolveGenericsAndIntersection(this.env,s,i);r.fileName=this.settings.adjustFilePath(e);const n=this.isSymbolExportedFromModule(e,t),o=(0,type_to_schema_1.describeSchemaForSymbol)(r,t,!0,n);if(o)return o.schema}getSchemasForAllTsTypes(e,t=this.settings.useResolvedSchemasForGenerics,s=this.settings.resolveIntersection){const i=overrideResolveGenericsAndIntersection(this.env,t,s);return e.map((({filePath:e,type:r})=>{i.fileName=this.settings.adjustFilePath(e);const n=(0,type_to_schema_1.describeSchemaForType)(i,r),o=(0,get_inlined_schema_1.getInlinedSchema)(i,n,t,s);if((0,typescript_schema_core_1.isRefSchema)(o)){const e=i.referenceToSchemaMap[o.$ref];if(e)return(0,get_inlined_schema_1.getInlinedSchema)(i,e,!0,!0)}return o}))}getSchemasForAllTsTypesAsBlob(e,t=this.settings.useResolvedSchemasForGenerics,s=this.settings.resolveIntersection){const i=overrideResolveGenericsAndIntersection(this.env,t,s),r=e.map((({filePath:e,type:t})=>{i.fileName=this.settings.adjustFilePath(e);return(0,type_to_schema_1.describeSchemaForType)(i,t)}));return(0,schema_blob_1.createSchemaBlob)(i,r,t,s,{useResolvedSchemas:!0,resolveIntersection:!0,getSchemaByReference:e=>{var t,s;const[r,n]=e.split("#"),o=!(n.startsWith("/definitions")||n.startsWith("/exportedDefinitions")),c=n.startsWith("/exportedProperties")||n.startsWith("/exportedDefinitions");i.fileName=this.settings.adjustFilePath(r);const l=this.getSymbolByReference(e);if(!l){if(this.ignoreSymbolErrors)return;throw new Error(`Can't get a symbol for the reference ${e}`)}const h=(0,type_to_schema_1.getSchemasNonInlined)(i,l,c);return o?null===(t=null==h?void 0:h.property)||void 0===t?void 0:t.typeIdReference:null===(s=null==h?void 0:h.definition)||void 0===s?void 0:s.typeIdReference}})}getModuleSchema(e,t=this.settings.useResolvedSchemasForGenerics,s=this.settings.resolveIntersection){const i=overrideResolveGenericsAndIntersection(this.env,t,s);i.fileName=this.settings.adjustFilePath(e),i.dependencies=new Set;const r=this.program.getSourceFile(e);if(!r)throw`Can't get source file for ${e}`;return(0,module_to_schema_1.getModuleSchema)(i,r)}getSymbolSchemasByReference(e,t=this.settings.useResolvedSchemasForGenerics,s=this.settings.resolveIntersection){const i=this.getSymbolByReference(e);if(!i){if(this.ignoreSymbolErrors)return;throw new Error(`Can't get a symbol for the reference ${e}`)}const[r]=e.split("#");return this.getSchemas(r,i,t,s)}getSchemaByReference(e,t=this.settings.useResolvedSchemasForGenerics,s=this.settings.resolveIntersection){var i,r;const n=this.getSymbolSchemasByReference(e,t,s),[,o]=e.split("#");return(null==n?void 0:n.definition)&&(o.startsWith("/definitions")||o.startsWith("/exportedDefinitions"))?{schema:null==n?void 0:n.definition,dependencies:null!==(i=null==n?void 0:n.dependencies)&&void 0!==i?i:[]}:(null==n?void 0:n.property)&&(o.startsWith("/properties")||o.startsWith("/exportedProperties"))?{schema:null==n?void 0:n.property,dependencies:null!==(r=null==n?void 0:n.dependencies)&&void 0!==r?r:[]}:void 0}invalidateCache(){this.resetEnv()}exportSchemaCache(){return(0,utils_1.mapEnvToCacheEnv)(this.env)}static getSchemaFromCacheEnv(e,t,s,i){return(0,utils_1.getSchemaFromCacheEnv)(e,t,s,i)}resetEnv(){return this.env=(0,utils_1.createEmptyEnv)(this.program.getTypeChecker(),"",this.settings),this.env}isSymbolExportedFromModule(e,t){const s=this.program.getTypeChecker(),i=this.program.getSourceFile(e);if(i){const e=s.getSymbolAtLocation(i);if(e&&e.exports){return t===e.exports.get(t.name)}}return!1}getSymbolByReference(e){var t,s,i;const r=(0,utils_1.getRefInfo)(e);if(!r){if(this.ignoreSymbolErrors)return;throw new Error(`Invalid reference ${e}`)}const{filePath:n,section:o,qualifiedNameParents:c,name:l}=r,h=this.program.getSourceFile(n);if(!h)throw new Error(`Can't get a source file for the file ${n}`);const a=this.env.typeChecker.getSymbolAtLocation(h),d="exportedDefinitions"===o||"exportedProperties"===o,m=c;let u=h.locals;if(d&&(u=null==a?void 0:a.exports),m.length>1&&"__global"===m[0]){const e=this.env.typeChecker.getSymbolsInScope(h,typescript_1.default.SymbolFlags.NamespaceModule);m.shift();const s=m.shift();u=null===(t=e.find((e=>e.getName()===s)))||void 0===t?void 0:t.exports}if(!u){if(this.ignoreSymbolErrors)return;throw new Error(`Symbol not found ${e}`)}for(;m.length;){const t=m.shift(),r=u.get(t);if(u=null!==(s=null==r?void 0:r.exports)&&void 0!==s?s:null===(i=null==r?void 0:r.exportSymbol)||void 0===i?void 0:i.exports,!u){if(this.ignoreSymbolErrors)return;throw new Error(`Symbol not found ${e}`)}}const p=u.get(l);if(!p){if(this.ignoreSymbolErrors)return;throw new Error(`Symbol not found ${e}`)}return p}getSchemasNonInlined(e,t,s=this.settings.useResolvedSchemasForGenerics,i=this.settings.resolveIntersection){var r,n,o,c;const l=overrideResolveGenericsAndIntersection(this.env,s,i);l.fileName=this.settings.adjustFilePath(e),l.dependencies=new Set;const h=this.isSymbolExportedFromModule(e,t),a=(0,type_to_schema_1.getSchemasNonInlined)(l,t,h),d={name:a.name,dependencies:[...l.dependencies]};return(null===(r=a.definition)||void 0===r?void 0:r.typeIdReference)&&(d.definition=null===(n=a.definition)||void 0===n?void 0:n.typeIdReference),(null===(o=a.property)||void 0===o?void 0:o.typeIdReference)&&(d.property=null===(c=a.property)||void 0===c?void 0:c.typeIdReference),d}}exports.SchemaBuilder=SchemaBuilder;